SystemOrganization addCategory: #'Path-Tests-CallTree'!
SystemOrganization addCategory: #'Path-Tests-Contracts'!
SystemOrganization addCategory: #'Path-Tests-Harvester'!
SystemOrganization addCategory: #'Path-Tests-Harvester-Sandbox'!
SystemOrganization addCategory: #'Path-Tests-Harvester-Types'!
SystemOrganization addCategory: #'Path-Tests-Harvester-ValueRanges'!
SystemOrganization addCategory: #'Path-Tests-Idioms'!
SystemOrganization addCategory: #'Path-Tests-MethodWrappers'!
SystemOrganization addCategory: #'Path-Tests-PathBrowser-Contracts'!
SystemOrganization addCategory: #'Path-Tests-PathBrowser-Core'!
SystemOrganization addCategory: #'Path-Tests-PathBrowser-Coverage'!
SystemOrganization addCategory: #'Path-Tests-PathFinder'!
SystemOrganization addCategory: #'Path-Tests-PathMap'!
SystemOrganization addCategory: #'Path-Tests-PathView'!
SystemOrganization addCategory: #'Path-Tests-PathView-Sandbox'!
SystemOrganization addCategory: #'Path-Tests-Projects'!
SystemOrganization addCategory: #'Path-Tests-Record-Replay'!
SystemOrganization addCategory: #'Path-Tests-Resources'!
SystemOrganization addCategory: #'Path-Tests-Sandbox'!
SystemOrganization addCategory: #'Path-Tests-Tracer'!

Error subclass: #STestResourceError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!STestResourceError commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!STestResourceError methodsFor: 'exceptionDescription' stamp: 'mp 7/16/2013 13:21:12.427'!
defaultAction

	self inform: 'Path tests cannot be run with multiple test suites in test runner.', 
	String cr, 
	'Please choose test suites individually or apply PathMap with the #path project.'.
	TestResource allSubclasses do: [:each | each reset].
	super defaultAction.! !

!STestResourceError methodsFor: 'printing' stamp: 'mp 5/24/2013 15:28:42.295'!
description
	^ 'Depending test resources. Stop running tests.'! !

TestCase subclass: #SBrowserTest
	instanceVariableNames: 'browser browserMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathBrowser-Core'!

!SBrowserTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SBrowserTest subclass: #SBrowserContractsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathBrowser-Contracts'!

!SBrowserContractsTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SBrowserContractsTest class methodsFor: 'accessing' stamp: 'mp 5/13/2013 10:40:28.236'!
resources
	^ Set 
		with: SProjectObserverTestResource 
		with: SPathMapBrowserContractsTestResource! !

!SBrowserContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 14:58:16.261'!
test01AddedContracts

	self assert: (SVisibleClock>>#initInFrame:) class = SContractWrapper.
	self assert: SVisibleClock organization invariantMethod notNil.! !

!SBrowserContractsTest methodsFor: 'testing' stamp: 'mp 3/27/2013 13:30:25.135'!
test02ShowInvariants
	self browser setClass: SVisibleClock selector: nil.
	self assert: self browser hasInvariants.
	self deny: self browser invariantsShown.
	self browser toggleInvariants.
	self assert: self browser invariantsShown.	
	self browser toggleInvariants.
	self deny: self browser invariantsShown.! !

!SBrowserContractsTest methodsFor: 'testing' stamp: 'mp 3/27/2013 13:31:54.013'!
test03ShowPreconditions
	self browser setClass: SVisibleClock selector: #initInFrame:.
	self assert: self browser hasConditions.
	self deny: self browser preconditionsShown.
	self browser togglePreconditions.
	self assert: self browser preconditionsShown.	
	self browser togglePreconditions.
	self deny: self browser preconditionsShown.! !

!SBrowserContractsTest methodsFor: 'testing' stamp: 'mp 3/27/2013 13:32:34.797'!
test04ShowPostconditions
	self browser setClass: SVisibleClock selector: #initInFrame:.
	self assert: self browser hasConditions.
	self deny: self browser postconditionsShown.
	self browser togglePostconditions.
	self assert: self browser postconditionsShown.	
	self browser togglePostconditions.
	self deny: self browser postconditionsShown.! !

SBrowserTest subclass: #SBrowserCoverageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathBrowser-Coverage'!

!SBrowserCoverageTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SBrowserCoverageTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:52:11.759'!
resources
	^ Set 
		with: SProjectObserverTestResource 
		with: SPathMapTestQualityTestResource! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 3/26/2013 14:15:15.239'!
test01ShowAllCoveredTests
	self assert: self browser coverageList isEmpty.
	self browser setClass: Subject selector: #notify.
	self assert: self browser coverageList asArray = 
		{STestCaseEntryPoint class: TestDriver selector: #testRun}.! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 3/27/2013 15:03:56.484'!
test02aStartNewBrowserFromCoveredTest
	| newBrowser |
	[newBrowser := self browser 
		setClass: Subject selector: #notify;
		testMode: #openBrowserOn:;
		coverageListIndex: 1.
	self assert: newBrowser currentSelectedMethod = 
		(MethodReference class: TestDriver selector: #testRun)]
			ensure: [newBrowser ifNotNil: [newBrowser dependents first abandon]].! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 3/27/2013 15:06:28.371'!
test02bStartDebuggerFromCoveredTest
	self should: [self browser 
		setClass: Subject selector: #notify;
		testMode: #openDebuggerOn:;
		coverageListIndex: 1] raise: BreakPoint.! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:54:44.286'!
test02cStartPathFinderFromCoveredTest
	| pathFinder |
	[pathFinder := self browser 
		setClass: SAnalogClock selector: #draw;
		testMode: #openPathFinderOn:;
		coverageListIndex: 1.
	self assert: pathFinder notNil.
	self assert: pathFinder callTreeModel rootNode clientSelector = #testRun.
	self assert: pathFinder callTreeModel selectedItem clientClass = SAnalogClock.	
	self assert: pathFinder callTreeModel selectedItem clientSelector = #draw]
		ensure: [pathFinder ifNotNil: [pathFinder windowMorph abandon]].! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 5/24/2013 13:52:30.606'!
test03RefineCoverageAtStatements
	<timeout: 20>
	"test fails with coverage analysis because of context simulation"
	self assert: (self browser codePane text runs 
		select: [:each | each includes: TextEmphasis underlined]) size = 0.
	self browser 
		setClass: SAnalogClock selector: #draw;
		statementCoverage.
	self assert: (self browser codePane text runs 
		select: [:each | each includes: TextEmphasis underlined]) size > 200.! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 8/16/2013 09:59:02.625'!
test04aStateViewTracerInstanceVariable
	<timeout: 20>
	| result tracer |
	tracer := (SStateViewInstanceVariableTracer 
				onClass: ClockTimer instVarName: 'second') run.
	result := tracer valuesAsSet.
	self assert: result = #('0' '1').! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 8/16/2013 09:59:08.305'!
test04bStateViewTracerReceiver
	<timeout: 20>
	| result tracer |
	tracer := (SStateViewInstanceVariableTracer 
				onClass: Observer instVarName: nil) run.
	result := tracer valuesAsSet.
	self assert: result = #('a SAnalogClock' 'a SDigitalClock').! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 8/16/2013 09:41:59.531'!
test05GetArgumentsFromMethodReference
	| arguments |
	arguments := SBrowser new getArgumentsFrom: 
					(MethodReference class: SSBClassA selector: #myValue).
	self assert: arguments isEmpty.
	arguments := SBrowser new getArgumentsFrom: 
					(MethodReference class: SSBClassA selector: #param:method:).
	self 
		assert: arguments notEmpty;
		assert: arguments first = 'anObject';
		assert: arguments second = 'anotherObject'.! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 8/16/2013 09:50:03.302'!
test06aStateViewTracerMethodArgumentEmpty
	<timeout: 20>
	| result tracer |
	tracer := (SStateViewMethodTracer 
				onMethodReference: (MethodReference 
										class: ClockTimer selector: #second:) 
				argument: 1 
				tests: {STestCaseEntryPoint class: TestDriver selector: #testRun}) 
					run.
	result := tracer valuesAsSet.
	self assert: result = #().! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 8/16/2013 09:54:25.835'!
test06bStateViewTracerMethodArgumentWithValue
	<timeout: 20>
	| result tracer |
	tracer := (SStateViewMethodTracer 
				onMethodReference: (MethodReference class: Subject selector: #attach:) 
				argument: 1 
				tests: {STestCaseEntryPoint class: TestDriver selector: #testRun}) 
					run.
	result := tracer valuesAsSet.
	self assert: result = #('a SAnalogClock' 'a SDigitalClock').! !

!SBrowserCoverageTest methodsFor: 'testing' stamp: 'mp 8/16/2013 09:52:36.266'!
test06cStateViewTracerReturnValueOfMethod
<timeout: 20>
	| result tracer |
	tracer := (SStateViewMethodTracer 
				onMethodReference: (MethodReference class: ClockTimer selector: #second) 
				argument: nil
				tests: {STestCaseEntryPoint class: TestDriver selector: #testRun}) 
					run.
	result := tracer valuesAsSet.
	self assert: result = #('1').! !

!SBrowserTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:52:21.902'!
resources
	^ Set with: SProjectObserverTestResource! !

!SBrowserTest methodsFor: 'accessing' stamp: 'mp 3/26/2013 13:22:42.334'!
browser
	"Answer the value of browser"

	^ browser! !

!SBrowserTest methodsFor: 'accessing' stamp: 'mp 3/26/2013 13:22:42.358'!
browser: anObject
	"Set the value of browser"

	browser := anObject! !

!SBrowserTest methodsFor: 'accessing' stamp: 'mp 3/26/2013 13:24:56.738'!
browserMorph
	"Answer the value of browserMorph"

	^ browserMorph! !

!SBrowserTest methodsFor: 'accessing' stamp: 'mp 3/26/2013 13:24:56.758'!
browserMorph: anObject
	"Set the value of browserMorph"

	browserMorph := anObject! !

!SBrowserTest methodsFor: 'helper' stamp: 'mp 3/26/2013 13:48:43.705'!
existMorphOf: aClass named: aSymbol
	^ (self morphOf: aClass named: aSymbol) notNil! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 8/19/2013 15:26:38.263'!
expectedFailures
	^ #(test02BrowserCoverageAndConcernPane)! !

!SBrowserTest methodsFor: 'helper' stamp: 'mp 3/26/2013 13:48:27.098'!
morphOf: aClass named: aSymbol
	^ self browserMorph 
		findDeepSubmorphThat: [:morph | 
			morph class = aClass 
				and: [morph knownName = aSymbol 
					or: [(morph respondsTo: #label) and: [morph label = aSymbol]]]] 
		ifAbsent: [nil]! !

!SBrowserTest methodsFor: 'running' stamp: 'mp 3/26/2013 13:25:03.254'!
setUp
	super setUp.
	self browser: SBrowser open.
	self browserMorph: self browser dependents first.! !

!SBrowserTest methodsFor: 'running' stamp: 'mp 3/26/2013 13:25:17.323'!
tearDown
	super tearDown.
	self browserMorph abandon.! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 13:29:09.765'!
test01BrowserLabel
	self assert: self browserMorph label =  'PathBrowser'.! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 14:01:17.181'!
test02BrowserCoverageAndConcernPane
	self assert: (self existMorphOf: PluggableListMorphPlus named: #testCoverage).
	self assert: (self existMorphOf: PluggableTreeMorph named: #concernTree).	
		
! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 13:45:44.257'!
test03BrowserAdditionalButtons
	self assert: (self existMorphOf: PluggableButtonMorphPlus named: 'coverage').
	self assert: (self existMorphOf: PluggableButtonMorphPlus named: 'path views').! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 13:57:45.221'!
test04aBrowserContractButtonsInvariants
	self assert: (self existMorphOf: PluggableButtonMorphPlus named: 'post').
	self deny: self browser hasConditions.! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 13:57:42.388'!
test04bBrowserContractButtonsPreconditions
	self assert: (self existMorphOf: PluggableButtonMorphPlus named: 'post').
	self deny: self browser hasConditions.! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 13:57:36.484'!
test04cBrowserContractButtonsPostconditions
	self assert: (self existMorphOf: PluggableButtonMorphPlus named: 'post').
	self deny: self browser hasConditions.! !

!SBrowserTest methodsFor: 'testing' stamp: 'mp 3/26/2013 14:01:34.924'!
test05BrowserExtendedCodePane
	self assert: (self existMorphOf: SPluggableTextMorphPlus named: #codePane).! !

TestCase subclass: #SCallNodeTest
	instanceVariableNames: 'rootNode calledNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallNodeTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
calledNode
	"Answer the value of calledNode"

	^ calledNode! !

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
calledNode: anObject
	"Set the value of calledNode"

	calledNode := anObject! !

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
rootNode
	"Answer the value of rootNode"

	^ rootNode! !

!SCallNodeTest methodsFor: 'accessing' stamp: 'mp 3/9/2010 10:59'!
rootNode: anObject
	"Set the value of rootNode"

	rootNode := anObject! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:08:30.535'!
setUp

	| callTree |
	callTree := SCallTreeModel new.
	self rootNode: (SCallNode id: 0 class: SSBTest methodName: #testDoNothing fromSender: nil model: callTree receiverType: SSBTest callsBefore: 0).
	self calledNode: (SCallNode id: 1 class: SSBClassA methodName: #doNothing fromSender: self rootNode model: callTree receiverType: SSBClassA callsBefore: 0).! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:07'!
testAddCall

	self rootNode addCall: self calledNode.
	self assert: self rootNode nextCalls notEmpty.
	self assert: self rootNode nextCalls first == self calledNode.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:06'!
testFromRootSender

	self assert: self calledNode fromSender == self rootNode.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:11'!
testGetCallStackFromMultipleCalledNodes

	self rootNode addCall: self calledNode.
	self rootNode addCall: self calledNode.
	self rootNode addCall: self calledNode.
	self assert: self rootNode nextCalls size = 3.
	self assert: (self rootNode nextCalls second getCallStack = (OrderedCollection with: self rootNode with: self calledNode)).! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 3/9/2010 11:12'!
testGetCallStackFromRoot

	self assert: self rootNode getCallStack = (OrderedCollection with: self rootNode).! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:47.397'!
testInitializationRootNode

	self assert: self rootNode id = 0.
	self assert: self rootNode fromSender = nil.
	self assert: self rootNode nextCalls isEmpty.
	self assert: self rootNode selectedView = #classes.
	self assert: self rootNode selectedProfile = #normal.
	self assert: self rootNode views notEmpty.
	self assert: (self rootNode views at: #classes) = SSBTest.
	self assert: self rootNode profiles isEmpty.
	self assert: self rootNode clientSelector == #testDoNothing.
	self assert: self rootNode clientClass == SSBTest.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:49.541'!
testPrintProfile

	self rootNode selectedProfile: #%.
	self rootNode profiles at: #% put: '100%'.
	self assert: self rootNode asString =  '[100%]SSBTest>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:40:56.338'!
testPrintString

	self assert: self rootNode asString =  'SSBTest>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 4/24/2010 17:55'!
testPrintView

	self rootNode selectedView: #objects.
	self rootNode views at: #objects put: 'a Test'.
	self assert: self rootNode asString =  'a Test>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 4/24/2010 17:55'!
testPrintViewAndProfile

	self rootNode selectedView: #objects.
	self rootNode views at: #objects put: 'a Test'.
	self rootNode selectedProfile: #%.
	self rootNode profiles at: #% put: '100%'.
	self assert: self rootNode asString =  '[100%]a Test>>testDoNothing'.! !

!SCallNodeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:20:26.435'!
testSetAsCurrentSelection

	self assert: self rootNode callTreeModel selectedItem isNil.
	self rootNode setAsCurrentSelection.
	self assert: self rootNode callTreeModel selectedItem = self rootNode.! !

TestCase subclass: #SColorPropagationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SColorPropagationTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SColorPropagationTest methodsFor: 'testing' stamp: 'mp 8/14/2013 11:08:28.013'!
test01DominantColorStrategyForColors
	self assert: (SPMDominantColorStrategy forColors: {}) = nil.
	self assert: (SPMDominantColorStrategy 
					forColors: {Color red. Color green. Color yellow}) = Color red.
	self assert: (SPMDominantColorStrategy 
					forColors: {Color green. Color yellow}) = Color yellow.
	self assert: (SPMDominantColorStrategy 
					forColors: {Color green. Color blue}) = Color green.
	self assert: (SPMDominantColorStrategy forColors: {Color blue. Color magenta}) = nil.	! !

!SColorPropagationTest methodsFor: 'testing' stamp: 'mp 8/14/2013 11:51:58.96'!
test02HighestColorStrategyForColors
	self assert: (SPMHighestColorStrategy forColors: {}) = nil.
	self assert: (SPMHighestColorStrategy 
					forColors: {Color white. Color white.}) = Color white.
	self assert: (SPMHighestColorStrategy 
					forColors: {Color green. Color yellow}) = Color yellow.
	self assert: (SPMHighestColorStrategy 
					forColors: {Color green. Color blue}) = Color green.
		self assert: (SPMHighestColorStrategy 
					forColors: {Color green. Color blue. Color red}) = Color red.
	self assert: (SPMHighestColorStrategy forColors: {Color blue. Color magenta}) = Color blue.	
	self assert: (SPMHighestColorStrategy 
					forColors: {Color black. Color white. Color gray}) = Color gray.
	self assert: (SPMHighestColorStrategy 
					forColors: {(Color h: 10 s: 0.1 v: 0.5). (Color h: 100 s: 0.5 v: 1.0). (Color h: 200 s: 1.0 v: 0.1)}) = (Color h:  10.381231671554254 s: 1.0 v: 1.0).					! !

!SColorPropagationTest methodsFor: 'testing' stamp: 'mp 8/14/2013 11:57:00.758'!
test03PercentageColorStrategyForColors
	self assert: (SPMPercentageColorStrategy forColors: {}) = nil.
	self assert: (SPMPercentageColorStrategy 
					forColors: {Color white. Color white.}) = Color white.
	self assert: (SPMPercentageColorStrategy 
					forColors: {Color green. Color yellow}) = (Color r: 0.5 g: 1 b: 0.0).
	self assert: (SPMPercentageColorStrategy 
					forColors: {Color green. Color blue}) = Color cyan.
		self assert: (SPMPercentageColorStrategy 
					forColors: {Color green. Color blue. Color red}) = Color green.
	self assert: (SPMPercentageColorStrategy forColors: {Color blue. Color magenta}) =  (Color r: 0.5 g: 0.0 b: 1).	
	self assert: (SPMPercentageColorStrategy 
					forColors: {Color black. Color white. Color gray}) = Color gray.
	self assert: (SPMPercentageColorStrategy 
					forColors: {(Color h: 10 s: 0.1 v: 0.5). (Color h: 100 s: 0.5 v: 1.0). (Color h: 200 s: 1.0 v: 0.1)}) = (Color h: 103.35616438356165 s:  0.5347985347985348 v:  0.533724340175953).					! !

TestCase subclass: #SContractsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Contracts'!

!SContractsTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SContractsTest class methodsFor: 'accessing' stamp: 'mp 5/13/2013 10:40:50.362'!
resources
	^ Set 
		with: SProjectSandboxTestResource
		with: SPathMapInductiveContractsTestResource! !

!SContractsTest methodsFor: 'helper' stamp: 'mp 5/13/2013 10:58:59.155'!
addContracts
	SPathMapInductiveContractsTestResource current pathMap 
		model pathMap selectedOptions addContracts.! !

!SContractsTest methodsFor: 'accessing' stamp: 'mp 10/18/2013 14:53:44.966'!
defaultTimeout

	^ 20! !

!SContractsTest methodsFor: 'helper' stamp: 'mp 5/13/2013 10:59:24.693'!
removeContracts
	SPathMapInductiveContractsTestResource current pathMap 
		model pathMap selectedOptions removeContracts.! !

!SContractsTest methodsFor: 'running' stamp: 'mp 5/13/2013 10:58:13.18'!
setUp
	super setUp.
	self addContracts.! !

!SContractsTest methodsFor: 'running' stamp: 'mp 5/13/2013 10:58:24.12'!
tearDown
	super tearDown.
	self removeContracts.! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 14:58:19.789'!
test01aCreationOfEmptyPrecondition
	| source |
	self assert: (SSBClassA>>#printString) class = SContractWrapper.
	source := (SSBClassA>>#printString) beforeMethod getSource asString.
	self assert: source = 'printString
	<preconditions: #(#sandbox)>
	"Type Contracts"
	"Value Range Contracts"'	! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 14:58:21.085'!
test01bCreationOfEmptyPostcondition
	| source |
	self assert: (SSBClassA>>#printString) class = SContractWrapper.
	source := (SSBClassA>>#printString) afterMethod getSource asString.
	self assert: source = 'printString
	<postconditions: #(#sandbox)>'.! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/13/2013 11:37:01.428'!
test01cCreationOfEmptyInvariant
	| source |
	self assert: SSBClassC organization invariantGroups = #(#sandbox).
	source :=  SSBClassC organization invariantMethod getSource asString.
	self assert: source = 'SSBClassC
	<invariants: #(#sandbox)>
	"Type Contracts"
	"Value Range Contracts"'! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:03:27.617'!
test02aTypeAssertionInPrecondition
	| source |
	source := (SSBClassA>>#+) beforeMethod getSource asString.
	self assert: (source 
					includesSubString: 'SContract expect: aValue toBeKindOf: Number.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:12:28.614'!
test02bTypeAssertionInPostcondition
	| source |
	source := (SSBClassA>>#initialize) afterMethod getSource asString.
	self assert: (source includesSubString: 
		'SContract expect: (SContract result) toBeKindOf: SSBClassA.').
! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:03:30.908'!
test02cTypeAssertionInInvariant
	| source |
	source :=  SSBDictionary organization invariantMethod getSource asString.
	self assert: (source includesSubString: 
		'SContract expect: myValue toBeKindOf: SmallInteger.')
! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:03:35.169'!
test03ContainerTypeAssertions
	| source |
	source :=  (SSBDictionary>>#symbolFor:) beforeMethod getSource asString.
	self assert: (source includesSubString: 
		'SContract expect: squeakSymbol toBeKindOf: ByteSymbol.').
	self assert: (source includesSubString: 
		'SContract expectElementsOf: squeakSymbol toBeKindOf: Character.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:03:38.753'!
test04BooleanAssertions
	| source |
	source :=  (SSBClassD>>#myValue:) beforeMethod getSource asString.
	self assert: (source includesSubString: 'SContract expectNotNil: anObject.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:03:43.705'!
test05CharactersAssertions
	| source |
	source :=  (SSBClassD>>#myValue3:) beforeMethod getSource asString.
	self 
		assert: (source includesSubString: 'SContract expect: anObject ofType: Character property: #charCode isBetween: 252 and: 252.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Character isNot: #isDigit.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Character isNot: #isSeparator.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Character isNot: #isSpecial.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Character isNot: #isUppercase.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:03:46.999'!
test06CollectionsAssertions
	| source |
	source :=  (SSBClassD>>#myValue2:) beforeMethod getSource asString.
	self 
		assert: (source includesSubString: 'SContract expectSize: anObject ofType: Collection isLessThan: 3.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Collection isNot: #isEmpty.').	! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 7/29/2013 15:01:06.645'!
test07DateAndTimeAssertions
	| source |
	source :=  (SSBClassD>>#myValue2:) beforeMethod getSource asString.
	self 
		assert: (source includesSubString: 'SContract expect: anObject ofType: DateAndTime isBetween: DateAndTime now +');
		assert: (source includesSubString: 'SContract expect: anObject ofType: DateAndTime property: #timeZoneName includes: #(''Local Time'').');
		assert: (source includesSubString: 'SContract expect: anObject ofType: DateAndTime property: #dayOfWeekName includes: #(#');
		assert: (source includesSubString: DateAndTime yesterday dayOfWeekName asString);
		assert: (source includesSubString: DateAndTime today dayOfWeekName asString);
		assert: (source includesSubString: DateAndTime tomorrow dayOfWeekName asString).
	DateAndTime now isLeapYear
		ifFalse: [self assert: (source includesSubString: 'SContract expect: anObject ofType: DateAndTime isNot: #isLeapYear.')].	! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:04:05.844'!
test08DurationAssertions
	| source |
	source :=  (SSBClassD>>#myValue3:) beforeMethod getSource asString.
	self 
		assert: (source includesSubString: 'SContract expect: anObject ofType: Duration property: #rawSeconds isBetween: 0 and: 86400.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Duration property: #nanoSeconds isBetween: 0 and: 10000.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Duration isNot: #isZero.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:04:09.566'!
test09NumbersAssertions
	| source |
	source :=  (SSBClassD>>#myValue:) beforeMethod getSource asString.
	self assert: (source includesSubString: 'SContract expect: anObject ofType: Number isBetween: 0 and: 10.').
! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:04:13.146'!
test10StreamAssertions
	| source |
	source :=  (SSBClassD>>#myValue2:) beforeMethod getSource asString.
	self 
		assert: (source includesSubString: 'SContract expect: anObject ofType: Stream isNot: #closed.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: Stream property: #''contents class'' includes: {OrderedCollection . ByteString}.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:04:16.687'!
test11StringAssertions
	| source |
	source :=  (SSBClassD>>#myValue:) beforeMethod getSource asString.
	self 
		assert: (source includesSubString: 'SContract expectCorrectSpellingOf: anObject.');
		assert: (source includesSubString: 'SContract expectSize: anObject ofType: String isLessThan: 19.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: String is: #isAsciiString.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: String isNot: #isAllDigits.');
		assert: (source includesSubString: 'SContract expect: anObject ofType: String isNot: #isAllSeparators.').! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:01:08.165'!
test12aRaiseTypeContractViolation

	self shouldnt: [SSBClassA new + 5 = 5] runWithContracts raise: SContractViolation.
	self should: [[SSBClassA new + '5'] runWithContracts] raise: STypeContractViolation.
	[[SSBClassA new + '5'] runWithContracts] 
		on: STypeContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Type violation (Given: ByteString Expected: Number) precondition of aValue fails in SSBClassA +';
				assert: violation shortDescription = 'Pre in aValue: Type violation >> ByteString !!= Number'.].! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:01:10.731'!
test12bRaiseTypeContractViolation
	| d |
	d := SSBClassD new.
	d myValue: (Dictionary newFrom: {1->#abc}).
	self shouldnt: [d myValue] runWithContracts raise: SContractViolation.
	d myValue: (Dictionary newFrom: {#abc->#abc}).
	self should: [[d myValue] runWithContracts] raise: STypeContractViolation.
	d myValue: (Dictionary newFrom: {1->1}).
	self should: [[d myValue] runWithContracts] raise: STypeContractViolation.! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:01:28.867'!
test13RaiseSpellingContractViolation

	self shouldnt: [SSBClassD new myValue: 'correct'] runWithContracts 
		raise: SContractViolation.
	self should: [[SSBClassD new myValue: 'rwogn'] runWithContracts] 
		raise: SSpellingContractViolation.
	[[SSBClassD new myValue: 'rwogn'] runWithContracts] 
		on: SSpellingContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Spelling violation (Spelling incorrect: rwogn) precondition of anObject fails in SSBClassD myValue:';
				assert: violation shortDescription = 'Pre in anObject: Spelling violation >> rwogn'.].! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:01:45.608'!
test14RaiseSizeContractViolation

	self shouldnt: [SSBClassD new myValue2: #(1 2 3)] runWithContracts 
		raise: SContractViolation.
	self should: [[SSBClassD new myValue2: #(1 2 3 4)] runWithContracts] 
		raise: SSizeContractViolation.
	[[SSBClassD new myValue2: #(1 2 3 4)] runWithContracts] 
		on: SSizeContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Size violation (Size: 4 > 3 elements) precondition of anObject fails in SSBClassD myValue2:';
				assert: violation shortDescription = 'Pre in anObject: Size violation >> 4 > 3'.].! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:02:05.816'!
test15RaiseRangeContractViolation

	self shouldnt: [SSBClassD new myValue: 1] runWithContracts 
		raise: SContractViolation.
	self should: [[SSBClassD new myValue: -1] runWithContracts] 
		raise: SRangeContractViolation.
	[[SSBClassD new myValue: -1] runWithContracts] 
		on: SRangeContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Range violation (-1 not between 0 and 10) precondition of anObject fails in SSBClassD myValue:';
				assert: violation shortDescription = 'Pre in anObject: Range violation >> -1 not between 0 and 10'.].! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:02:26.815'!
test16RaisePropertyContractViolation

	self shouldnt: [SSBClassD new myValue2: #(1 2)] runWithContracts 
		raise: SContractViolation.
	self should: [[SSBClassD new myValue2: #()] runWithContracts] 
		raise: SPropertyContractViolation.
	[[SSBClassD new myValue2: #()] runWithContracts] 
		on: SPropertyContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Property violation (Expected to be not isEmpty) precondition of anObject fails in SSBClassD myValue2:';
				assert: violation shortDescription = 'Pre in anObject: Property violation >> Expected not isEmpty'.].! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:02:44.421'!
test17RaiseNilContractViolation

	self shouldnt: [SSBClassD new myValue: true] runWithContracts 
		raise: SContractViolation.
	self should: [[SSBClassD new myValue: nil] runWithContracts] 
		raise: SNilContractViolation.
	[[SSBClassD new myValue: nil] runWithContracts] 
		on: SNilContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Nil violation (precondition of anObject) in SSBClassD myValue:';
				assert: violation shortDescription = 'Pre in anObject: Nil violation'.].! !

!SContractsTest methodsFor: 'testing' stamp: 'mp 5/14/2013 15:02:58.578'!
test18RaiseIncludesContractViolation

	self shouldnt: [SSBClassD new myValue2: (ReadWriteStream 
					with: OrderedCollection new)] runWithContracts 
		raise: SContractViolation.
	self should: [[SSBClassD new myValue2: (ReadWriteStream 
					with: SortedCollection new)] runWithContracts] 
		raise: SIncludesContractViolation.
	[[SSBClassD new myValue2: (ReadWriteStream 
			with: SortedCollection new)] runWithContracts] 
		on: SIncludesContractViolation 
		do: [:violation | 
			self 
				assert: violation description = 'Includes violation (contents class: SortedCollection is not included in {OrderedCollection . ByteString}) precondition of anObject fails in SSBClassD myValue2:';
				assert: violation shortDescription = 'Pre in anObject: Includes violation >> SortedCollection not included in {OrderedCollection . ByteString}'.].! !

TestCase subclass: #SHarvesterTest
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester'!

!SHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:41:05.785'!
harvesterTestResource
	self subclassResponsibility.! !

!SHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:42:14.852'!
projectTestResource
	self subclassResponsibility.! !

!SHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:42:02.41'!
resources
	^ Set 
		with: self projectTestResource 
		with: self harvesterTestResource! !

!SHarvesterTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:39:24.413'!
bucket
	self subclassResponsibility.! !

!SHarvesterTest methodsFor: 'accessing' stamp: 'mp 4/29/2013 11:26:52.456'!
project

	^ SProject current! !

!SHarvesterTest methodsFor: 'running' stamp: 'mp 4/30/2013 14:35:24.673'!
run: aTestClass with: aTestSymbol
	^ self tracer 
		entryPoints: {(STestCaseEntryPoint class: aTestClass selector: aTestSymbol)};
		run.
! !

!SHarvesterTest methodsFor: 'running' stamp: 'mp 5/3/2013 10:57:53.517'!
runWith: aCollection 
	^ self tracer 
		entryPoints: (aCollection collect: [:each | STestCaseEntryPoint 
													class: each key 
													selector: each value]);
		run.
! !

!SHarvesterTest methodsFor: 'running' stamp: 'mp 5/2/2013 17:40:44.88'!
setUp

	self project harvestedBuckets: nil.
	self tracer: (self class harvesterTestResource current pathMap model 
					run: #testTracer) pathMap tracer.! !

!SHarvesterTest methodsFor: 'accessing' stamp: 'mp 4/29/2013 16:52:09.376'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SHarvesterTest methodsFor: 'accessing' stamp: 'mp 4/29/2013 16:52:09.542'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

SHarvesterTest subclass: #STypeHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Types'!

!STypeHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

STypeHarvesterTest subclass: #SHarvestingHeisenbugTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Types'!

!SHarvestingHeisenbugTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SHarvestingHeisenbugTest methodsFor: 'checking' stamp: 'mp 4/30/2013 14:39:44.908'!
checkTestResult: aTracer
	| testResult | 
	testResult := aTracer entryPoints first lastResult.
	self assert: testResult tests size = 1.
	self assert: testResult hasPassed.
	self deny: testResult hasFailures.
	self deny: testResult hasErrors.! !

!SHarvestingHeisenbugTest methodsFor: 'running' stamp: 'mp 4/30/2013 14:34:08.03'!
setUp

	super setUp.
	self tracer harvester allTypes.! !

!SHarvestingHeisenbugTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:40:40.567'!
testGetAccessor

	self checkTestResult: (self run: SHarvestingSandboxTest with: #testGetAccessor).! !

!SHarvestingHeisenbugTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:40:42.667'!
testLoopBlock

	self checkTestResult: (self run: SHarvestingSandboxTest with: #testLoopBlock).! !

!SHarvestingHeisenbugTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:40:44.588'!
testReturn

	self checkTestResult: (self run: SHarvestingSandboxTest with: #testReturn).! !

!SHarvestingHeisenbugTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:40:50.805'!
testTraceMethodExecution

	self checkTestResult: (self run: SHarvestingSandboxTest 
								with: #testTraceMethodExecution).! !

!SHarvestingHeisenbugTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:40:53.664'!
testTraceMethodExecutionWithBlock

	self checkTestResult: (self run: SHarvestingSandboxTest 
								with: #testTraceMethodExecutionWithBlock).! !

!SHarvestingHeisenbugTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:40:55.191'!
testTraceMethodExecutionWithCondition

	self checkTestResult: (self run: SHarvestingSandboxTest 
								with: #testTraceMethodExecutionWithCondition).! !

STypeHarvesterTest subclass: #SMonoTypeBucketTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Types'!

!SMonoTypeBucketTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SMonoTypeBucketTest methodsFor: 'accessing' stamp: 'mp 5/3/2011 13:28:01.853'!
byteString
	^ self container: ByteString
		elements: Character
		keys: nil! !

!SMonoTypeBucketTest methodsFor: 'accessing' stamp: 'mp 5/3/2011 13:28:12.084'!
byteSymbol
	^ self container: ByteSymbol
		elements: Character
		keys: nil! !

!SMonoTypeBucketTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 14:13:09.912'!
container: aClass elements: elementType keys: keyType
	| container |
	container := SContainerType new.
	container 
		typeOfContainer: aClass;
		typeOfElements: elementType;	
		typeOfKeys: keyType.
	^ container! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/5/2011 17:03:50.16'!
expectedFailures
	^ #( #testDictionaryChange )! !

!SMonoTypeBucketTest methodsFor: 'accessing' stamp: 'mp 5/3/2011 13:39:50.323'!
string
	^ self container: String
		elements: Character
		keys: nil! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:59:52.507'!
testArrayWithObject
	self run: SHarvestingSandboxTest with: #testArrayWithObject.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self container: Array elements: Object keys: nil).! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:00:13.054'!
testAssociation
	self run: SHarvestingSandboxTest with: #testAssociation.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: Association 
						elements: self byteString 
						keys: self byteSymbol).! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:00:55.617'!
testAssociationChange
	self run: SHarvestingSandboxTest with: #testAssociationChange.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: Association 
						elements: Object 
						keys: Object)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:16.459'!
testAssociationChangeElement
	self run: SHarvestingSandboxTest with: #testAssociationChangeElement.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: Association 
						elements: Object 
						keys: self byteSymbol)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:21.606'!
testAssociationChangeKey
	self run: SHarvestingSandboxTest with: #testAssociationChangeKey.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: Association 
						elements: self byteString 
						keys: Object)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:25.261'!
testChangeFromArrayToOrderedCollection
	self run: SHarvestingSandboxTest with: #testChangeFromArrayToOrderedCollection.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: SequenceableCollection 
						elements: SmallInteger 
						keys: nil)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:29.212'!
testChangeFromSingleObjectToCollection
	self run: SHarvestingSandboxTest with: #testChangeFromSingleObjectToCollection.
	self assert: ((self bucket membersFor: SHClassA) at: 2) = Object.! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 15:05:28.461'!
testClosureTemps
	self run: SHarvestingSandboxTest with: #testCollectCollection.		
	self assert: ((self bucket argumentsFor: SHClassA >> #collectCollection:) at: 1) = 
					(self container: Array elements: SmallInteger keys: nil)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:06:02.025'!
testContainerArguments
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOver.
	self assert: ((self bucket argumentsFor: SHClassA>>#assoc:collection:dict:number:) 
					at: 1) = 	(self container: Association 
								elements: SmallInteger 
								keys: self byteSymbol).! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:32.294'!
testContainerInstVars
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOver.
	self assert: ((self bucket membersFor: SHClassA) at: 2) = Object.! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:36.489'!
testContainerInstVarsAll
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOverReally.
	self assert: ((self bucket membersFor: SHClassA) at: 2) = 
				(self 
					container: Object 
					elements: Object 
					keys: self byteSymbol).! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 11:40:33.822'!
testContainerReturn
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOver.
	self assert: (self bucket 
					returnFor: SHClassA>>#assoc:collection:dict:number:) = 
						(self 
							container: Array 
							elements: Object 
							keys: nil).! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 11:40:35.707'!
testContainerReturnAll
	| type |
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOverReally.
	type := self bucket returnFor: SHClassA>>#assoc:collection:dict:number:.
	self assert: type = (self 
							container: Array 
							elements: (self 
											container: Object 
											elements: Object 
											keys: self byteSymbol) 
							keys: nil).! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 18:29:41.033'!
testConversionBackAndForth
	| bucket recoveredBucket |
	self tracer run.
	bucket := self bucket.
	recoveredBucket := bucket convertToSymbols convertToTypes..
	self assert: bucket = bucket copy.
	self deny: bucket = bucket convertToTypes.
	self assert: (bucket instVarNamed: 'arguments') = 
					(recoveredBucket instVarNamed: 'arguments').
	self assert: (bucket instVarNamed: 'returns') = 
					(recoveredBucket instVarNamed: 'returns').
	self assert: (bucket instVarNamed: 'members') = 
					(recoveredBucket instVarNamed: 'members').
	self assert: bucket = recoveredBucket.! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 18:30:24.329'!
testConversionToSymbols
	"self convertToSymbols"
	| bucket symbolBucket |
	self tracer run.
	bucket := self bucket.
	symbolBucket := bucket convertToSymbols.

	self deny: bucket == symbolBucket.

	self assert: (bucket instVarNamed: 'arguments') size = 
					(symbolBucket instVarNamed: 'arguments') size.
					
	self assert: (bucket instVarNamed: 'returns') size = 
					(symbolBucket instVarNamed: 'returns') size.
	self assert: [(symbolBucket instVarNamed: 'returns')
					anyOne isSymbol or: [
						(symbolBucket instVarNamed: 'returns')
							anyOne class = SContainerType]].
					
	self assert: (bucket instVarNamed: 'members') size = 
					(symbolBucket instVarNamed: 'members') size.
	self assert: ((symbolBucket instVarNamed: 'members') at: #SHClassA) = 
					#(Number Object Object).! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 18:31:09.792'!
testConversionToTypes
	| bucket symbolBucket typesBucket |
	self tracer run.
	bucket := self bucket.
	symbolBucket := bucket convertToSymbols.
	typesBucket := symbolBucket convertToTypes.
	self assert: (bucket instVarNamed: 'arguments') size = 
				(typesBucket instVarNamed: 'arguments') size.
	self assert: (bucket instVarNamed: 'returns') = 
				(typesBucket instVarNamed: 'returns').
	self assert: (bucket instVarNamed: 'members') = 
				(typesBucket instVarNamed: 'members').! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:45.224'!
testDictionary
	self run: SHarvestingSandboxTest with: #testDictionary.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: Dictionary 
						elements: SmallInteger 
						keys: self byteSymbol)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:49.542'!
testDictionaryChange
	self run: SHarvestingSandboxTest with: #testDictionaryChange.
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: Dictionary 
						elements: Number 
						keys: self byteSymbol)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:01:52.817'!
testIdentitySet
	self run: SHarvestingSandboxTest with: #testIdentitySet.						
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: IdentitySet 
						elements: Character 
						keys: nil)! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 15:06:25.334'!
testLocalTypes
	| m |
	self run: SHarvestingSandboxTest with: #testLocals.	
	m := SHClassA >> #locals:which:.
	self
		assert: (self bucket argumentsFor: m) size > 0;
		assert: ((self bucket argumentsFor: m) at: 1) = Object;
		assert: ((self bucket argumentsFor: m) at: 2) = SmallInteger.! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 15:02:05.346'!
testMemberTypes
	self run: SHarvestingSandboxTest with: #testMembers.	
	self
		assert: ((self bucket membersFor: SHClassA) at: 1) = Number;
		assert: ((self bucket membersFor: SHClassA) at: 2) = self string;
		assert: ((self bucket membersFor: SHClassA) at: 3) = SmalltalkImage! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 15:02:16.37'!
testMemberTypesSubclass
	self run: SHarvestingSandboxTest with: #testMembersTypesSubclass.	
	self assert: ((self bucket membersFor: SHClassB) at: 1) = self byteString.! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 15:06:39.411'!
testMoreParameterTypes
	| m |
	self run: SHarvestingSandboxTest with: #testStringsMagnitudesAndObjects.							
	m := SHClassA >> #strings:magnitudes:andObjects:index:.
	self
		assert: (self bucket argumentsFor: m) size > 0;
		assert: ((self bucket argumentsFor: m) at: 1) = self string;
		assert: ((self bucket argumentsFor: m) at: 2) = Magnitude;
		assert: ((self bucket argumentsFor: m) at: 3) = Object! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:02:23.868'!
testOrderedCollectionWithNumber
	self run: SHarvestingSandboxTest with: #testOrderedCollectionWithNumber.								
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: OrderedCollection 
						elements: Number 
						keys: nil)! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:02:33.246'!
testOrderedCollectionWithSmallInteger
	self run: SHarvestingSandboxTest with: #testOrderedCollectionWithSmallInteger.							
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: OrderedCollection 
						elements: SmallInteger 
						keys: nil)! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 15:06:46.554'!
testParameterTypes
	| m |
	self run: SHarvestingSandboxTest with: #testNumbers.		
	m := SHClassA >> #numbers:.
	self
		assert: (self bucket argumentsFor: m) size > 0;
		assert: ((self bucket argumentsFor: m) at: 1) = Number! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:02:38.135'!
testRecursiveCollections
	self run: SHarvestingSandboxTest with: #testRecursiveCollections.								
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = 
					(self 
						container: OrderedCollection 
						elements: ((self 
										container: Collection 
										elements: Object 
										keys: nil)) 
						keys: nil)! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 11:40:37.192'!
testReturnTypeLeastCommon
	self run: SHarvestingSandboxTest with: #testReturnLeastCommon.			
	self assert: (self bucket returnFor: SHClassA >> #numbers:) = Number.			! !

!SMonoTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 11:40:45.143'!
testReturnTypes
	self run: SHarvestingSandboxTest with: #testReturn.	
	self 
		assert: (self bucket returnFor: SHClassA >> #numbers:) = SmallInteger;
		assert: (self bucket returnFor: SHClassA >> #initialize) = SHClassA;
		assert: (self bucket returnFor: SHClassA >> #a:) = SHClassA.! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:02:41.943'!
testString
	self run: SHarvestingSandboxTest with: #testString.								
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = self byteString.! !

!SMonoTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 15:02:45.15'!
testStringAndSymbol
	self run: SHarvestingSandboxTest with: #testStringAndSymbol.								
	self
		assert: ((self bucket membersFor: SHClassA) at: 2) = self string.! !

STypeHarvesterTest subclass: #SPolyTypeBucketTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Types'!

!SPolyTypeBucketTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPolyTypeBucketTest methodsFor: 'accessing' stamp: 'mp 4/30/2013 13:28:20.089'!
byteString
	^ self container: ByteString
		elements: {Character} 
		keys: nil! !

!SPolyTypeBucketTest methodsFor: 'accessing' stamp: 'mp 4/30/2013 13:28:13.316'!
byteSymbol
	^ self container: ByteSymbol 
		elements: {Character} 
		keys: nil! !

!SPolyTypeBucketTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 14:13:19.1'!
container: aClass elements: elementTypes keys: keyTypes
	| container |
	container := SContainerType forPoly: aClass.
	elementTypes ifNotNil: [
		elementTypes do: [:each | container typeOfElements add: each]].
	keyTypes ifNotNil: [
		keyTypes do: [:each | container typeOfKeys add: each]].
	^ container! !

!SPolyTypeBucketTest methodsFor: 'running' stamp: 'mp 4/30/2013 13:16:37.779'!
expectedFailures
	^ #(#testHarvestDictionaryChange 
		#testHarvestIncrementalAddOfNumbers)! !

!SPolyTypeBucketTest methodsFor: 'running' stamp: 'mp 4/30/2013 12:02:57.297'!
setUp
	super setUp.
	self tracer harvester allTypes.! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:42:50.457'!
testClosureTemps
	self run: SHarvestingSandboxTest with: #testCollectCollection.
	self 
		assert: ((self bucket argumentsFor: SHClassA >> #collectCollection:) at: 1) 
					size = 1;
		assert: ((self bucket argumentsFor: SHClassA >> #collectCollection:) at: 1) = 
						(Set with: (self container: Array elements: {SmallInteger} keys: {}))! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:40:51.421'!
testContainerArguments
	| type |
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOver.
	type := ((self bucket 
				argumentsFor: SHClassA>>#assoc:collection:dict:number:) at: 1) anyOne.
	self assert: type = (self container: Association 
									elements: {SmallInteger} 
									keys: {self byteSymbol}).
	type := ((self bucket 
				argumentsFor: SHClassA>>#assoc:collection:dict:number:) at: 2) anyOne.	
	self assert: type = (self container: OrderedCollection 
									elements: {SmallInteger. self byteString} 
									keys: {}).
	type := ((self bucket 
				argumentsFor: SHClassA>>#assoc:collection:dict:number:) at: 3) anyOne.
	self assert: type = (self container: Dictionary 
									elements: {SmallInteger} 
									keys: {self byteSymbol}).
	type := ((self bucket 
				argumentsFor: SHClassA>>#assoc:collection:dict:number:) at: 4) anyOne.
	self assert: type = SmallInteger.	! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:45:45.291'!
testContainerInstVars
	| types container |
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOver.
	types := ((self bucket membersFor: SHClassA) at: 2).
	self assert: types size = 4.
	self assert: (types includes: SmallInteger).
	container := types detect: [:each | each isBehavior
									ifTrue: [false]
									ifFalse: [each typeOfContainer = OrderedCollection]].
	self assert: container = (self container: OrderedCollection 
									elements: {SmallInteger. self byteString} 
									keys: {}).
	container := types detect: [:each | each isBehavior
										ifTrue: [false]
										ifFalse: [each typeOfContainer = Dictionary]].
	self assert: container = (self container: Dictionary 
									elements: {SmallInteger} 
									keys: {self byteSymbol}).
	container := types detect: [:each | each isBehavior
										ifTrue: [false]
										ifFalse: [each typeOfContainer = Association]].
	self assert: container = (self container: Association 
									elements: {SmallInteger} 
									keys: {self byteSymbol}).			! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 11:46:44.374'!
testContainerReturn
	| type |
	self run: SHarvestingSandboxTest with: #testMethodWithContainersAllOver.
	type := (self bucket returnFor: SHClassA>>#assoc:collection:dict:number:) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Array;
		assert: type typeOfElements = (Set 
											with: (self container: OrderedCollection 
													     elements: {SmallInteger. 
																    self byteString} 
													     keys: {})
											with: SmallInteger
											with: (self container: Dictionary 
													     elements: {SmallInteger} 
													     keys: {self byteSymbol})
											with: (self container: Association 
													     elements: {SmallInteger} 
													     keys: {self byteSymbol}));
		assert: type typeOfKeys isEmpty.									! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:45:56.979'!
testHarvestArrayWithObject
	| type |
	self run: SHarvestingSandboxTest with: #testArrayWithObject.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Array;
		assert: type typeOfElements  = (Set 
											with: self byteString 
											with: SmallInteger);
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:03.119'!
testHarvestAssociation
	| type |
	self run: SHarvestingSandboxTest with: #testAssociation.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Association;
		assert: type typeOfElements anyOne = self byteString;
		assert: type typeOfKeys anyOne = self byteSymbol.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:10.037'!
testHarvestAssociationChange
	| type |
	self run: SHarvestingSandboxTest with: #testAssociationChange.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Association;
		assert: type typeOfElements = (Set 
											with: self byteString 
											with: SmallInteger);
		assert: type typeOfKeys = (Set 
										with: self byteSymbol 
										with: SmallInteger).! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:16.368'!
testHarvestAssociationChangeElement
	| type |
	self run: SHarvestingSandboxTest with: #testAssociationChangeElement.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Association;
		assert: type typeOfElements = (Set 
										with: self byteString 
										with: SmallInteger);
		assert: type typeOfKeys = (Set with: self byteSymbol).! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:23.205'!
testHarvestAssociationChangeKey
	| type |
	self run: SHarvestingSandboxTest with: #testAssociationChangeKey.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Association;
		assert: type typeOfElements = (Set with: self byteString);
		assert: type typeOfKeys = (Set 
										with: self byteSymbol 
										with: SmallInteger).! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:29.404'!
testHarvestBagWithNumbers
	| type |
	self run: SHarvestingSandboxTest with: #testBagWithNumbers.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Bag;
		assert: type typeOfElements = (Set with: SmallInteger with: Float);
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:35.624'!
testHarvestChangeFromArrayToOrderedCollection
	| types container |
	self run: SHarvestingSandboxTest with: #testChangeFromArrayToOrderedCollection.
	types := ((self bucket membersFor: SHClassA) at: 2).
	self assert: types size = 2.
	container := types detect: [:each | each typeOfContainer = Array].
	self assert: container = (self container: Array
											   elements: {SmallInteger} 
											   keys: {}).
	container := types detect: [:each | each typeOfContainer = OrderedCollection].
	self assert: container = (self container: OrderedCollection
											   elements: {SmallInteger} 
											   keys: {}).												! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:42.917'!
testHarvestChangeFromSingleObjectToCollection
	| types container |
	self run: SHarvestingSandboxTest with: #testChangeFromSingleObjectToCollection.
	types := ((self bucket membersFor: SHClassA) at: 2).
	self assert: types size = 2.
	self assert: (types includes: SmallInteger).
	container := types detect: [:each | each isBehavior not].
	self assert: container = (self container: OrderedCollection
											   elements: {SmallInteger} 
											   keys: {}).! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:49.809'!
testHarvestDictionary
	| type |
	self run: SHarvestingSandboxTest with: #testDictionary.
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Dictionary;
		assert: type typeOfElements anyOne = SmallInteger;
		assert: type typeOfKeys anyOne = self byteSymbol.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:46:55.441'!
testHarvestDictionaryChange
	| type |
	self run: SHarvestingSandboxTest with: #testDictionaryChange.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Dictionary;
		assert: type typeOfElements = (Set with: SmallInteger with: Float);
		assert: type typeOfKeys = (Set with: self byteSymbol).! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:47:03.783'!
testHarvestIdentitySet
	| type |
	self run: SHarvestingSandboxTest with: #testIdentitySet.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = IdentitySet;
		assert: type typeOfElements anyOne = Character;
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:47:10.235'!
testHarvestIncrementalAddOfNumbers
	| type |
	self run: SHarvestingSandboxTest with: #testIncrementalAddOfNumbers.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = OrderedCollection;
		assert: type typeOfElements = (Set with: SmallInteger with: Float with: Fraction);
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:47:16.801'!
testHarvestInterval
	| type |
	self run: SHarvestingSandboxTest with: #testInterval.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Interval;
		assert: type typeOfElements anyOne = SmallInteger;
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:47:22.989'!
testHarvestMatrix
	| type |
	self run: SHarvestingSandboxTest with: #testMatrix.		
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Matrix;
		assert: type typeOfElements anyOne = SmallInteger;
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:47:48.425'!
testHarvestOrderedCollectionWithNumber
	| type |
	self run: SHarvestingSandboxTest with: #testOrderedCollectionWithNumber.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = OrderedCollection;
		assert: type typeOfElements = (Set with: SmallInteger with: Float);
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:47:55.796'!
testHarvestOrderedCollectionWithSmallInteger
	| type |
	self run: SHarvestingSandboxTest with: #testOrderedCollectionWithSmallInteger.						
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = OrderedCollection;
		assert: type typeOfElements anyOne = SmallInteger;
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:48:01.984'!
testHarvestRecursiveCollections
	| type |
	self run: SHarvestingSandboxTest with: #testRecursiveCollections.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = OrderedCollection;
		assert: type typeOfElements = (Set 
								with: (self container: Array 
										    elements: {SmallInteger}
										    keys: {}) 
								with: (self container: Array 
										    elements: {Character} 
										    keys: {})
								with: (self container: Set 
										    elements: {self byteString} 
										    keys: {}));
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:48:07.783'!
testHarvestSetWithIntegers
	| type |
	self run: SHarvestingSandboxTest with: #testSetWithIntegers.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = Set;
		assert: type typeOfElements anyOne = SmallInteger;
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing-container' stamp: 'mp 5/8/2013 14:48:13.298'!
testHarvestString
	| type |
	self run: SHarvestingSandboxTest with: #testString.							
	type := ((self bucket membersFor: SHClassA) at: 2) anyOne.
	self
		deny: type isBehavior;
		assert: type class = SContainerType;
		assert: type typeOfContainer = ByteString;
		assert: type typeOfElements anyOne = Character;
		assert: type typeOfKeys isEmpty.! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:49:08.092'!
testMemberTypes
	self run: SHarvestingSandboxTest with: #testMembers.
	self
		assert: ((self bucket membersFor: SHClassA) at: 1) size = 2;
		assert: ((self bucket membersFor: SHClassA) at: 2) size = 2;
		assert: ((self bucket membersFor: SHClassA) at: 3) size = 1! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:44:23.146'!
testReturnTypeBlock
	self run: SHarvestingSandboxTest with: #testReturnTypeBlock.
	self 
		assert: (self bucket returnFor: SHClassA >> #returnBlock:) size = 1;
		assert: (self bucket returnFor: SHClassA >> #returnBlock:) = 
					(Set with: SmallInteger);
		assert: (self bucket returnFor: SHClassA >> #evalBlock:with:) size = 0						! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:43:48.212'!
testReturnTypeQuick
	self run: SHarvestingSandboxTest with: #testReturnTypeQuick.
	self 
		assert: (self bucket returnFor: SHClassA >> #a) size = 1;
		assert: (self bucket returnFor: SHClassA >> #a) = (Set with: SmallInteger).! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:43:53.74'!
testReturnTypeSets
	self run: SHarvestingSandboxTest with: #testReturnTypeSets.
	self 
		assert: (self bucket returnFor: SHClassA >> #numbers:) size  = 4;
		assert: (self bucket returnFor: SHClassA >> #numbers:) = 
						(Set 
							with: SmallInteger
							with: Float
							with: self byteString
							with: SHClassB)! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:44:00.173'!
testReturnTypeSpecialConstants
	self run: SHarvestingSandboxTest with: #testReturnTypeSpecialConstants.
	self 
		assert: (self bucket returnFor: SHClassA >> #returnTrue) size = 1;
		assert: (self bucket returnFor: SHClassA >> #returnTrue) = 
					(Set with: True)				! !

!SPolyTypeBucketTest methodsFor: 'testing' stamp: 'mp 5/8/2013 14:44:06.297'!
testReturnTypes
	self run: SHarvestingSandboxTest with: #testReturn.
	self 
		assert: (self bucket returnFor: SHClassA >> #numbers:) size = 1;
		assert: (self bucket returnFor: SHClassA >> #numbers:) = (Set with: SmallInteger);
		assert: (self bucket returnFor: SHClassA >> #initialize) = (Set with: SHClassA);
		assert: (self bucket returnFor: SHClassA >> #a:) = (Set with: SHClassA).					! !

!STypeHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:41:26.443'!
harvesterTestResource
	^ SPathMapInductiveTypeHarvestingTestResource! !

!STypeHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:49:54.087'!
projectTestResource
	^ SProjectHarvesterSandboxTestResource! !

!STypeHarvesterTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:38:36.336'!
bucket
	^ SProject current typesBucket! !

!STypeHarvesterTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:38:36.549'!
byteString
	self subclassResponsibility.! !

!STypeHarvesterTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:38:36.567'!
byteSymbol
	self subclassResponsibility.! !

!STypeHarvesterTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:38:36.585'!
container: aClass elements: elementTypes keys: keyTypes
	self subclassResponsibility.! !

SHarvesterTest subclass: #SValueRangeHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SValueRangeHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SValueRangeHarvesterTest subclass: #SBooleanHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SBooleanHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SBooleanHarvesterTest methodsFor: 'testing' stamp: 'mp 5/3/2013 11:51:42.826'!
test01DefaultRangePropertyInitialization
	| property |
	property := SDefaultRangeProperties new.
	self 
		assert: property constantValue;
		deny: property nilAllowed;
		assert: property lastObject isNil;
		assert: property class label = 'Other Objects'.! !

!SBooleanHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:26.372'!
test02Equality
	self run: SSBValueRangeTest with: #testBoolean.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SBooleanHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:10.719'!
test03ConstantValue
	self run: SSBValueRangeTest with: #testBoolean.
	self 
		assert: (self bucket returnFor: SSBClassD>>#myValue:) constantValue;
		deny: (self bucket membersFor: SSBClassD) first constantValue.
! !

!SBooleanHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:12.704'!
test04NilAllowed
	self run: SSBValueRangeTest with: #testBoolean.
	self 
		deny: (self bucket returnFor: SSBClassD>>#myValue:) nilAllowed;
		assert: (self bucket membersFor: SSBClassD) first nilAllowed.! !

SValueRangeHarvesterTest subclass: #SCharactersHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SCharactersHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/3/2013 11:51:22.208'!
test01DefaultRangePropertyInitialization
	| property |
	property := SCharactersRangeProperties new.
	self 
		assert: property range isNil;
		deny: property includesLetters;
		deny: property includesDigits;
		deny: property includesSeparators;
		deny: property includesSpecials;
		deny: property lowercase;
		deny: property uppercase;
		assert: property httpSafe;
		assert: property class label = 'Characters'.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:28.488'!
test02Equality
	self runWith: {SSBValueRangeTest->#testCharacters1. 
				SSBValueRangeTest->#testCharacters2.
				SSBValueRangeTest->#testCharacters3.}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:14.28'!
test03CharactersRange
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property range = (Interval from: 32 to: 97).
! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:16.001'!
test04IncludesLetters
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesLetters.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:17.836'!
test05IncludesDigits
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesDigits.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:19.663'!
test06IncludesSeparators
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesSeparators.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:21.226'!
test07IncludesSpecials
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesSpecials.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:22.671'!
test08Lowercase
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property lowercase.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:24.176'!
test09Uppercase
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property uppercase.! !

!SCharactersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:25.712'!
test10HttpSafe
	| property |
	self run: SSBValueRangeTest with: #testCharacters1.
	property := (self bucket membersFor: SSBClassD) first.
	self deny: property httpSafe.! !

SValueRangeHarvesterTest subclass: #SCollectionHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SCollectionHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCollectionHarvesterTest methodsFor: 'testing' stamp: 'mp 5/3/2013 13:05:11.232'!
test01DefaultRangePropertyInitialization
	| property |
	property := SCollectionsRangeProperties new.
	self 
		assert: property maxNumberOfElements = 0;
		assert: property fixedSize;
		deny: property emptyAllowed;
		assert: property class label = 'Collections'.! !

!SCollectionHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:30.191'!
test02Equality
	self runWith: {SSBValueRangeTest->#testCollection1. 
				SSBValueRangeTest->#testCollection2}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SCollectionHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:27.224'!
test03MaximalNumbersOfElements
	| property |
	self run: SSBValueRangeTest with: #testCollection1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property maxNumberOfElements = 4.
! !

!SCollectionHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:29.085'!
test04FixedSizeOfCollection
	| property |
	self run: SSBValueRangeTest with: #testCollection1.
	property := (self bucket membersFor: SSBClassD) first.
	self deny: property fixedSize.
! !

!SCollectionHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:30.744'!
test05EmptyCollectionsAllowed
	| property |
	self run: SSBValueRangeTest with: #testCollection1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property emptyAllowed.
! !

!SCollectionHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:32.163'!
test06MultipleCollectionTypes
	| property |
	self run: SSBValueRangeTest with: #testCollection2.
	property := (self bucket membersFor: SSBClassD) first.
	self 
		deny: property constantValue;
		deny: property nilAllowed;
		assert: property maxNumberOfElements = 3;
		assert: property fixedSize;
		deny: property emptyAllowed.
! !

SValueRangeHarvesterTest subclass: #SDateAndTimeHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SDateAndTimeHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 5/6/2013 11:02:39.812'!
test01DefaultRangePropertyInitialization
	| property |
	property := SDateAndTimeRangeProperties new.
	self 
		assert: property minDate isNil;
		assert: property maxDate isNil;
		assert: property dayOfWeekNames isEmpty;
		deny: property isLeapYear;
		assert: property timeZones isEmpty;
		assert: property class label = 'DateAndTime'.! !

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:31.843'!
test02Equality
	self runWith: {SSBValueRangeTest->#testDateAndTime1. 
				SSBValueRangeTest->#testDateAndTime2}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 6/7/2013 14:12:09.709'!
test03MinDate
	| property high low |
	self run: SSBValueRangeTest with: #testDateAndTime2.
	property := (self bucket membersFor: SSBClassD) first.
	low := ((DateAndTime yesterday - DateAndTime now) * 1.05) asSeconds - 6.
	high := ((DateAndTime yesterday - DateAndTime now) * 1.05) asSeconds - 4.
	self assert: (property minDate asSeconds between: low and: high).! !

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 6/7/2013 14:18:58.304'!
test04MaxDate
	| property high low |
	self run: SSBValueRangeTest with: #testDateAndTime2.
	property := (self bucket membersFor: SSBClassD) first.
	low := ((DateAndTime tomorrow - DateAndTime now * 1.05) asSeconds + 4).
	high := ((DateAndTime tomorrow - DateAndTime now * 1.05) asSeconds + 6).
	self assert: (property maxDate asSeconds between: low and: high)
! !

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:36.955'!
test05DayOfWeekNames
	| property |
	self run: SSBValueRangeTest with: #testDateAndTime2.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property dayOfWeekNames = (Set 
										with: DateAndTime now dayOfWeekName 
										with: DateAndTime yesterday dayOfWeekName 
										with: DateAndTime tomorrow dayOfWeekName).
! !

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:39.973'!
test06IsLeapYear
	| property |
	self run: SSBValueRangeTest with: #testDateAndTime1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property isLeapYear = DateAndTime now isLeapYear.
! !

!SDateAndTimeHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:41.675'!
test07timeZones
	| property |
	self run: SSBValueRangeTest with: #testDateAndTime1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property timeZones = (Set with: DateAndTime now timeZoneName).! !

SValueRangeHarvesterTest subclass: #SDurationHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SDurationHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/6/2013 11:16:42.436'!
test01DefaultRangePropertyInitialization
	| property |
	property := SDurationRangeProperties new.
	self 
		assert: property secondsRange isNil;
		assert: property nanoRange isNil;
		deny: property positive;
		deny: property negative;
		deny: property isZero;
		assert: property class label = 'Duration'.! !

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:33.5'!
test02Equality
	self runWith: {SSBValueRangeTest->#testDuration1. 
				SSBValueRangeTest->#testDuration2.
				SSBValueRangeTest->#testDuration3}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:43.204'!
test03SecondsRange
	| property |
	self run: SSBValueRangeTest with: #testDuration1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property secondsRange = (-10 to: 10).
! !

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:44.65'!
test04NanoSecondsRange
	| property |
	self run: SSBValueRangeTest with: #testDuration2.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property nanoRange = (-10 to: 10).
! !

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:46.296'!
test05PositiveValue
	| property |
	self run: SSBValueRangeTest with: #testDuration1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property positive.
! !

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:47.786'!
test06NegativeValue
	| property |
	self run: SSBValueRangeTest with: #testDuration1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property negative.
! !

!SDurationHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:49.45'!
test07isZero
	| property |
	self run: SSBValueRangeTest with: #testDuration1.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property isZero.
! !

SValueRangeHarvesterTest subclass: #SNumbersHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SNumbersHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/6/2013 11:22:19.068'!
test01DefaultRangePropertyInitialization
	| property |
	property := SNumbersRangeProperties new.
	self 
		assert: property range isNil;
		deny: property includesZero;
		deny: property positive;
		deny: property negative;
		assert: property class label = 'Numbers'.! !

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:35.189'!
test02Equality
	self runWith: {SSBValueRangeTest->#testNumbers1. 
				SSBValueRangeTest->#testNumbers2.
				SSBValueRangeTest->#testNumbers3.
				SSBValueRangeTest->#testNumbers4}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:51.768'!
test03aNumbersRange
	| property |
	self run: SSBValueRangeTest with: #testNumbers2.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property range = (-7 to: 10).
! !

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:53.319'!
test03bNumbersRange
	| property |
	self run: SSBValueRangeTest with: #testNumbers3.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property range = (-1.43 to: 10).
! !

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:55.13'!
test04IncludesZero
	| property |
	self run: SSBValueRangeTest with: #testNumbers2.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesZero.
! !

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:56.58'!
test05PositiveNumbers
	| property |
	self run: SSBValueRangeTest with: #testNumbers1.
	property := (self bucket membersFor: SSBClassD) first.
	self 
		assert: property positive;
		deny: property negative.
! !

!SNumbersHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:58.164'!
test06NegativeNumbers
	| property |
	self run: SSBValueRangeTest with: #testNumbers2.
	property := (self bucket membersFor: SSBClassD) first.
	self 
		assert: property positive;
		assert: property negative.
! !

SValueRangeHarvesterTest subclass: #SStreamHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SStreamHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SStreamHarvesterTest methodsFor: 'testing' stamp: 'mp 5/6/2013 11:27:26.596'!
test01DefaultRangePropertyInitialization
	| property |
	property := SStreamRangeProperties new.
	self 
		deny: property isClosed;
		assert: property contents isEmpty;
		assert: property class label = 'Stream'.! !

!SStreamHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:37.495'!
test02Equality
	self runWith: {SSBValueRangeTest->#testStreams1.
				SSBValueRangeTest->#testStreams2}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SStreamHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:31:59.762'!
test03IsClosed
	| property |
	self run: SSBValueRangeTest with: #testStreams1.
	property := (self bucket membersFor: SSBClassD) first.
	self deny: property isClosed.
! !

!SStreamHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:01.43'!
test04ContentsOfStream
	| property |
	self run: SSBValueRangeTest with: #testStreams2.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property contents = (Set with: OrderedCollection with: ByteString).
! !

SValueRangeHarvesterTest subclass: #SStringHarvesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SStringHarvesterTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/6/2013 11:32:59.778'!
test01DefaultRangePropertyInitialization
	| property |
	property := SStringRangeProperties new.
	self 
		assert: property spellingOkay;
		assert: property length = 0;
		deny: property includesNumbers; 
		deny: property includesSeparators;
		assert: property isAsciiString; 
		assert: property contentTypes isEmpty; 
		assert: property class label = 'Strings'.! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:39.174'!
test02Equality
	self runWith: {SSBValueRangeTest->#testString1.
				SSBValueRangeTest->#testString2.
				SSBValueRangeTest->#testString3.
				SSBValueRangeTest->#testString4.
				SSBValueRangeTest->#testString5}.
	self assert: (self bucket returnFor: SSBClassD>>#myValue:) = 
				(self bucket argumentsFor: SSBClassD>>#myValue:) first.! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:02.902'!
test03SpellingOkay
	| property |
	self run: SSBValueRangeTest with: #testString2.
	property := (self bucket membersFor: SSBClassD) first.
	self deny: property spellingOkay.
! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:04.699'!
test04LengthOfString
	| property |
	self run: SSBValueRangeTest with: #testString1.
	property := (self bucket membersFor: SSBClassD) first.
	self deny: property length = 0.
! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:06.311'!
test05IncludesNumbers
	| property |
	self run: SSBValueRangeTest with: #testString3.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesNumbers.
! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:07.603'!
test06includesSeparators
	| property |
	self run: SSBValueRangeTest with: #testString5.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property includesSeparators.
! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:09.212'!
test07isAsciiString
	| property |
	self run: SSBValueRangeTest with: #testString5.
	property := (self bucket membersFor: SSBClassD) first.
	self deny: property isAsciiString.
! !

!SStringHarvesterTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:10.612'!
test08ContentTypes
	| property |
	self run: SSBValueRangeTest with: #testString4.
	property := (self bucket membersFor: SSBClassD) first.
	self assert: property contentTypes = (Set 
											with: #fileDirectory 
											with: #asNumber 
											with:  #asInteger 
											with: #asTime 
											with: #asDate).! !

SValueRangeHarvesterTest subclass: #SValueRangeBucketTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-ValueRanges'!

!SValueRangeBucketTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:41.109'!
test01aGetParameterRanges
	| ranges | 
	self run: SSBValueRangeTest with: #testBoolean.
	ranges := self bucket argumentsFor: SSBClassD>>#myValue:.
	self 
		assert: ranges notNil;
		assert: ranges size = 1;
		assert: ranges first class label = 'Other Objects'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:42.67'!
test01bGetParameterRanges
	| ranges | 
	self run: SSBValueRangeTest with: #testBoolean.
	ranges := self bucket argumentsFor: SSBClassD>>#myValue2:.
	self 
		assert: ranges notNil;
		assert: ranges size = 1;
		assert: ranges first class label = 'Other Objects'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:44.414'!
test01cGetParameterRanges
	| ranges | 
	self run: SSBValueRangeTest with: #testBoolean.
	ranges := self bucket argumentsFor: SSBClassD>>#myValue3:.
	self 
		assert: ranges notNil;
		assert: ranges size = 1;
		assert: ranges first isNil.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:28:49.267'!
test02aGetReturnRanges
	| range | 
	self run: SSBValueRangeTest with: #testBoolean.
	range := self bucket returnFor: SSBClassD>>#myValue:.
	self 
		assert: range notNil;
		assert: range class label = 'Other Objects'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:28:50.769'!
test02bGetReturnRanges
	| range | 
	self run: SSBValueRangeTest with: #testBoolean.
	range := self bucket returnFor: SSBClassD>>#myValue2:.
	self 
		assert: range notNil;
		assert: range class label = 'Other Objects'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:28:52.177'!
test02cGetReturnRanges
	| range | 
	self run: SSBValueRangeTest with: #testBoolean.
	range := self bucket returnFor: SSBClassD>>#myValue3:.
	self assert: range isNil.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:12.961'!
test03GetMemberRanges
	| ranges |
	self run: SSBValueRangeTest with: #testBoolean.
	ranges := self bucket membersFor: SSBClassD.
	self 
		assert: ranges notNil;
		assert: ranges size = 1;
		assert: ranges first class label = 'Other Objects'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:45:45.759'!
test04aMultipleValueRanges
	| ranges |
	self runWith: {SSBValueRangeTest->#testCharacters1. 
					SSBValueRangeTest->#testNumbers1}.
	ranges := self bucket argumentsFor: SSBClassD>>#myValue:.
	self 
		assert: ranges first isCollection;
		assert: ranges first size = 2;
		assert: ranges first first class label = 'Characters';
		assert: ranges first second class label = 'Numbers'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:28:53.827'!
test04bMultipleValueRanges
	| ranges |
	self runWith: {SSBValueRangeTest->#testCharacters1. 
					SSBValueRangeTest->#testNumbers1}.
	ranges := self bucket returnFor: SSBClassD>>#myValue:.
	self 
		assert: ranges isCollection;
		assert: ranges size = 2;
		assert: ranges first class label = 'Characters';
		assert: ranges second class label = 'Numbers'.! !

!SValueRangeBucketTest methodsFor: 'testing' stamp: 'mp 5/7/2013 17:32:14.5'!
test04cMultipleValueRanges
	| ranges |
	self runWith: {SSBValueRangeTest->#testCharacters1. 
					SSBValueRangeTest->#testNumbers1}.
	ranges := self bucket membersFor: SSBClassD.
	self 
		assert: ranges first isCollection;
		assert: ranges first size = 2;
		assert: ranges first first class label = 'Characters';
		assert: ranges first second class label = 'Numbers'.! !

!SValueRangeHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:59:13.896'!
harvesterTestResource
	^ SPathMapInductiveValueRangeHarvestingTestResource! !

!SValueRangeHarvesterTest class methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:57:50.472'!
projectTestResource
	^ SProjectSandboxTestResource! !

!SValueRangeHarvesterTest methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:57:24.617'!
bucket
	^ SProject current valueRangeBucket! !

TestCase subclass: #SHarvestingSandboxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Sandbox'!

!SHarvestingSandboxTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:30.884'!
testArrayWithObject
	| obj |
	obj := SHClassA new.
	obj b: {'String'. 1}! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:33.13'!
testAssociation
	| obj |
	obj := SHClassA new.
	obj b: (#key -> 'value').! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:43.563'!
testAssociationChange
	| obj |
	obj := SHClassA new.
	obj b: (#key -> 'value').
	obj b: (1 -> 2).
	! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:46.146'!
testAssociationChangeElement
	| obj |
	obj := SHClassA new.
	obj b: (#key -> 'value').
	obj b: (#otherKey -> 2).! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:48.604'!
testAssociationChangeKey
	| obj |
	obj := SHClassA new.
	obj b: (#key -> 'value').
	obj b: (1 -> '2').! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:51.031'!
testBagWithNumbers
	| obj |
	obj := SHClassA new.
	obj b: (Bag with: 1 with: 1 with: 3.0)! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:53.549'!
testChangeFromArrayToOrderedCollection
	| obj |
	obj := SHClassA new.
	obj b: {1. 2}.
	obj b: obj b asOrderedCollection.! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:45:55.608'!
testChangeFromSingleObjectToCollection
	| obj |
	obj := SHClassA new.
	obj b: 1.
	obj b: (OrderedCollection with: obj b with: 2).! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:45:58.213'!
testCollectCollection
	| jm |
	jm := SHClassA new.
	self
		assert: (jm collectCollection: #( 1 2 3 )) = #( true true true )! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:00.903'!
testConstructor
	| obj |
	obj := SHClassA a: 1 b: 2 c: 3.
	self assert: obj a = 1.
	self assert: obj b = 2.
	self assert: obj c = 3.		! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:03.375'!
testDictionary
	| obj |
	obj := SHClassA new.
	obj b: (Dictionary newFrom: {#a->1. #b->2.}).! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:06.229'!
testDictionaryChange
	| obj |
	obj := SHClassA new.
	obj b: Dictionary new.
	obj b add: #a -> 1.
"	obj b: obj b."
	obj b at: #a put: 2.0.
"	obj b: obj b."! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:09.06'!
testGetAccessor

	self assert: SHClassA new a = 1.! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:11.825'!
testIdentitySet
	| obj |
	obj := SHClassA new.
	obj b: IdentitySet new.
	obj b add: $a.
	obj b add: $a.
	obj b: obj b.! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:14.207'!
testIncrementalAddOfNumbers
	| obj |
	obj := SHClassA new.
	obj b: OrderedCollection new.
	obj b 
			add: 1;
			add: -2;
			addLast: 2.0;
			add: (3/5).
"	obj b: obj b."! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:16.495'!
testInterval
	| obj |
	obj := SHClassA new.
	obj b: (Interval from: 1 to: 10).! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:18.804'!
testLocals
	| jm |
	jm := SHClassA new.
	self
		assert: (jm locals: 23 which: 1) = 23;
		assert: (jm locals: 42.0 which: 1) = 42.0;
		assert: (jm locals: 'yo' which: 2) = 'yo';
		assert: (jm locals: #yo which: 2) = #yo;
		assert: (jm locals: nil which: 3) = nil;
		assert: (jm locals: Smalltalk which: 3) = Smalltalk! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:22.484'!
testLoopBlock

	| number |
	number := 1.
	2 timesRepeat: [number := SHClassA new addValueToA: number].
	self assert: number = 3.	! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:25.415'!
testMatrix
	| obj |
	obj := SHClassA new.
	obj b: (Matrix rows: 5 columns: 5 tabulate: [:row :column | row * column]).! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:27.981'!
testMembers
	| sm |
	sm := SHClassA new.
	self
		assert: (sm a: 23; a) = 23;
		assert: (sm a: 42.0; a) = 42.0;
		assert: (sm b: 'yo'; b) = 'yo';
		assert: (sm b: #yo; b) = #yo;
		assert: (sm c: nil; c) = nil;
		assert: (sm c: Smalltalk; c) = Smalltalk! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:51:21.305'!
testMembersTypesSubclass
	SHClassSubB new.! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:30.463'!
testMethodWithContainersAllOver
	| obj |
	obj := SHClassA new.
	obj 
		assoc: #a -> 1 
		collection: (OrderedCollection with: 1 with: 'string') 
		dict: (Dictionary newFrom: {#a -> 1. #b -> 2})
		number: 2.! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:32.734'!
testMethodWithContainersAllOverReally
	| obj |
	obj := SHClassA new.
	obj 
		assoc: #a -> 1 
		collection: (OrderedCollection with: 1 with: 'string') 
		dict: (Dictionary newFrom: {#a -> 1. #b -> 2})
		number: {2}.! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:35.352'!
testNumbers
	| jm |
	jm := SHClassA new.
	self
		assert: (jm numbers: 23) = 23;
		assert: (jm numbers: 42.23) = 42.23! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:37.457'!
testOrderedCollectionWithNumber
	| obj |
	obj := SHClassA new.
	obj b: (OrderedCollection with: 1 with: 2.0)! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:39.813'!
testOrderedCollectionWithSmallInteger
	| obj |
	obj := SHClassA new.
	obj b: (OrderedCollection with: 1 with: 2)! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:46:42.024'!
testRecursiveCollections
	| obj |
	obj := SHClassA new.
	obj b: (OrderedCollection with: {1. 2.} with: {$a. $b} with: (Set with: 'string')).! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:46.801'!
testReturn

	self assert: (SHClassA new numbers: 1 ) = 1
	! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:49.286'!
testReturnLeastCommon
	SHClassA new 
			numbers: 10;
			numbers: -3.5
	! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:52.318'!
testReturnTypeBlock
	SHClassA new returnBlock: 1.! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:46:54.694'!
testReturnTypeQuick
	SHClassA new a.! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:51:03.9'!
testReturnTypeSets
	SHClassA new 
			numbers: 10;
			numbers: -3.5;
			numbers: 'abc';
			numbers: SHClassB new.! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:47:03.923'!
testReturnTypeSpecialConstants
	SHClassA new returnTrue! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:47:06.368'!
testSetWithIntegers
	| obj |
	obj := SHClassA new.
	obj b: (Set with: 1 with: 2 with: 3)! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:47:08.982'!
testString
	| obj |
	obj := SHClassA new.
	obj b: 'string'.! !

!SHarvestingSandboxTest methodsFor: 'testing-container' stamp: 'mp 5/2/2013 13:47:11.445'!
testStringAndSymbol
	| obj |
	obj := SHClassA new.
	obj b: 'string'.
	obj b: #string! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:47:13.763'!
testStringsMagnitudesAndObjects
	| jm |
	jm := SHClassA new.
	self
		assert: (jm strings: 'hi' magnitudes: $E andObjects: 23 index: 1) = 'hi';
		assert: (jm strings: #ho magnitudes: #eep -> #oop andObjects: 'xyz' index: 1) = #ho;
		assert: (jm strings: #'a b c' magnitudes: DateAndTime current andObjects: nil index: 3) = nil;
		assert: (jm strings: 'Yo!!' magnitudes: TimeStamp now andObjects: self index: 3) = self! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:51:33.811'!
testSuper

	self assert: SHClassSubB2 new mark = '?'.! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:47:17.667'!
testTraceMethodExecution

	self assert: (SHClassA new sayHelloTo: 'world') = 'Hello world!!'
	! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:47:20.37'!
testTraceMethodExecutionWithBlock

	self assert: (SHClassA new concatTwoStrings: [:str1 :str2 | str1, ' ', str2, '!!']) = 'Hello world!!'
	! !

!SHarvestingSandboxTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:47:22.984'!
testTraceMethodExecutionWithCondition

	| str |
	'1' = 1 asString
		ifTrue: [str := SHClassA new sayHelloTo: 'world']
		ifFalse: [str := 'Germany'].
	self assert: str = 'Hello world!!'.
	! !

TestCase subclass: #SPathFinderTest
	instanceVariableNames: 'oldCurrentProject browserModel browserMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathFinder'!

!SPathFinderTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserModel
	"Answer the value of browserModel"

	^ browserModel! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserModel: anObject
	"Set the value of browserModel"

	browserModel := anObject! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserMorph
	"Answer the value of browserMorph"

	^ browserMorph! !

!SPathFinderTest methodsFor: 'accessing' stamp: 'mp 1/31/2010 18:59'!
browserMorph: anObject
	"Set the value of browserMorph"

	browserMorph := anObject! !

!SPathFinderTest methodsFor: 'testing' stamp: 'mp 7/8/2010 17:20:53.514'!
setUp

	oldCurrentProject := SProject current.
	SProject setCurrent: #sandbox.
	self browserModel: SPathFinder new.
	self browserMorph: (ToolBuilder build: self browserModel).
		
	! !

!SPathFinderTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:35.567'!
tearDown

	SProject setCurrentProject: oldCurrentProject.! !

SPathFinderTest subclass: #SPathFinderTestChooserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathFinder'!

!SPathFinderTestChooserTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathFinderTestChooserTest methodsFor: 'accessing' stamp: 'mp 3/12/2010 17:18'!
getTestModel
	
	^ self browserModel testChooserModel! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:56:42.539'!
testAnalyzeTest

	self assert: self getTestModel result isNil.
	self assert: self browserModel callTreeModel rootNode isNil.
	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self getTestModel analyzeTest.
	self assert: self getTestModel result hasPassed.
	self assert: self browserModel callTreeModel rootNode notNil.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:56:44.697'!
testDeselectTest

	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self getTestModel setCurrentTest: nil.
	self assert: self browserModel callTreeModel rootNode isNil.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:33:52.501'!
testRerunTestButtonEnabled

	self deny: self getTestModel isTestAvailable.
	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: self getTestModel isTestAvailable.
	self getTestModel setCurrentTest: nil.
	self deny: self getTestModel isTestAvailable.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:56:48.246'!
testSelectAnotherTest

	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: self browserModel callTreeModel rootNode clientSelector == #testDoNothing.
	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testBinary).
	self assert: self browserModel callTreeModel rootNode clientSelector == #testBinary.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 3/14/2010 14:05'!
testSelectProfiling

	self assert: self getTestModel tracer profilingMode == #normal.
	self getTestModel normalRunWithCounts.
	self assert: self getTestModel tracer profilingMode == #counts.
	self getTestModel profileRunWithMs.
	self assert: self getTestModel tracer profilingMode == #ms.
	self getTestModel profileRunWithPercentage.
	self assert: self getTestModel tracer profilingMode == #%.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:56:51.893'!
testSelectTest

	self getTestModel setCurrentTest: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: self browserModel callTreeModel rootNode notNil.
	self getTestModel setCurrentTest: nil.
	self assert: self browserModel callTreeModel rootNode isNil.! !

!SPathFinderTestChooserTest methodsFor: 'testing' stamp: 'mp 3/14/2010 14:04'!
testSelectView

	self assert: self getTestModel tracer viewMode == #classes.
	self getTestModel selectObjectView.
	self assert: self getTestModel tracer viewMode == #objects.
	self getTestModel selectIdentityView.
	self assert: self getTestModel tracer viewMode == #identities.! !

SPathFinderTest subclass: #SPathFinderToolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathFinder'!

!SPathFinderToolTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathFinderToolTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:57:25.348'!
testModelCreation

	self assert: self browserModel notNil.
	self assert: self browserModel callTreeTracer notNil.
	self assert: self browserModel callTreeModel notNil.
	self assert: self browserModel testChooserModel notNil.
	
	self assert: self browserModel callTreeTracer selectedCategories = 
		SProject current categories.
	self assert: self browserModel callTreeTracer callTreeModel == 
		self browserModel callTreeModel.
	self assert: self browserModel callTreeModel tracer == 
		self browserModel callTreeTracer.
	self assert: self browserModel testChooserModel tracer == 
		self browserModel callTreeTracer.! !

!SPathFinderToolTest methodsFor: 'testing' stamp: 'mp 12/9/2013 13:06:23.993'!
testMorphCreation

	self assert: self browserMorph notNil.
	
	self assert: (self browserMorph submorphs at: 1) class == SActionButtonIconMorph.
	self assert: (self browserMorph submorphs at: 1) actionModel == self browserModel callTreeModel.
	self assert: (self browserMorph submorphs at: 1) balloonText = 'step to sender'.
	self assert: (((self browserMorph submorphs at: 1) iconForm asGrayScale2) bits 		hasEqualElements: UiFugueIcons arrowTurn090Icon asGrayScale2 bits).
	
	self assert: (self browserMorph submorphs at: 2) class == SActionButtonIconMorph.
	self assert: (self browserMorph submorphs at: 2) actionModel == self browserModel callTreeModel.
	self assert: (self browserMorph submorphs at: 2) balloonText = 'step back'.
	self assert: ((self browserMorph submorphs at: 2) iconForm asGrayScale2 bits
		hasEqualElements: (UiFugueIcons arrowStepOverIcon 
								flipBy: #horizontal centerAt: 8@8) asGrayScale2 bits).

	self assert: (self browserMorph submorphs at: 3) class == SActionButtonIconMorph.
	self assert: (self browserMorph submorphs at: 3) actionModel == self browserModel callTreeModel.
	self assert: (self browserMorph submorphs at: 3) balloonText = 'step return'.
	self assert: ((self browserMorph submorphs at: 3) iconForm asGrayScale2 bits hasEqualElements: UiFugueIcons arrowTurn090LeftIcon asGrayScale2 bits).
	
	self assert: (self browserMorph submorphs at: 4) class == SActionButtonIconMorph.
	self assert: (self browserMorph submorphs at: 4) actionModel == self browserModel callTreeModel.
	self assert: (self browserMorph submorphs at: 4) balloonText = 'step into'.
	self assert: ((self browserMorph submorphs at: 4) iconForm asGrayScale2 bits
				hasEqualElements: UiFugueIcons arrowStepIcon asGrayScale2 bits).

	self assert: (self browserMorph submorphs at: 5) class == SActionButtonIconMorph.
	self assert: (self browserMorph submorphs at: 5) actionModel == self browserModel callTreeModel.
	self assert: (self browserMorph submorphs at: 5) balloonText = 'step over'.
	self assert: ((self browserMorph submorphs at: 5) iconForm asGrayScale2 bits
				hasEqualElements: UiFugueIcons arrowStepOverIcon asGrayScale2 bits).

	self assert: (self browserMorph submorphs at: 6) class == SDropDownMorph.
	self assert: (self browserMorph submorphs at: 6) actionModel == self browserModel testChooserModel.	
	self assert: (self browserMorph submorphs at: 6) labelMorph contents = 'Without Profiling'.
	
	self assert: (self browserMorph submorphs at: 7) class == SDropDownMorph.
	self assert: (self browserMorph submorphs at: 7) actionModel == self browserModel testChooserModel.
	self assert: (self browserMorph submorphs at: 7) labelMorph contents = 'Class View'.

	self assert: (self browserMorph submorphs at: 8) class == STestResultFeedbackMorph.
	self assert: (self browserMorph submorphs at: 8) actionModel == self browserModel.

	"9 is an alignemnt morph"

	self assert: (self browserMorph submorphs at: 10) class == PluggableTextMorphPlus.
	self assert: (self browserMorph submorphs at: 10) knownName = 'searchInputField'.
	self assert: (self browserMorph submorphs at: 10) model == 
		self browserModel callTreeModel.

	self assert: (self browserMorph submorphs at: 11) class == SPluggableTreeMorph.
	self assert: (self browserMorph submorphs at: 11) knownName = 'callTree'.
	self assert: (self browserMorph submorphs at: 11) model == 
		self browserModel callTreeModel.

	self flag: #mpe.	"TODO: feedback morph is new and needs more tests"! !

TestCase subclass: #SProjectTest
	instanceVariableNames: 'oldRegistry oldCurrentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SProjectTest subclass: #SPathMapTest
	instanceVariableNames: 'testRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SPathMapTest subclass: #SPathMapCreationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapCreationTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 14:21:16.66'!
test01PathMapLabel

	self assert: self testRunner label = 'PathMap'.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 14:23:45.465'!
test02CheckSelectedTestClasses
	| listMorph |
	listMorph := self testRunner findA: PluggableListMorphOfMany.
	self assert: listMorph notNil.
	self assert: (listMorph instVarNamed: 'list') = #('SSBFaultLocalizationExampleTest' 
													'SSBFaultLocalizationTest' 
													'SSBTest' 
													'SSBTypeTest' 
													'SSBValueRangeTest')! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 14:27:03.786'!
test03TestRunnerButtons
	| button | 
	button := self findButtonLabeled: 'Run Selected'.
	self 
		assert: button notNil;
		assert: button enabled.
	{'Run with Contracts'. 'Run Failures'. 'Run Errors'} do: [:each | 
		button := self findButtonLabeled: each.
		self 
			assert: button notNil;
			deny: button enabled].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 11:47:51.612'!
test04TestRunnerResultsText
	self checkTestResults: '0 run, 0 passes, 0 expected failures, 0 failures, 0 errors, 0 unexpected passes'.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/17/2013 11:44:37.174'!
test05ProjectMetricsText
	self checkTestResults: '1 Categories, 11 Classes, and 96 Methods (324 LoC) '.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 14:33:01.142'!
test06BuildingOfAdditionalFlaps
	| flap |
	{'globalOptions'. 'traceability'. 'inductive'. 'faultLocalization'. 'profiling'. 'testQuality'}	
		do: [:each | 
			flap := self testRunner submorphNamed: each.
			self 
				assert: flap class = SPluggableFlapMorph;
				deny: flap expandedFlap].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 15:35:34.418'!
test07aTreeMapCreationFindRootMorph
	| rootMorph | 
	rootMorph := self testRunner findA: SPMRootMorph.
	self assert: rootMorph notNil.
	self assert: rootMorph lineMorph notNil.
	self assert: rootMorph == self testRunner model pathMap rootMorph.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 15:02:29.303'!
test07bTreeMapCreationCategoryMorph
	| rootMorph categoryMorph | 
	rootMorph := self testRunner findA: SPMRootMorph.
	categoryMorph := rootMorph submorphNamed: 'Path-Tests-Sandbox'.
	self assert: categoryMorph notNil. 
	self assert: categoryMorph sourceCodeEntity =  #'Path-Tests-Sandbox'.
	categoryMorph childrenMorphs do: [:each | 
		self assert: each sourceCodeEntity isBehavior]! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/28/2013 16:40:45.441'!
test07cTreeMapCreationClassAndMethodMorphs
	| rootMorph classMorph | 
	rootMorph := self testRunner findA: SPMRootMorph.
	classMorph := (rootMorph childrenMorphs at: #'Path-Tests-Sandbox')
						submorphNamed: 'SSBClassA'.
	self 
		assert: classMorph notNil;
		assert: classMorph childrenMorphs size = 1.
	(classMorph childrenMorphs at: #'no category') traverseAllChildsAndDo: [:each | 
		self assert: (classMorph sourceCodeEntity >> each sourceCodeEntity) 
			isCompiledMethod].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/15/2013 15:07:02.121'!
test07dTreeMapCreationAllMorphsAreWhite
	| rootMorph | 
	rootMorph := self testRunner findA: SPMRootMorph.
	rootMorph allMorphsDo: [:each | 
		(each class inheritsFrom: SPMPathMapMorph)
			ifTrue: [self assert: each color = Color white]].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 8/6/2013 13:25:24.125'!
test08ResizePathMap

	self deny: self testRunner extent =  (200@200).
	self testRunner extent: (200@200).
	self assert: self testRunner extent =  (200@200).! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 10:32:56.059'!
test09aCheckHalosForClassMorphBrowseClass
	| classMorph menuMorph browserMorph |
	classMorph := self classMorph: SSBClassA.
	menuMorph := self activateMenuFor: classMorph.
	self pushButton: #browse on: menuMorph.
	browserMorph := World findDeepSubmorphThat: [:each | 
		(each class = PluggableSystemWindow and: 
		[each model isKindOf: Browser]) and: 
		[(each model selectedClassName = #SSBClassA) and: 
			[each model selectedMessageCategoryName isNil]]] ifAbsent: nil.
	self assert: browserMorph notNil.
	browserMorph abandon.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 10:32:52.193'!
test09bCheckHalosForClassMorphExpandChildrenMorphs
	| classMorph menuMorph expandedMorph |
	classMorph := self classMorph: SSBClassA.
	menuMorph := self activateMenuFor: classMorph.
	self pushButton: #expandChildren on: menuMorph.
	expandedMorph := World findDeepSubmorphThat: [:each | 
		(each class = SPMExpandRootMorph and: 
		[each targetMorph = classMorph])] ifAbsent: nil.
	self assert: expandedMorph notNil.
	expandedMorph abandon.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/17/2013 14:13:44.271'!
test10aCheckHalosForMethodMorphBrowseMethod
	| methodMorph menuMorph browserMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBClassA selector: #initialize).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #browse on: menuMorph.
	browserMorph := self findBrowserFor: #SSBClassA -> #initialize.
	browserMorph abandon.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 13:48:37.909'!
test10bCheckHalosForMethodMorphStartPathFinder
	| methodMorph menuMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBClassA selector: #initialize).
	menuMorph := self activateMenuFor: methodMorph.
	[self pushButton: #pathfinderMethod on: menuMorph] 
		on: ProvideAnswerNotification
		do: [: notification | self assert: notification messageText = 
							'No covering test found.'].
! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 13:48:42.241'!
test10cCheckHalosForMethodMorphStartDebugger
	| methodMorph menuMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBClassA selector: #initialize).
	menuMorph := self activateMenuFor: methodMorph.
	[self pushButton: #debugMethod on: menuMorph] 
		on: ProvideAnswerNotification
		do: [: notification | self assert: notification messageText = 
							'No covering test found.'].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/17/2013 14:10:55.562'!
test11aCheckHalosForTestMethodMorphBrowseMethod
	| methodMorph menuMorph browserMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #browse on: menuMorph.
	browserMorph := self findBrowserFor: #SSBTest -> #testDoNothing.
	browserMorph abandon.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 13:49:08.468'!
test11bCheckHalosForTestMethodMorphRunSingleTest
	| methodMorph menuMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #rerunTest on: menuMorph.
	self checkTestResults: '1 run, 1 passes, 0 expected failures, 0 failures, 0 errors, 0 unexpected passes'.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 13:49:19.994'!
test11cCheckHalosForTestMethodMorphStartPathFinder
	| methodMorph menuMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	[self pushButton: #pathfinderMethod on: menuMorph] 
		on: ProvideAnswerNotification
		do: [: notification | self assert: notification messageText = 
							'No covering test found.'].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/16/2013 13:49:25.551'!
test11dCheckHalosForTestMethodMorphStartDebugger
	| methodMorph menuMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	[self pushButton: #debugMethod on: menuMorph] 
		on: ProvideAnswerNotification
		do: [: notification | self assert: notification messageText = 
							'No covering test found.'].! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 17:26:35.501'!
test12CheckHalosForMethodCategoryMorphBrowse
	| menuMorph browserMorph categoryMorph |
	(self pathMap options at: #globalOptions) switchShowMethodCategories.
	categoryMorph := (self classMorph: SSBClassA) childrenMorphs at: #accessing.
	menuMorph := self activateMenuFor: categoryMorph.
	self pushButton: #browse on: menuMorph.
	browserMorph := World findDeepSubmorphThat: [:each | 
		(each class = PluggableSystemWindow and: 
		[each model isKindOf: Browser]) and: 
		[(each model selectedClassName = #SSBClassA) and: 
			[each model selectedMessageCategoryName isNil]]] ifAbsent: nil.
	self assert: browserMorph notNil.
	browserMorph abandon.! !

!SPathMapCreationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 17:29:55.425'!
test13CheckHalosForCategoryMorphBrowse
	| menuMorph browserMorph categoryMorph |
	categoryMorph := (self classMorph: SSBClassA) parentMorph.
	menuMorph := self activateMenuFor: categoryMorph.
	self pushButton: #browse on: menuMorph.
	browserMorph := World findDeepSubmorphThat: [:each | 
		(each class = PluggableSystemWindow and: 
		[each model isKindOf: Browser]) and: 
		[(each model selectedSystemCategory = #'Path-Tests-Sandbox') and: 
			[each model selectedClassName isNil]]] ifAbsent: nil.
	self assert: browserMorph notNil.
	browserMorph abandon.! !

SPathMapTest subclass: #SPathMapFlapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapFlapTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SPathMapFlapTest subclass: #SPathMapFaultLocalizationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapFaultLocalizationTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapFaultLocalizationTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:33:25.867'!
analysisSymbol
	^ #faultLocalization! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:59:25.854'!
test01aRunAllTestsWithOpenFlap
	<timeout: 10>
	self runAllTests.
	self checkTestResults: '52 run, 49 passes, 0 expected failures, 3 failures, 0 errors, 0 unexpected passes'.
	self checkTestResults: '1 Categories, 11 Classes, and 96 Methods (324 LoC) '! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:33:57.886'!
test01bRunSelectedTestsWithOpenFlap
	<timeout: 10>
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests;
		checkTestResults: '6 run, 5 passes, 0 expected failures, 1 failures, 0 errors, 0 unexpected passes'.
	self 
		assert: (self options getLabelString: 0.1@0.1) = '10% suspicious
100% confidence';
		assert: (self options getLabelString: 0.9@0.9) = '90% suspicious
11% confidence'.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:53:40.925'!
test02OchiaiMetricWithSelectedTest
	<timeout: 10>
	|  highscore morph |
	self options setFormula: #ochiai.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	self 
		assert: morph color = (Color r: 0.816 g: 1.0 b: 0.0);
		assert: morph additionalInfo = 'SSBFaultLocalizationExample midX:Y:Z:
5 out of 5 passed tests
1 out of 1 failed tests
Suspiciousness value: 40%
Single point of failure probability: 40%
'.	
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 4;
		assert: highscore rootObject first value first < 0.45;
		assert: highscore rootObject first value second > 0.99.		
	highscore dependents first abandon.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:55:05.21'!
test03TarantulaMetricWithSelectedTest
	<timeout: 10>
	| highscore morph |
	self options setFormula: #tarantula.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	self 
		assert: morph color = Color yellow;
		assert: morph additionalInfo = 'SSBFaultLocalizationExample midX:Y:Z:
5 out of 5 passed tests
1 out of 1 failed tests
Suspiciousness value: 50%
Single point of failure probability: 50%
'.	
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 4;
		assert: highscore rootObject first value first <= 0.5;
		assert: highscore rootObject first value second > 0.99.		
	highscore dependents first abandon.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:55:18.267'!
test04JaccardMetricWithSelectedTest
	<timeout: 10>
	| highscore morph |
	self options setFormula: #jaccard.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	self 
		assert: morph color = (Color r: 0.333 g: 1.0 b: 0.0);
		assert: morph additionalInfo = 'SSBFaultLocalizationExample midX:Y:Z:
5 out of 5 passed tests
1 out of 1 failed tests
Suspiciousness value: 16%
Single point of failure probability: 16%
'.	
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 4;
		assert: highscore rootObject first value first < 0.17;
		assert: highscore rootObject first value second > 0.99.		
	highscore dependents first abandon.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:34:43.008'!
test05SingleFaultFilterWithOchiai
	<timeout: 10>
	| morph |
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	self assert: morph color = (Color r: 0.824 g: 1.0 b: 0.667).
	self options switchSinglePointOfFault.
	self assert: morph color = Color white.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:34:53.488'!
test06aDeveloperRankingMethodCreator
	<timeout: 10>
	self options setFormula: #ochiai.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	[self options authorRanking] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignore].
	self assert: (self pathMap tracer mostOpportuneAuthorsWith: #authorFirstChange) first key = 'mp'.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:35:00.984'!
test06bDeveloperRankingMostChanges
	<timeout: 10>
	self options setFormula: #ochiai.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	[self options authorRanking] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignore].
	self assert: (self pathMap tracer mostOpportuneAuthorsWith: #authorMostChanges) first key = 'mp'.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:35:11.058'!
test06cDeveloperRankingLastChange
	<timeout: 10>
	self options setFormula: #ochiai.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	[self options authorRanking] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignore].
	self assert: (self pathMap tracer mostOpportuneAuthorsWith: #authorLastChange) first key = 'mp'.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:35:17.656'!
test06dDeveloperRankingFrequencyAndRecency
	<timeout: 10>
	self options setFormula: #ochiai.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	[self options authorRanking] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignore].
	self assert: (self pathMap tracer mostOpportuneAuthorsWith: #authorRecentChanges) first key = 'mp'.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 5/21/2013 15:00:27.525'!
test07RefinementOfFaultLocalizationAtStatements
	<timeout: 10>
	| morph browser highlights |
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.	
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	morph browse.
	browser := self findBrowserFor: #SSBFaultLocalizationExample -> #midX:Y:Z:.
	highlights := browser model codePane text runs 
		select: [:each | each includes: TextEmphasis underlined].
	self 
		assert: highlights size = 134;
		assert: (highlights at: 74) first color = (Color r: 1.0 g: 0.586 b: 0.0).
	browser abandon.	! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 8/8/2013 15:26:35.165'!
test08StartPathFinderWithFaultResults
	<timeout: 20>
	| methodMorph menuMorph pathFinder morph |
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.	
	methodMorph := self methodMorph: (MethodReference 
											class: SSBFaultLocalizationExampleTest
											selector: #test213).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #pathfinderMethod on: menuMorph.
	pathFinder := self findPathfinderFor: SSBFaultLocalizationExampleTest -> #test213.
	morph := (pathFinder findA: SPluggableTreeMorph) scroller submorphs second.
	self 
		assert: morph notNil;
		assert: morph contents = '{40%} SSBFaultLocalizationExampleTest>>setUp';
		assert: morph icon bits first =  4291886848.
	pathFinder abandon.		! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 8/8/2013 17:36:10.543'!
test09aStartBrowserWithFaultLocalizationIcons
	<timeout: 10>
	| morph browser |
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.	
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	morph browse.
	browser := self findBrowserFor: #SSBFaultLocalizationExample -> #midX:Y:Z:.
	self 
		assert: browser model methodColors notNil;
		assert: browser model methodColors notEmpty;
		assert: (browser model methodColors 
				at: (MethodReference 
					class: SSBFaultLocalizationExample 
					selector:#midX:Y:Z:)) = 
				(Color r: 0.816 g: 1 b: 0.0);
		assert: ((browser model iconForMessage: 1) colorAt: 10@10) = 
				(Color r: 0.815 g: 1 b: 0.0);
		assert: ((browser model iconForClass: 7) colorAt: 10@10) = 
				Color yellow.
	browser abandon.! !

!SPathMapFaultLocalizationTest methodsFor: 'testing' stamp: 'mp 8/8/2013 17:36:02.503'!
test09bStartBrowserWithFaultLocalizationIconsFromPathFinder
	<timeout: 10>
	| menuMorph methodMorph pathFinder morph browser |
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.	
	methodMorph := self methodMorph: (MethodReference 
											class: SSBFaultLocalizationExampleTest
											selector: #test213).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #pathfinderMethod on: menuMorph.
	pathFinder := self findPathfinderFor: SSBFaultLocalizationExampleTest -> #test213.
	morph := (pathFinder findA: SPluggableTreeMorph) scroller submorphs second.
	self assert: (morph icon colorAt: 1@1) =  (Color r: 0.815 g: 1 b: 0.0).
	pathFinder model callTreeModel browseMethod.
	pathFinder abandon.
	browser := self findBrowserFor: #SSBFaultLocalizationExampleTest -> #test213.
	self 
		assert: browser model methodColors notNil;
		assert: browser model methodColors notEmpty;
		assert: (browser model methodColors 
				at: (MethodReference 
					class: SSBFaultLocalizationExampleTest 
					selector:#test213)) = 
				Color yellow;
		assert: ((browser model iconForMessage: 2) colorAt: 10@10) = 
				Color yellow;
		assert: ((browser model iconForClass: 7) colorAt: 10@10) = 
				Color yellow.
	browser abandon.! !

!SPathMapFlapTest class methodsFor: 'testing' stamp: 'mp 5/22/2013 11:49:40.562'!
shouldInheritSelectors
	^ false! !

!SPathMapFlapTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:30:59.205'!
analysisSymbol
	self subclassResponsibility.! !

!SPathMapFlapTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:31:32.78'!
flap: aSymbol
	^ self testRunner model getFlap: aSymbol! !

!SPathMapFlapTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:31:46.191'!
options 
	^ self options: self analysisSymbol! !

!SPathMapFlapTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:31:55.843'!
options: aSymbol
	^ self pathMap options at: aSymbol! !

!SPathMapFlapTest methodsFor: 'running' stamp: 'mp 5/22/2013 11:30:37.345'!
setUp
	super setUp.
	(self testRunner model getFlap: self analysisSymbol) switchExpandState.! !

SPathMapFlapTest subclass: #SPathMapGlobalOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapGlobalOptionsTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapGlobalOptionsTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:25:19.876'!
analysisSymbol
	^ #globalOptions! !

!SPathMapGlobalOptionsTest methodsFor: 'running' stamp: 'mp 5/21/2013 16:57:58.069'!
analyzeTestQuality
	(self testRunner model getFlap: #testQuality) switchExpandState.! !

!SPathMapGlobalOptionsTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:29:05.57'!
test01DefaultConfiguration
	self 
		deny: self options showMethodCategories;
		deny: self options showAllMethods;
		deny: self options ignoreTracingOfSetUpAndTearDownMethods;
		assert: self options visualizeIntermediateSteps;
		assert: self options showTestResults.! !

!SPathMapGlobalOptionsTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:29:15.505'!
test02ShowMethodCategories
	| morph |
	morph := self classMorph: SSBClassA.
	self 
		assert: morph childrenMorphs size = 1;
		assert: (morph childrenMorphs at: #'no category') class = SPMAllMethodCategoriesMorph.
	self options switchShowMethodCategories.
	morph := self classMorph: SSBClassA.
	self 
		assert: morph childrenMorphs size = 3;
		assert: (morph childrenMorphs at: #accessing) class = SPMMethodCategoryMorph.! !

!SPathMapGlobalOptionsTest methodsFor: 'testing' stamp: 'mp 5/28/2013 16:55:14.88'!
test03ShowAllMethods
	| morph  |
	morph := self classMorph: SSBClassA.
	self assert: (morph childrenMorphs at: #'no category') childrenMorphs size = 11.
	self options switchShowAllMethods.
	morph := self classMorph: SSBClassA.
	self assert: (morph childrenMorphs at: #'no category') childrenMorphs size = 14.
! !

!SPathMapGlobalOptionsTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:29:31.239'!
test04IgnoreSetupCodeDuringTracing
	<timeout: 10>
	self 
		analyzeTestQuality;
		runAllTests.
	self checkTestResults: '1 Categories, 11 Classes, and 96 Methods (324 LoC) --- 97.92% covered'.
	self options switchIgnoreTracingOfSetUpAndTearDownMethods.
	self runAllTests.
	self checkTestResults: '1 Categories, 11 Classes, and 96 Methods (324 LoC) --- 89.58% covered'.! !

!SPathMapGlobalOptionsTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:29:42.107'!
test05VisualizeIntermediatedSteps
	| runTimeWithIntermediate start |
	start := DateAndTime now.
	self 
		analyzeTestQuality;
		runAllTests.
	runTimeWithIntermediate := DateAndTime now - start.
	self options switchVisualizeIntermediateSteps.
	start := DateAndTime now.
	self 
		analyzeTestQuality;
		runAllTests.
	self assert: runTimeWithIntermediate > (DateAndTime now - start).	! !

!SPathMapGlobalOptionsTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:29:51.355'!
test06ShowTestResults
	<timeout: 10>
	| morph |
	self 
		analyzeTestQuality;
		runAllTests.
	morph := self methodMorph: (MethodReference class: SSBTest selector: #testDoNothing).
	self assert: morph color = (Color r: 0.0 g: 0.5 b: 0.0).
	self options switchShowTestResults.
	self runAllTests.
	self assert: morph color = Color gray.! !

SPathMapFlapTest subclass: #SPathMapInductiveAnalysisTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapInductiveAnalysisTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapInductiveAnalysisTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:24:27.663'!
analysisSymbol
	^ #inductive! !

!SPathMapInductiveAnalysisTest methodsFor: 'testing' stamp: 'mp 5/21/2013 15:58:01.713'!
test01RunAllTestsWithOpenFlap
	self should: [self runAllTests] raise: ProvideAnswerNotification.! !

!SPathMapInductiveAnalysisTest methodsFor: 'testing' stamp: 'mp 7/12/2013 12:01:03.793'!
test02TypeHarvestingWithAllTests
	<timeout: 20>
	|  morph | 
	self options setKindOfAnalysis: STypeHarvester.
	self runAllTests.
	self assert: (SProject current harvestedBuckets at: #STypeHarvester) class = SMonoTypeBucket.
	self 
		assert: (self options getLabelString: 0.1@0.1) = 'No types available';
		assert: (self options getLabelString: 0.9@0.9) = 'Harvested types'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph color =  Color gray;
		assert: morph additionalInfo = 'temporary types
Number
return type
Number
'.! !

!SPathMapInductiveAnalysisTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:28:20.148'!
test03ValueRangeHarvestingWithAllTests
	<timeout: 20>
	| morph | 
	self options setKindOfAnalysis: SValueRangeHarvester.
	self runAllTests.
	self assert: (SProject current harvestedBuckets at: #SValueRangeHarvester) class = SValueRangeBucket.
	self 
		assert: (self options getLabelString: 0.1@0.1) = 'No value ranges available';
		assert: (self options getLabelString: 0.9@0.9) = 'Strings'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph additionalInfo = (Dictionary newFrom: 
	{#Method -> 'SSBClassA +'. 
	#Return -> (SNumbersRangeProperties new constantValue: false; range: (2.3 to: 10); positive: true; yourself). 
	#Temporaries -> {(SNumbersRangeProperties new constantValue: false; range: (2.3 to: 5); positive: true; yourself)}}).! !

!SPathMapInductiveAnalysisTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:28:38.187'!
test04CreationOfContracts
	<timeout: 30>
	self options setKindOfAnalysis: STypeHarvester.
	self deny: self options isAddingContractsPossible.
	self runAllTests.
	self options setKindOfAnalysis: SValueRangeHarvester.
	self runAllTests.
	self 
		assert: (SProject current harvestedBuckets at: #STypeHarvester) class = 
			SMonoTypeBucket;
		assert: (SProject current harvestedBuckets at: #SValueRangeHarvester) class = 
			SValueRangeBucket.
	self 
		assert: self options isAddingContractsPossible;
		deny: self options isRemovingContractsPossible.
	[self options addContracts.
	self 
		deny: self options isAddingContractsPossible;
		assert: self options isRemovingContractsPossible.
	] ensure: [self options removeContracts].! !

!SPathMapInductiveAnalysisTest methodsFor: 'testing' stamp: 'mp 5/28/2013 16:54:27.962'!
test05RunAllTestsWithContracts
	<timeout: 30>
	| morph violation |
	self options setKindOfAnalysis: STypeHarvester.
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.
	self options setKindOfAnalysis: SValueRangeHarvester.
	self runAllTests.
	[self options addContracts.
	self runAllTestsWithContracts.
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	self assert: morph violations notEmpty.
	violation := morph violations sortedElements first key.
	self
		assert: violation class = SRangeContractViolation;
		assert: violation givenObject = 1;
		assert: violation expectedMin = 2.
	] ensure: [self options removeContracts.].! !

SPathMapFlapTest subclass: #SPathMapProfilingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapProfilingTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapProfilingTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:23:19.834'!
analysisSymbol
	^ #profiling! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 5/21/2013 10:21:06.15'!
test01RunAllTestsWithOpenFlap
	<timeout: 20>
	self runAllTests.
	self checkTestResults: '52 run, 49 passes, 0 expected failures, 3 failures, 0 errors, 0 unexpected passes'.
	self checkTestResults: '1 Categories, 11 Classes, and 96 Methods (324 LoC) '.! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:55:49.858'!
test02MethodCallsOfAllTests
	<timeout: 20>
	|  morph highscore |
	self options setKindOfProfiling: #numberOfMethodCalls.
	self runAllTests.
	self 
		assert: (self options getLabelString: 0.1@0.1) = '2 method calls';
		assert: (self options getLabelString: 0.9@0.9) = '29 method calls'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self 
		assert: morph color = (Color r: 1.0 g: 0.644 b: 0.0);
		assert: morph additionalInfo = 'SSBClassA initialize
was called 23 times.
'.
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 94;
		assert: highscore rootObject first = 
					(42 -> (MethodReference class: SSBTest selector: #a)).
	highscore dependents first abandon.! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:56:09.534'!
test03InstanceCountOfAllTests
	<timeout: 20>
	|  morph highscore |
	self options setKindOfProfiling: #numberOfInstances.
	self runAllTests.
	self 
		assert: (self options getLabelString: 0.1@0.1) = '2 instances';
		assert: (self options getLabelString: 0.9@0.9) = '19 instances'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self deny: morph visible.
	morph := self classMorph: SSBClassA.
	self 
		assert: morph color = (Color r: 1.0 g: 0.151 b: 0.0);
		assert: morph additionalInfo = 'SSBClassA
23 objects were created.
'.
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 11;
		assert: highscore rootObject first = 
					(26 -> (MethodReference class: SSBClassD class selector: #basicNew)).
	highscore dependents first abandon.! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:56:18.794'!
test04aRunTimeFromAllTests
	<timeout: 30>
	| morph highscore |
	self options setKindOfProfiling: #runtime.
	self deny: self options leafProfiling.
	self runAllTests.
	self 
		assert: (self options getLabelString: 0.0@0.1) =  '1 ns';
		assert: (self options getLabelString: 1.0@0.9) asInteger >  98000000.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #delayedMethod).
	self 
		assert: morph color red = 1.0;
		assert: (morph additionalInfo startsWith: 'SSBClassA delayedMethod
required ');
		assert: morph additionalInfo asInteger > 98.
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 94;
		assert: highscore rootObject first key nanoSeconds > 98000000.
	highscore dependents first abandon.! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:56:08.233'!
test04bRunTimeLeafsFromAllTests
	<timeout: 30>
	| morph highscore |
	self options 
		setKindOfProfiling: #runtime;
		switchLeafProfilingRuntime.
	self assert: self options leafProfiling.
	self runAllTests.
	self 
		assert: (self options getLabelString: 0.0@0.1) =  '1 ns';
		assert: (self options getLabelString: 1.0@0.9) asInteger >  98000000.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #delayedMethod).
	self 
		assert: morph color red = 1.0;
		assert: (morph additionalInfo startsWith: 'SSBClassA delayedMethod
required ');
		assert: morph additionalInfo asInteger > 98.
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 94;
		assert: highscore rootObject first key nanoSeconds > 98000000.
	highscore dependents first abandon.! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:54:59.544'!
test05aRunTimePerCallFromAllTests
	<timeout: 30>
	| morph highscore |
	self options setKindOfProfiling: #runtimePerCall.
	self deny: self options leafProfiling.
	self runAllTests.
	self 
		assert: (self options getLabelString: 0.0@0.1) = '1 ns per call';
		assert: (self options getLabelString: 1.0@0.9) asInteger >  98000000.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #delayedMethod).
	self 
		assert: morph color red = 1.0;
		assert: (morph additionalInfo startsWith: 'SSBClassA delayedMethod
required ');
		assert: morph additionalInfo asInteger > 98.
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 94;
		assert: highscore rootObject first key > 99.
	highscore dependents first abandon.! !

!SPathMapProfilingTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:55:09.63'!
test05bRunTimePerCallLeafsFromAllTests
	<timeout: 30>
	| morph highscore |
	self options 
		setKindOfProfiling: #runtimePerCall;
		switchLeafProfilingRuntime.
	self assert: self options leafProfiling.
	self runAllTests.
	self 
		assert: (self options getLabelString: 0.0@0.1) =  '1 ns per call';
		assert: (self options getLabelString: 1.0@0.9) asInteger >  98000000.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #delayedMethod).
	self 
		assert: morph color red = 1.0;
		assert: (morph additionalInfo startsWith: 'SSBClassA delayedMethod
required ');
		assert: morph additionalInfo asInteger > 98.
	highscore := self options showHighscore.
	self 
		assert: highscore notNil;
		assert: highscore rootObject size = 94;
		assert: highscore rootObject first key > 99.
	highscore dependents first abandon.! !

SPathMapFlapTest subclass: #SPathMapTestQualityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapTestQualityTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapTestQualityTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:13:48.151'!
analysisSymbol
	^ #testQuality! !

!SPathMapTestQualityTest methodsFor: 'helper' stamp: 'mp 5/22/2013 11:14:14.165'!
getOptionWithAuthorMetric: aSymbol
	[self options staticMetricAuthors] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignoreMenu].
	self options staticCodeMetric metric: #authorFirstChange.
	self options redrawPathMapIfPossible ifFalse: [self options visualizeStaticMetric].
	^ self options
! !

!SPathMapTestQualityTest methodsFor: 'helper' stamp: 'mp 5/22/2013 11:14:34.933'!
getOptionWithComplexityMetric: aBoolean
	[self options staticMetricComplexity] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignoreMenu].
	self options staticCodeMetric thresholdSelected: aBoolean.
	self options redrawPathMapIfPossible ifFalse: [self options visualizeStaticMetric].
	^ self options
! !

!SPathMapTestQualityTest methodsFor: 'helper' stamp: 'mp 5/22/2013 11:14:50.781'!
getOptionWithLinesOfCodeMetric: aBoolean
	[self options staticMetricLinesOfCode] 
		on: ProvideAnswerNotification 
		do: [:notification | notification resume: #ignoreMenu].
	self options staticCodeMetric thresholdSelected: aBoolean.
	self options redrawPathMapIfPossible ifFalse: [self options visualizeStaticMetric].
	^ self options
! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:56:26.83'!
test01RunAllTestsWithOpenFlap
	<timeout: 10>
	self runAllTests.
	self checkTestResults: '52 run, 49 passes, 0 expected failures, 3 failures, 0 errors, 0 unexpected passes'.
	self checkTestResults: '1 Categories, 11 Classes, and 96 Methods (324 LoC) --- 97.92% covered'! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:57:15.508'!
test02RunAllTestsWithMethodCoverage
	<timeout: 10>
	|  morph |
	self options methodCoverage.
	self 
		assert: (self options getLabelString: 0.1@0.1) =  'Method not covered.';
		assert: (self options getLabelString: 0.9@0.9) =  'Method covered.'.
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self 
		assert: morph color =  Color gray;
		assert: morph additionalInfo = 'SSBClassA initialize
'.
	morph := self methodMorph: (MethodReference class: SSBTest selector: #testDoNothing).
	self 
		assert: morph color = (Color r: 0.0 g: 0.5 b: 0.0);
		assert: morph additionalInfo =  'SSBTest testDoNothing
Result: Test passed
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 7/12/2013 11:58:09.304'!
test03aRunAllTestsWithTestIntensity
	<timeout: 10>
	| morph |
	self options intensityCoverage.
	self 
		assert: (self options getLabelString: 0.1@0.1) =  'Method not covered.';
		assert: (self options getLabelString: 0.9@0.9) =  'Method covered by 30 tests.'.
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self 
		assert: morph color =  (Color r: 0.172 g: 0.172 b: 0.172);
		assert: morph additionalInfo =  'SSBClassA initialize
21 test(s) covered this method.
'.
	morph := self methodMorph: (MethodReference class: SSBTest selector: #testDoNothing).
	self 
		assert: morph color = (Color r: 0.0 g: 0.75 b: 0.0);
		assert: morph additionalInfo = 'SSBTest testDoNothing
Result: Test passed
1 test(s) covered this method.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:15:50.541'!
test03bRunAllTestsWithMethodCoverageAndConvertToTestIntensity
	<timeout: 10>
	| morph |
	self options methodCoverage.
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self assert: morph color =  Color gray.
	self options intensityCoverage.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self assert: morph color =  (Color r: 0.172 g: 0.172 b: 0.172).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 8/6/2013 10:45:12.329'!
test04RunAllTestsWithStatementCoverage
	<timeout: 10>
	| morph |
	self options statementCoverage.
	self 
		assert: (self options getLabelString: 0.1@0.1) =  '0% covered statements.';
		assert: (self options getLabelString: 0.9@0.9) =   '86% covered statements.'.
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	self 
		assert: morph color =  Color black;
		assert: morph additionalInfo =  'SSBClassA initialize
100% of statements covered.
'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #complexMethod:).
	self 
		assert: morph color = (Color r: 0.197 g: 0.197 b: 0.197);
		assert: morph additionalInfo =  'SSBClassA complexMethod:
73% of statements covered.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:56:47.582'!
test05RefinementOfStatementCoverage
	<timeout: 10>
	| morph browser |
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #initialize).
	morph browse.
	browser := self findBrowserFor: #SSBClassA -> #initialize.
	self assert: (browser model codePane text runs 
		select: [:each | each includes: TextEmphasis underlined]) size = 10.
	browser abandon.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:56:51.645'!
test06aAuthorMetricMethodCreatorPure
	<timeout: 10>
	| options morph |
	options := self getOptionWithAuthorMetric: #authorFirstChange.
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
Last change by Unknown.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
Last change by mp.'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
	self 
		assert: morph color = (Color r: 0.65 g: 1.0 b: 1.0);
		assert: morph additionalInfo = 'SSBDictionary symbolFor:
Author: Unknown
'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #myValue:).
	self 
		assert: morph color = (Color r: 1.0 g: 0.65 b: 0.65);
		assert: morph additionalInfo = 'SSBDictionary myValue:
Author: mp
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:56:56.701'!
test06bAuthorMetricMethodCreatorWithCoverage
	<timeout: 10>
	| options morph |
	self runAllTests.
	options := self getOptionWithAuthorMetric: #authorFirstChange.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
	self assert: morph color =  (Color r: 0.326 g: 0.5 b: 0.5).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:00.385'!
test07aAuthorMetricMostChangesPure
	<timeout: 10>
	| options morph |
	options := self getOptionWithAuthorMetric: #authorMostChanges.
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
Last change by Unknown.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
Last change by mp.'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
	self 
		assert: morph color = (Color r: 0.65 g: 1.0 b: 1.0);
		assert: morph additionalInfo = 'SSBDictionary symbolFor:
Author: Unknown
'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #myValue:).
	self 
		assert: morph color = (Color r: 1.0 g: 0.65 b: 0.65);
		assert: morph additionalInfo = 'SSBDictionary myValue:
Author: mp
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:04.125'!
test07bAuthorMetricMostChangesWithCoverage
	<timeout: 10>
	| options morph |
	self runAllTests.
	options := self getOptionWithAuthorMetric: #authorMostChanges.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
	self assert: morph color =  (Color r: 0.326 g: 0.5 b: 0.5).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:09.138'!
test08aAuthorMetricLastChangePure
	<timeout: 10>
	| options morph |
	options := self getOptionWithAuthorMetric: #authorLastChange.
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
Last change by Unknown.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
Last change by mp.'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:13.397'!
test08bAuthorMetricLastChangeWithCoverage
	<timeout: 10>
	| options morph |
	self runAllTests.
	options := self getOptionWithAuthorMetric: #authorLastChange.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
	self assert: morph color =  (Color r: 0.326 g: 0.5 b: 0.5).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:17.325'!
test09aAuthorMetricFrequencyPure
	<timeout: 10>
	| options morph |
	options := self getOptionWithAuthorMetric: #authorRecentChanges.	
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
Last change by Unknown.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
Last change by mp.'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:21.305'!
test09bAuthorMetricFrequencyWithCoverage
	<timeout: 10>
	| options morph |
	self runAllTests.
	options := self getOptionWithAuthorMetric: #authorRecentChanges.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #symbolFor:).
	self assert: morph color =  (Color r: 0.326 g: 0.5 b: 0.5).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:16:52.012'!
test10aLastChangeMetricPure
	<timeout: 10>
	| morph |
	self options staticMetricLastChanges.
	self 
		assert: (self options getLabelString: 0.0@0.1) =  'Method not covered.
8 March 2010 last change.';
		assert: (self options getLabelString: 1.0@0.9) = ('Method covered.
', Date today asString, ' last change.').
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #myValue:).
	self assert: morph additionalInfo =  'SSBDictionary myValue:
last change: 5 January 2012 11:55:12 am.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:17:04.435'!
test10bLastChangeMetricWithCoverage
	<timeout: 10>
	| morph |
	self runAllTests.
	self options staticMetricLastChanges.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #myValue:).
	self assert: morph additionalInfo =  'SSBDictionary myValue:
last change: 5 January 2012 11:55:12 am.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:32.792'!
test11aLinesOfCodeMetricPureWithThreshold
	<timeout: 10>
	| options morph |
	options := self getOptionWithLinesOfCodeMetric: true.	
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
<= 7 lines of code.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
> 19 lines of code.'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph color = Color green;
		assert: morph additionalInfo = 'SSBClassA +
2 lines of code.
'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #complexMethod:).
	self 
		assert: morph color = Color yellow;
		assert: morph additionalInfo = 'SSBClassA complexMethod:
9 lines of code.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:37.637'!
test11bLinesOfCodeMetricPureWithoutThreshold
	<timeout: 10>
	| options morph |
	options := self getOptionWithLinesOfCodeMetric: false.
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
2 lines of code.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
9 lines of code.'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph color = (Color r: 0.65 g: 1.0 b: 0.947);
		assert: morph additionalInfo = 'SSBClassA +
2 lines of code.
'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #complexMethod:).
	self 
		assert: morph color = (Color r: 1.0 g: 0.772 b: 0.65);
		assert: morph additionalInfo = 'SSBClassA complexMethod:
9 lines of code.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:17:21.802'!
test11cLinesOfCodeMetricWithCoverageAndThreshold
	<timeout: 10>
	| morph |
	self runAllTests.
	self getOptionWithLinesOfCodeMetric: true.	
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph color =  (Color r: 0.0 g: 0.5 b: 0.0).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:17:32.719'!
test11dLinesOfCodeMetricWithCoverageWithoutThreshold
	<timeout: 10>
	| morph |
	self runAllTests.
	self getOptionWithLinesOfCodeMetric: false.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph color = (Color r: 0.326 g: 0.5 b: 0.474)	! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:50.452'!
test12aComplexityMetricPureWithThreshold
	<timeout: 10>
	| options morph |
	options := self getOptionWithComplexityMetric: true.	
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
<= 1 complexity.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
> 5 complexity.'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph color = Color green;
		assert: morph additionalInfo = 'SSBClassA +
1 complexity.
'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #complexMethod:).
	self 
		assert: morph color = Color yellow;
		assert: morph additionalInfo = 'SSBClassA complexMethod:
2 complexity.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/21/2013 13:57:53.813'!
test12bComplexityMetricPureWithoutThreshold
	<timeout: 10>
	| options morph |
	options := self getOptionWithComplexityMetric: false.
	self 
		assert: (options getLabelString: 0.1@0.1) = 'Method not covered.
2 complexity.';
		assert: (options getLabelString: 0.9@0.9) = 'Method covered.
9 complexity.'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph color = (Color r: 0.65 g: 0.65 b: 1.0);
		assert: morph additionalInfo = 'SSBClassA +
1 complexity.
'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #complexMethod:).
	self 
		assert: morph color = (Color r: 0.65 g: 1.0 b: 0.947);
		assert: morph additionalInfo = 'SSBClassA complexMethod:
2 complexity.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:17:43.522'!
test12cComplexityMetricWithCoverageAndThreshold
	<timeout: 10>
	| morph |
	self runAllTests.
	self getOptionWithComplexityMetric: true.	
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph color =  (Color r: 0.0 g: 0.5 b: 0.0).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:17:49.528'!
test12dComplexityMetricWithCoverageWithoutThreshold
	<timeout: 10>
	| morph |
	self runAllTests.
	self getOptionWithComplexityMetric: false.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph color = (Color r: 0.326 g: 0.326 b: 0.5)	! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:18:03.789'!
test13aVariableAccessMetricPure
	<timeout: 10>
	| morph |
	self options staticMetricAccessedVariables.
	self 
		assert: (self options getLabelString: 0.1@0.1) = 'Method not covered.
2 variable(s) accessed.';
		assert: (self options getLabelString: 0.9@0.9) = 'Method covered.
11 variable(s) accessed.'.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #myValue:).
	self 
		assert: morph color = (Color r: 0.65 g: 1.0 b: 0.982);
		assert: morph additionalInfo = 'SSBDictionary myValue:
2 variable(s) accessed.
'.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 11:18:13.701'!
test13bVariableAccessMetricWithCoverage
	<timeout: 10>
	|  morph |
	self runAllTests.
	self options staticMetricAccessedVariables.
	morph := self methodMorph: (MethodReference class: SSBDictionary selector: #myValue:).
	self assert: morph color = (Color r: 0.326 g: 0.5 b: 0.492).! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 5/28/2013 16:51:34.3'!
test14SortMethodsByMetric
	<timeout: 10>
	| options |
	self runAllTests.
	options := self getOptionWithLinesOfCodeMetric: false.	
	self assert: ((self classMorph: SSBClassA) 
		childrenMorphs at: #'no category') submorphs last sourceCodeEntity = #+.
	options sortMethodsToStaticMetric.
	self assert: ((self classMorph: SSBClassA) 
		childrenMorphs at: #'no category') submorphs last sourceCodeEntity = #complexMethod:.! !

!SPathMapTestQualityTest methodsFor: 'testing' stamp: 'mp 8/8/2013 17:36:47.649'!
test15StartBrowserWithCoverageIcons
	<timeout: 10>
	| morph browser |
	self getOptionWithLinesOfCodeMetric: true.	
	self 
		selectTests: (Set with: SSBFaultLocalizationExampleTest);
		runAllTests.	
	morph := self methodMorph: (MethodReference class: SSBFaultLocalizationExample selector: #midX:Y:Z:).
	morph browse.
	browser := self findBrowserFor: #SSBFaultLocalizationExample -> #midX:Y:Z:.
	self 
		assert: browser model methodColors notNil;
		assert: browser model methodColors notEmpty;
		assert: (browser model methodColors 
				at: (MethodReference 
					class: SSBFaultLocalizationExample 
					selector:#midX:Y:Z:)) = 
				(Color r: 0.5 g: 0.5 b: 0.0);
		assert: ((browser model iconForMessage: 1) colorAt: 10@10) = 
				(Color r: 0.501 g: 0.501 b: 0.0);
		assert: ((browser model iconForClass: 1) colorAt: 10@10) = 
				Color yellow.
	browser abandon.! !

SPathMapFlapTest subclass: #SPathMapTraceabilityTest
	instanceVariableNames: 'chooser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapTraceabilityTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapTraceabilityTest methodsFor: 'running' stamp: 'mp 5/22/2013 13:39:58.274'!
addConcernMapping
	self addGroupAndConcernToChooser.
	self chooser 
		newSelectedTestItem: {SSBTest};
		addMapping.! !

!SPathMapTraceabilityTest methodsFor: 'running' stamp: 'mp 5/22/2013 11:59:02.4'!
addGroupAndConcernToChooser
	self addGroupToChooser.
	[self chooser addConcern] valueSupplyingAnswer: self concern.
	self chooser newSelectedConcernItem: {self group. self concern}.! !

!SPathMapTraceabilityTest methodsFor: 'running' stamp: 'mp 5/22/2013 11:57:42.594'!
addGroupToChooser
	[self chooser addConcernGroup] valueSupplyingAnswer: self group.
	self chooser newSelectedConcernItem: {self group}.! !

!SPathMapTraceabilityTest methodsFor: 'running' stamp: 'mp 5/22/2013 14:11:07.003'!
addMultipleConcernMapping
	| concern2 |
	self addGroupAndConcernToChooser.
	self chooser 
		newSelectedTestItem: {SSBTest. #testComplexTrace};
		addMapping.
	concern2 := 'myConcern2'.
	[self chooser addConcern] valueSupplyingAnswer: concern2.
	self chooser newSelectedConcernItem: {self group. concern2}.
	self chooser 
		newSelectedTestItem: {SSBTest. #testBinary};
		addMapping.! !

!SPathMapTraceabilityTest methodsFor: 'hooks' stamp: 'mp 5/22/2013 11:11:54.706'!
analysisSymbol
	^ #traceability! !

!SPathMapTraceabilityTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:09:39.088'!
chooser
	"Answer the value of chooser"

	^ chooser! !

!SPathMapTraceabilityTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:09:39.105'!
chooser: anObject
	"Set the value of chooser"

	chooser := anObject! !

!SPathMapTraceabilityTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:51:43.568'!
concern
	^ 'myConcern'! !

!SPathMapTraceabilityTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:07:25.64'!
concerns
	^ SProject current concerns! !

!SPathMapTraceabilityTest methodsFor: 'accessing' stamp: 'mp 5/22/2013 11:51:36.433'!
group
	^ 'myGroup'! !

!SPathMapTraceabilityTest methodsFor: 'running' stamp: 'mp 5/22/2013 11:55:23.471'!
setUp
	super setUp.
	self chooser: self options chooseConcerns.! !

!SPathMapTraceabilityTest methodsFor: 'running' stamp: 'mp 5/22/2013 11:55:46.728'!
tearDown
	self chooser windowMorph abandon.
	super tearDown.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 10:18:52.293'!
test01RunAllTestsWithOpenFlap
	self should: [self runAllTests] raise: ProvideAnswerNotification.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:34:30.102'!
test02aConcernChooserAddGroup
	self 
		assert: self concerns groups isEmpty;
		assert: self chooser groupButtonEnabled;
		assert: self chooser groupButtonLabel = 'Add Group'.
	[self chooser groupButtonAction] valueSupplyingAnswer: self group.
	self 
		assert: (self concerns groups at: self group) isEmpty.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:34:37.714'!
test02bConcernChooserRemoveGroup
	self addGroupToChooser.
	self assert: self chooser groupButtonLabel = 'Remove Group'.
	[self chooser groupButtonAction] valueSupplyingAnswer: true.
	self assert: self concerns groups isEmpty.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:34:48.744'!
test03aConcernChooserAddConcern
	self 
		addGroupToChooser;
		assert: self chooser concernButtonEnabled;
		assert: self chooser concernButtonLabel = 'Add Concern'.
	[self chooser concernButtonAction] valueSupplyingAnswer: self concern.
	self assert: (self concerns groups at: self group) first = self concern.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:34:51.729'!
test03bConcernChooserRemoveConcern
	self 
		addGroupAndConcernToChooser;
		assert: self chooser concernButtonLabel = 'Remove Concern'.
	[self chooser concernButtonAction] valueSupplyingAnswer: true.
	self 
		assert: (self concerns groups at: self group) isEmpty;
		deny: self chooser concernButtonEnabled.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 13:50:34.734'!
test04aConcernChooserChooseColor
	self 
		addGroupAndConcernToChooser;
		assert: (self concerns colors at: self concern) class = Color;
		assert: self chooser colorEnabled.
	self chooser setIconColorOfSelectedConcern: Color green.
	self assert: (self concerns colors at: self concern) = Color green.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 13:50:55.383'!
test04bConcernChooserRemoveColor
	self addGroupAndConcernToChooser.
	[self chooser removeConcern] valueSupplyingAnswer: true.	
	self assert: self concerns colors isEmpty;
		deny: self chooser colorEnabled.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:37:58.195'!
test05aConcernChooserAddMapping
	self addGroupAndConcernToChooser.
	self deny: self chooser mappingButtonEnabled.
	self chooser newSelectedTestItem: {SSBTest}.
	self 
		assert: self chooser mappingButtonEnabled;
		assert: self chooser mappingButtonLabel = 'Add Mapping'.
	self chooser mappingButtonAction.
	self 
		assert: self concerns mapping notEmpty;
		assert: (self concerns mapping at: self concern) first = 
					(MethodReference class: SSBTest selector: #testBinary).	! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:38:48.53'!
test05bConcernChooserRemoveMapping
	self addGroupAndConcernToChooser.
	self chooser newSelectedTestItem: {SSBTest}.
	self chooser mappingButtonAction.
	self chooser newSelectedConcernItem: {self group. self concern}.
	self chooser newSelectedTestItem: {SSBTest}.
	self assert: self chooser mappingButtonLabel = 'Remove Mapping'.
	self chooser mappingButtonAction.
	self assert: (self concerns mapping at: self concern) isEmpty.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 7/12/2013 12:00:04.681'!
test06RunTestsWithConcernMapping
	<timeout: 20>
	| morph |
	self addConcernMapping.
	self chooser setIconColorOfSelectedConcern: Color green.
	self options setConcernGroup: self group.
	self runAllTests.
	self assert: (self options getLabelString: 0.1@0.1) = 'No selected concern covered this method.'.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph color =  Color green;
		assert: morph additionalInfo = 'SSBClassA +
was covered by the following concerns: 
myConcern
'.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 7/12/2013 12:00:22.819'!
test07MultipleColorsPerMethodMorph
	<timeout: 20>
	| morph |
	self addMultipleConcernMapping.
	self options setConcernGroup: self group.
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph additionalColors size = 2;
		assert: morph additionalInfo = 'SSBClassA +
was covered by the following concerns: 
myConcern
myConcern2
'.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:27:36.452'!
test08ShowOnlySpecificConcerns
	<timeout: 20>
	| morph |
	self addMultipleConcernMapping.
	self options setConcernGroup: self group.
	self runAllTests.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph additionalColors size = 2.
	self options switchSpecificConcernMethodsOnly.
	self assert: morph additionalColors isNil.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:32:08.232'!
test09GrayColorsPerMethodMorph
	<timeout: 20>
	| morph |
	self addMultipleConcernMapping.
	self options setConcernGroup: self group.
	self runAllTests.
	self assert: (self options getLabelString: 0.9@0.9) = '2 concerns covered this method'.
	self options switchMultipleColorsPerMethod.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self 
		assert: morph additionalColors isNil;
		assert: morph color = Color black.! !

!SPathMapTraceabilityTest methodsFor: 'testing' stamp: 'mp 5/22/2013 14:28:04.161'!
test10DeselectConcernMapping
	<timeout: 20>
	| morph |
	self addConcernMapping.
	self chooser setIconColorOfSelectedConcern: Color green.
	self options setConcernGroup: self group.
	self runAllTests.
	self options selectedConcernAt: 1 put: false.
	morph := self methodMorph: (MethodReference class: SSBClassA selector: #+).
	self assert: morph color =  Color white.! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/16/2013 10:23:42.369'!
activateMenuFor: aPathMapMorph
	| menuMorph |
	aPathMapMorph mouseUp: nil.
	menuMorph := aPathMapMorph rootMorph menuMorph.
	self 
		assert: menuMorph notNil;
		assert: menuMorph targetMorph = aPathMapMorph.
	^ menuMorph! !

!SPathMapTest methodsFor: 'test results' stamp: 'mp 5/16/2013 12:05:49.727'!
allTests
	^ SProject current allTests! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/16/2013 11:46:31.499'!
checkTestResults: aString
	| textMorph |
	textMorph := self testRunner findDeepSubmorphThat: [:morph | 
		morph class =  PluggableTextMorphPlus and: 
		[morph text asString = aString]] 
	ifAbsent: nil.
	self assert: textMorph notNil.! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/16/2013 10:22:02.097'!
classMorph: aClass
	| classMorph |
	classMorph := self pathMap getClassMorph: aClass.
	self assert: classMorph notNil.
	^ classMorph! !

!SPathMapTest methodsFor: 'test results' stamp: 'mp 5/16/2013 12:05:43.608'!
failingTests
	^ {MethodReference 
			class: SSBFaultLocalizationExampleTest selector: #test213. 
		MethodReference 
			class: SSBFaultLocalizationTest selector: #testFailingMethodFault. 
		MethodReference 
			class: SSBTest selector: #testParamMethod2} asOrderedCollection! !

!SPathMapTest methodsFor: 'accessing' stamp: 'mp 5/17/2013 14:11:14.964'!
findBrowserFor: anAssociation
	| browserMorph |
	browserMorph := World findDeepSubmorphThat: [:each | 
		(each class = PluggableSystemWindow and: 
		[each model isKindOf: Browser]) and: 
		[(each model selectedClassName = anAssociation key) and: 
			[each model selectedMessageName = anAssociation value]]] ifAbsent: nil.
	self assert: browserMorph notNil.
	^ browserMorph! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/16/2013 11:43:08.578'!
findButtonLabeled: aString
	^ self testRunner 
		findDeepSubmorphThat: [:morph | 
			morph class = PluggableButtonMorphPlus and: [morph label = aString]] 
		ifAbsent: nil ! !

!SPathMapTest methodsFor: 'accessing' stamp: 'mp 8/8/2013 15:25:36.732'!
findPathfinderFor: anAssociation
	| pathFinderMorph |
	pathFinderMorph := World findDeepSubmorphThat: [:each | 
		(each class = PluggableSystemWindow and: 
			[each model isKindOf: SPathFinder]) and: 
			[(each label = ('PathFinder: ', 
							anAssociation key asString, ' ', anAssociation value asString))]]
		 ifAbsent: nil.
	self assert: pathFinderMorph notNil.
	^ pathFinderMorph! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/16/2013 13:47:50.152'!
methodMorph: aMethodReference
	| methodMorph |
	methodMorph := self pathMap 
						getMethodMorph: aMethodReference actualClass 
						and: aMethodReference methodSymbol.
	self assert: methodMorph notNil.
	^ methodMorph! !

!SPathMapTest methodsFor: 'test results' stamp: 'mp 5/16/2013 13:58:01.598'!
methodsWithoutTests
	| tests |
	tests := self allTests.
	^ SProject current allMethods reject: [:each | tests includes: each]! !

!SPathMapTest methodsFor: 'test results' stamp: 'mp 5/16/2013 13:54:19.37'!
passingTests
	^ self allTests reject: [:each | self failingTests includes: each].! !

!SPathMapTest methodsFor: 'accessing' stamp: 'mp 5/15/2013 15:55:24.712'!
pathMap
	^ self testRunner model pathMap! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/16/2013 10:30:20.961'!
pushButton: aSymbol on: aMenuMorph
	| button |
	button := aMenuMorph submorphs 
				detect: [:each | each actionSelector = aSymbol] ifNone: [nil].
	self assert: button notNil.
	button mouseUp: nil.! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/17/2013 13:15:01.004'!
runAllTests
	(self findButtonLabeled: 'Run Selected') performAction.! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/21/2013 16:25:10.76'!
runAllTestsWithContracts
	(self findButtonLabeled: 'Run with Contracts') performAction.! !

!SPathMapTest methodsFor: 'pathMap-helper' stamp: 'mp 5/21/2013 14:01:39.543'!
selectTests: aSet
	self testRunner model instVarNamed: 'classesSelected' put: aSet.! !

!SPathMapTest methodsFor: 'running' stamp: 'mp 5/15/2013 15:07:52.514'!
setUp
	super setUp.
	SProject addProject: SProject sandboxProject.
	SProject setCurrent: #sandbox.
	self testRunner: SPathMapTestRunner open.! !

!SPathMapTest methodsFor: 'running' stamp: 'mp 5/15/2013 15:07:52.701'!
tearDown
	self testRunner abandon.
	super tearDown.! !

!SPathMapTest methodsFor: 'accessing' stamp: 'mp 5/15/2013 15:07:52.91'!
testRunner
	"Answer the value of testRunner"

	^ testRunner! !

!SPathMapTest methodsFor: 'accessing' stamp: 'mp 5/15/2013 15:07:52.926'!
testRunner: anObject
	"Set the value of testRunner"

	testRunner := anObject! !

SPathMapTest subclass: #SPathMapTestRunnerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathMap'!

!SPathMapTestRunnerTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 5/17/2013 13:15:54.781'!
test01RunAllTests
	self runAllTests.
	self checkTestResults: '52 run, 49 passes, 0 expected failures, 3 failures, 0 errors, 0 unexpected passes'.
	self passingTests 
		do: [:each | self assert: (self methodMorph: each) color = Color green].
	self failingTests 
		do: [:each | self assert: (self methodMorph: each) color = Color yellow].
	self methodsWithoutTests
		do: [:each | self assert: (self methodMorph: each) color = Color white].! !

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 5/21/2013 14:02:08.328'!
test02RunSelectedTestSuites
	self 
		selectTests: (Set with: SSBTest with: SSBTypeTest);
		runAllTests;
		checkTestResults: '21 run, 20 passes, 0 expected failures, 1 failures, 0 errors, 0 unexpected passes'.
	self assert: (self methodMorph: 
			(MethodReference class: SSBTest selector: #testDoNothing)) color = 
				Color green.
	self assert: (self methodMorph: 
			(MethodReference class: SSBTest selector: #testParamMethod2)) color =
				Color yellow.
	self assert: (self methodMorph: 
			(MethodReference 
				class: SSBFaultLocalizationTest selector: #testFailingMethodFault)) color =
				Color white.! !

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 5/16/2013 14:19:51.168'!
test03RunSingleTestCase
	| methodMorph menuMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #rerunTest on: menuMorph.
	self assert: (self methodMorph: 
			(MethodReference class: SSBTest selector: #testDoNothing)) color = 
				Color green.
	(SProject current allMethods 
		remove: (MethodReference class: SSBTest selector: #testDoNothing);
		yourself)
			do: [:each | self assert: (self methodMorph: each) color = Color white].! !

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 5/16/2013 14:45:43.106'!
test04aDebugSinglePassedTestCase
	| menuMorph methodMorph |
	self assert: SBreakpointManager installedNodes isEmpty.
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #rerunTest on: menuMorph.
	self should: [self pushButton: #debugMethod on: menuMorph] raise: BreakPoint.! !

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 5/16/2013 14:53:43.099'!
test04bDebugSingleFailedTestCase
	| menuMorph methodMorph |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBFaultLocalizationTest 
											selector: #testFailingMethodFault).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #rerunTest on: menuMorph.
	self should: [self pushButton: #debugMethod on: menuMorph] raise: TestFailure.! !

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 5/16/2013 14:57:27.003'!
test05PathFinderSingleTestCase
	| menuMorph methodMorph pathFinder |
	methodMorph := self methodMorph: (MethodReference 
											class: SSBTest selector: #testDoNothing).
	menuMorph := self activateMenuFor: methodMorph.
	self pushButton: #rerunTest on: menuMorph.
	self pushButton: #pathfinderMethod on: menuMorph.
	pathFinder := World findDeepSubmorphThat: [:each | 
		(each class = PluggableSystemWindow and: 
			[each model isKindOf: SPathFinder]) and: 
			[(each label =  'PathFinder: SSBTest testDoNothing')]] ifAbsent: nil.
	self assert: pathFinder notNil.
	pathFinder abandon.! !

!SPathMapTestRunnerTest methodsFor: 'testing' stamp: 'mp 7/12/2013 13:31:16.159'!
test06CheckTestResultsAdditionalInformation
	self runAllTests.
	self passingTests 
		do: [:each | self assert: (self methodMorph: each) additionalInfo = 
				(each asStringOrText, String cr, 
				'Result: Test passed', String cr)].
	self failingTests 
		do: [:each | self assert: (self methodMorph: each) additionalInfo = 
				(each asStringOrText, String cr, 
				'Result: Test failed - TestFailure: Assertion failed', String cr)].! !

SProjectTest subclass: #SProjectAccessTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectAccessTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 3/25/2013 15:10:03.546'!
allMethodsOfObserverExample
	^ {ClockTimer -> #tick.
	ClockTimer -> #hour.
	ClockTimer -> #hour:.
	ClockTimer -> #initialize. 
	ClockTimer -> #second.
	ClockTimer -> #minute.
	ClockTimer -> #minute:.
	ClockTimer -> #second:.
	Driver -> #run.
	Driver class -> #demo.
	Observer -> #update:.
	Observer -> #subject.
	Observer -> #subject:.
	Observer class -> #on:.
	SAnalogClock -> #draw.
	SAnalogClock -> #update:.
	SDigitalClock -> #draw.
	SDigitalClock -> #update:. 
	SVisibleClock -> #initInFrame:.
	SVisibleClock -> #drawText:. 
	SVisibleClock class -> #defaultExtent.
	SVisibleClock class -> #newOn:inFrame:.
	SVisibleClock class -> #on:.
	Subject -> #initialize.
	Subject -> #notify.
	Subject -> #detach:.
	Subject -> #attach:.
	TestDriver -> #testNoop.
	TestDriver -> #tearDown.
	TestDriver -> #testRun} 
		inject: OrderedCollection new into: [:collection :each | 
			collection 
				add: (MethodReference class: each key selector: each value); 
				yourself]
	
	 ! !

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 3/25/2013 15:12:06.903'!
allTestsOfObserverExample
	^ {TestDriver -> #testNoop.
	TestDriver -> #testRun} 
		inject: OrderedCollection new into: [:collection :each | 
			collection 
				add: (MethodReference class: each key selector: each value); 
				yourself]
	
	 ! !

!SProjectAccessTest methodsFor: 'running' stamp: 'mp 3/22/2013 11:25:11.779'!
setUp
	super setUp.
	SProject addProject: SProject observerExampleProject.
	SProject setCurrent: #observerExample.! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 3/22/2013 11:27:31.328'!
test01AllClasses

	self assert: self project allClasses =  {ClockTimer. Driver. Observer. SAnalogClock. SDigitalClock. SVisibleClock. Subject. TestDriver}.! !

!SProjectAccessTest methodsFor: 'category tests' stamp: 'mp 3/22/2013 11:32:05.387'!
test01CategoriesWithTest

	self assert: self project categoriesWithTests = 
					#(#'Path-Dev-Example-Observer-Tests').! !

!SProjectAccessTest methodsFor: 'method category tests' stamp: 'mp 3/22/2013 11:37:37.075'!
test01MethodCategoriesOfClass

	self assert: (self project methodCategoriesOfClass: Observer) =   #(#accessing #observation #'instance creation (class)').	! !

!SProjectAccessTest methodsFor: 'print tests' stamp: 'mp 3/22/2013 15:07:11.493'!
test01PrintMetricsOverview

	self assert: self project metricsOverviewString = 
		'2 Categories, 8 Classes, and 30 Methods (136 LoC)'.! !

!SProjectAccessTest methodsFor: 'project tests' stamp: 'mp 3/22/2013 11:46:50.483'!
test01ProjectInitialized

	self assert: self project notNil.
	self assert: self project projectName == #observerExample.! !

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 3/22/2013 13:41:42.834'!
test01aMethodsPerClass
	
	self assert: (self project methodsPerClass: ClockTimer) = 
		#(#hour #hour: #initialize #minute #minute: #second #second: #tick)! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:58:13.222'!
test01aNumberOfMethodsOfClass

	self assert: (self project numberOfMethodsOfClass: Driver) = 2.
	self assert: (self project numberOfMethodsOfClass: Subject) = 4.
	self assert: (self project numberOfMethodsOfClass: ClockTimer) = 8.! !

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 3/22/2013 13:42:01.558'!
test01bMethodsPerClass
	
	self assert: (self project methodsPerClass: ClockTimer withQuick: false) = 
		#(#hour: #initialize #minute: #second: #tick)! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 15:01:51.465'!
test01bNumberOfMethodsOfClassWithoutQuick

	self assert: (self project numberOfMethodsOfClass: Driver withQuick: false) = 2.
	self assert: (self project numberOfMethodsOfClass: Subject withQuick: false) = 4.
	self assert: (self project numberOfMethodsOfClass: ClockTimer withQuick: false) = 5.! !

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 5/28/2013 16:37:28.197'!
test02AllMethods
	self assert: self project allMethods asSet = self allMethodsOfObserverExample asSet
	 ! !

!SProjectAccessTest methodsFor: 'category tests' stamp: 'mp 3/22/2013 11:32:36.916'!
test02CategoriesOrderedByTests

	self assert: self project categoriesOrderedByTestsFirst =  #(#'Path-Dev-Example-Observer-Tests' #'Path-Dev-Example-Observer').! !

!SProjectAccessTest methodsFor: 'method category tests' stamp: 'mp 3/22/2013 11:48:23.82'!
test02MethodsOfMethodCategoryAndClass

	self assert: (self project methodsPerClass: Subject andMethodCategory: #observation) =   #(#attach: #detach: #notify).
	self assert: (self project methodsPerClass: SVisibleClock andMethodCategory: #'instance creation (class)') =   #(#newOn:inFrame: #on:).! !

!SProjectAccessTest methodsFor: 'print tests' stamp: 'mp 3/22/2013 15:13:24.118'!
test02PrintString

	self assert: self project asString = 'observerExample <current>'.
	SProject addProject: SProject sandboxProject.
	self assert: (SProject projectAt: #sandbox) asString = 'sandbox'.! !

!SProjectAccessTest methodsFor: 'project tests' stamp: 'mp 6/11/2010 16:26'!
test02ResetClassesCache

	self assert: (self project instVarNamed: 'classesCache') isNil.
	self project allClasses.
	self assert: (self project instVarNamed: 'classesCache') notNil.
	self project resetClassesCache.
	self assert: (self project instVarNamed: 'classesCache') isNil.	! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 3/22/2013 11:28:33.464'!
test02TestClasses

	self assert: self project testClasses =  {TestDriver}! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:59:06.417'!
test02aNumberOfMethodsOfClassAndMethodCategory

	self assert: (self project 
					numberOfMethodsOfClass: ClockTimer 
					methodCategory: 'accessing') = 6.
	self assert: (self project 
					numberOfMethodsOfClass: ClockTimer 
					methodCategory: 'initialize-release') = 1.
! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 15:00:17.496'!
test02bNumberOfMethodsOfClassAndMethodCategoryWithoutQuick

	self assert: (self project 
					numberOfMethodsOfClass: ClockTimer 
					methodCategory: 'accessing' withQuick: false) = 3.
	self assert: (self project 
					numberOfMethodsOfClass: ClockTimer 
					methodCategory: 'initialize-release' withQuick: false) = 1.
! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 3/22/2013 11:54:22.496'!
test03ClassesOfCategory

	self assert: (self project classesOfCategory: #'Path-Dev-Example-Observer') =  
	{ClockTimer. Driver. Observer. SAnalogClock. SDigitalClock. SVisibleClock. Subject}.! !

!SProjectAccessTest methodsFor: 'print tests' stamp: 'mp 3/22/2013 15:14:42.276'!
test03FullPrintString

	self assert: self project fullPrintString = 'a SProject <observerExample>'.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:56:34.346'!
test03NumberOfMethodsOfCategory

	self assert: (self project 
					numberOfMethodsOfCategory: #'Path-Dev-Example-Observer') = 27.
	self assert: (self project categories 
					inject: 0 
					into: [:sum :cat | sum := sum + 
							(self project numberOfMethodsOfCategory: cat)]) 
						= self project numberOfMethods.! !

!SProjectAccessTest methodsFor: 'project tests' stamp: 'mp 3/22/2013 13:37:14.821'!
test03RemoveClassFromCache

	self project allClasses.
	self assert: (self project instVarNamed: 'classesCache') includes: Observer.
	self project removeFromClassesCache: Observer.
	self deny: (self project instVarNamed: 'classesCache') includes: Observer.
	! !

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 3/25/2013 15:12:29.018'!
test03aAllTests
	
	self assert: (self project allTests = self allTestsOfObserverExample)! !

!SProjectAccessTest methodsFor: 'method tests' stamp: 'mp 3/25/2013 15:13:42.356'!
test03bAllTestsAsEntryPoints
	
	self assert: (self project allTestsAsEntryPoints = (self allTestsOfObserverExample collect: [:each | STestCaseEntryPoint onTestMethodReference: each]))! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:51:57.849'!
test04NumberOfMethodsOfProject

	self assert: self project numberOfMethods = 30.
	self assert: self project numberOfMethods = 
		(self project allClasses 
			inject: 0 
			into: [:sum :each | sum + each methodDict size + each class methodDict size]).! !

!SProjectAccessTest methodsFor: 'project tests' stamp: 'mp 3/25/2013 16:30:00.085'!
test04SystemClassChanged
	| recorder |
	recorder := SProjectEventRecorder new.
	self project addDependent: recorder.
	self assert: recorder events isEmpty.
	Compiler evaluate: 'Object subclass: #Driver
		instanceVariableNames: ''''
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''Path-Dev-Example-Observer'''.
	self deny: recorder events isEmpty.! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 3/22/2013 11:55:16.952'!
test04TestClassesOfCategory

	self assert: (self project 
		testClassesOfCategory: #'Path-Dev-Example-Observer-Tests') =  {TestDriver}.
	self assert: (self project 
		testClassesOfCategory: #'Path-Dev-Example-Observer') isEmpty.! !

!SProjectAccessTest methodsFor: 'class tests' stamp: 'mp 3/22/2013 13:43:06.099'!
test05AllClassesWithoutTests

	self assert: self project allClassesWithoutTests = 
	{ClockTimer. Driver. Observer. SAnalogClock. SDigitalClock. SVisibleClock. Subject}.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:48:56.801'!
test05NumberOfClassesOfProject

	self assert: self project numberOfClasses = 8.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:52:56.787'!
test06NumberOfPackagesOfProject

	self assert: self project numberOfPackages = 2.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 14:47:52.616'!
test07LinesOfCodeOfProject

	self assert: self project linesOfCode =  136.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 7/16/2013 15:04:22.618'!
test08NumberOfMethodsWithoutLowComplexity

	self assert: self project numberOfMethodsWithoutLowComplexity = 6.! !

!SProjectAccessTest methodsFor: 'metric tests' stamp: 'mp 8/9/2013 14:25:28.555'!
test09AllMethodReferncesOfAClass

	self assert: (self project allMethodReferencesOf: Observer) = {
		MethodReference class: Observer selector: #update:.
		MethodReference class: Observer selector: #subject.
		MethodReference class: Observer selector: #subject:.
		MethodReference class: Observer class selector: #on:.
	}.! !

SProjectTest subclass: #SProjectBucketTest
	instanceVariableNames: 'pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectBucketTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectBucketTest methodsFor: 'accessing' stamp: 'mp 3/22/2013 14:20:52.95'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SProjectBucketTest methodsFor: 'accessing' stamp: 'mp 3/22/2013 14:20:53.127'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SProjectBucketTest methodsFor: 'running' stamp: 'mp 3/22/2013 14:52:39.808'!
runInductiveAnalysisWith: aHarvesterClass
	self pathMap model pathMap selectedOptions	setKindOfAnalysis: aHarvesterClass.
	self pathMap model runAll.! !

!SProjectBucketTest methodsFor: 'running' stamp: 'mp 3/22/2013 14:31:21.061'!
setUp
	super setUp.
	SProject addProject: SProject observerExampleProject.
	SProject setCurrent: #observerExample.
	self pathMap: SPathMapTestRunner open.
	(self pathMap model getFlap: #inductive) switchExpandState.
	self pathMap model pathMap selectedAnalysis: #inductive.! !

!SProjectBucketTest methodsFor: 'running' stamp: 'mp 3/22/2013 14:20:53.151'!
tearDown

	self pathMap abandon.
	super tearDown.! !

!SProjectBucketTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:59:23.294'!
test01RunHarvesting
	self assert: self project harvestedBuckets isEmpty.
	self runInductiveAnalysisWith: STypeHarvester.
	self assert: self project harvestedBuckets notEmpty.! !

!SProjectBucketTest methodsFor: 'testing' stamp: 'mp 5/2/2013 14:11:50.238'!
test02TypeBucket
	self assert: self project typesBucket isNil.
	self runInductiveAnalysisWith: STypeHarvester.
	self assert: self project valueRangeBucket isNil.
	self assert: self project typesBucket notNil.
	self assert: (self project typesBucket class inheritsFrom: STypeBucket)! !

!SProjectBucketTest methodsFor: 'testing' stamp: 'mp 3/22/2013 14:53:01.327'!
test03ValueRangeBucket
	self assert: self project typesBucket isNil.
	self runInductiveAnalysisWith: SValueRangeHarvester.
	self assert: self project typesBucket isNil.
	self assert: self project valueRangeBucket notNil.
	self assert: (self project valueRangeBucket class == SValueRangeBucket)! !

!SProjectBucketTest methodsFor: 'testing' stamp: 'mp 5/2/2013 13:59:37.594'!
test04BothBuckets
	self runInductiveAnalysisWith: STypeHarvester.
	self runInductiveAnalysisWith: SValueRangeHarvester.
	self assert: self project typesBucket notNil.
	self assert: self project valueRangeBucket notNil.! !

SProjectTest subclass: #SProjectChooserTest
	instanceVariableNames: 'projectChooser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectChooserTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectChooserTest methodsFor: 'accessing' stamp: 'mp 3/25/2013 16:39:51.102'!
projectChooser
	"Answer the value of projectChooser"

	^ projectChooser! !

!SProjectChooserTest methodsFor: 'accessing' stamp: 'mp 3/25/2013 16:39:51.116'!
projectChooser: anObject
	"Set the value of projectChooser"

	projectChooser := anObject! !

!SProjectChooserTest methodsFor: 'running' stamp: 'mp 3/25/2013 17:34:30.312'!
setUp
	super setUp.
	SProject initialize.
	self projectChooser: SProjectChooser open.
	self projectChooser enableTestMode.! !

!SProjectChooserTest methodsFor: 'running' stamp: 'mp 3/25/2013 16:41:53.47'!
tearDown
	super tearDown.
	self projectChooser windowMorph abandon.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:00:06.435'!
test01Initialization
	| morph | 
	self assert: self projectChooser selectedProject projectName = #null.
	morph := self projectChooser windowMorph.
	self assert: morph label = 'PathProjects'.
	self assert: morph paneMorphs size = 3.
	self assert: (morph paneMorphs collect: [:each | each knownName]) = 
		 #('selectedCategoriesList' 'projectList' nil).
	self assert: (morph allSubmorphsOfKind: PluggableButtonMorphPlus) size = 5.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:12:43.642'!
test02CheckProjectList
	self assert: self projectChooser allRegisteredProjects asSet = 
		SProject allProjectsWithoutNull asSet
! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:15:56.448'!
test03CheckSelectedCategoriesList
	self assert: self projectChooser selectedCategoriesOfProject isEmpty.
	self projectChooser selectedProject: (SProject projectAt: #observerExample).
	self assert: self projectChooser selectedCategoriesOfProject =  
		#(#'Path-Dev-Example-Observer' #'Path-Dev-Example-Observer-Tests').! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:21:27.175'!
test04SetCurrentProject
	self projectChooser selectedProject: (SProject projectAt: #observerExample). 
	self projectChooser selectCurrentProject.
	self assert: self projectChooser selectedProject asString = 
		'observerExample <current>'.
	self assert: self projectChooser selectedCategoriesOfProject =  
		#(#'Path-Dev-Example-Observer' #'Path-Dev-Example-Observer-Tests').! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:37:56.509'!
test05AddProject
	self projectChooser addProject.
	self assert: self projectChooser selectedProject projectName = #PathTestProject.
	self assert: (SProject projectAt: #PathTestProject) notNil.
	self assert: self projectChooser selectedCategoriesOfProject isEmpty.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:40:18.804'!
test06aChooseCategoriesAll
	| categoryChooser |
	self projectChooser selectedProject: (SProject projectAt: #observerExample). 
	categoryChooser := self projectChooser chooseCategories.
	categoryChooser selectAll.
	categoryChooser ok.
	self assert: self projectChooser selectedCategoriesOfProject size > 100.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:42:33.857'!
test06bChooseCategoriesInverse
	| categoryChooser |
	self projectChooser selectedProject: (SProject projectAt: #observerExample). 
	categoryChooser := self projectChooser chooseCategories.
	categoryChooser selectInverse.
	categoryChooser ok.
	self assert: self projectChooser selectedCategoriesOfProject size > 100.
	self deny: (self projectChooser selectedCategoriesOfProject 
					includes: #'Path-Dev-Example-Observer').! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:43:12.834'!
test06cChooseCategoriesNone
	| categoryChooser |
	self projectChooser selectedProject: (SProject projectAt: #observerExample). 
	categoryChooser := self projectChooser chooseCategories.
	categoryChooser selectNone.
	categoryChooser ok.
	self assert: self projectChooser selectedCategoriesOfProject isEmpty.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:43:44.299'!
test06dChooseCategoriesCancel
	| categoryChooser |
	self projectChooser selectedProject: (SProject projectAt: #observerExample). 
	categoryChooser := self projectChooser chooseCategories.
	categoryChooser selectAll.
	categoryChooser cancel.
	self assert: self projectChooser selectedCategoriesOfProject size = 2.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:45:26.332'!
test07RemoveProject
	self projectChooser selectedProject: (SProject projectAt: #observerExample). 
	self projectChooser removeSelectedProject.
	self assert: (SProject projectAt: #observerExample) isNil.! !

!SProjectChooserTest methodsFor: 'testing' stamp: 'mp 3/25/2013 17:51:39.456'!
test08ResetProjectCache
	| observerProject |
	observerProject := SProject projectAt: #observerExample.
	observerProject allClasses.
	self assert: (observerProject instVarNamed: 'classesCache') notNil.
	self projectChooser selectedProject: observerProject. 
	self projectChooser resetCacheOfSelectedProject.
	self assert: (observerProject instVarNamed: 'classesCache') isNil.
	! !

SProjectTest subclass: #SProjectCoverageTest
	instanceVariableNames: 'pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectCoverageTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectCoverageTest methodsFor: 'accessing' stamp: 'mp 3/22/2013 13:48:11.062'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SProjectCoverageTest methodsFor: 'accessing' stamp: 'mp 3/22/2013 13:48:11.074'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SProjectCoverageTest methodsFor: 'running' stamp: 'mp 3/22/2013 14:30:12.94'!
setUp
	super setUp.
	SProject addProject: SProject observerExampleProject.
	SProject setCurrent: #observerExample.
	self pathMap: SPathMapTestRunner open.
	(self pathMap model getFlap: #testQuality)	switchExpandState.
	self pathMap model pathMap selectedAnalysis: #testQuality.
	self pathMap model runAll.! !

!SProjectCoverageTest methodsFor: 'running' stamp: 'mp 3/22/2013 14:06:05.746'!
tearDown

	self pathMap abandon.
	super tearDown.! !

!SProjectCoverageTest methodsFor: 'testing' stamp: 'mp 3/22/2013 14:06:38.51'!
test01RunCoverage

	self assert: self project coverage notEmpty.! !

!SProjectCoverageTest methodsFor: 'testing' stamp: 'mp 3/22/2013 14:19:19.905'!
test02CoveredTestsForMethod
	"covered by one test"
	self assert: (self project coveredTestsFor: 
		(MethodReference class: SVisibleClock selector: #initInFrame:)) asArray = 		{(STestCaseEntryPoint class: TestDriver selector: #testRun).}.
	"covered by multiple tests"
	self assert: (self project coveredTestsFor: 
		(MethodReference class: TestDriver selector: #tearDown)) asArray = 
		{(STestCaseEntryPoint class: TestDriver selector: #testRun). 
		(STestCaseEntryPoint class: TestDriver selector: #testNoop).}.
	"Not covered"
	self assert: (self project coveredTestsFor: 
		(MethodReference class: Driver selector: #run)) asArray = {}.
	"Not in project"
	self assert: (self project coveredTestsFor: 
		(MethodReference class: SProjectTest selector: #tearDown)) asArray = {}.
! !

!SProjectCoverageTest methodsFor: 'testing' stamp: 'mp 8/9/2013 14:29:04.438'!
test03CoveredTestsForAClass
	"covered by one test"
	self assert: (self project coveredTestsForClass: Observer) asArray = 		{(STestCaseEntryPoint class: TestDriver selector: #testRun).}.
	"Not covered"
	self assert: (self project coveredTestsForClass: Driver) asArray = {}.
	"Not in project"
	self assert: (self project coveredTestsForClass: SProjectTest) asArray = {}.! !

SProjectTest subclass: #SProjectRegistryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectRegistryTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:53:13.09'!
test01EmptyProjectRegistry

	self assert: SProject projectRegistry isEmpty.
	self assert: SProject allProjects isEmpty.
	self assert: SProject allProjectNames isEmpty.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/16/2013 13:20:16.484'!
test02ProjectRegistryInitializeWithStandardProjects

	SProject addPredefinedProjects.
	self deny: SProject projectRegistry isEmpty.
	self assert: (SProject projectAt: #NeverUseThisSymbolAsAProjectyxnbcvejg) isNil.
	self assert: (SProject projectAt: #sunit) notNil.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:32.351'!
test03aProjectRegistryAtMonticelloProject
	| project |
	SProject addPredefinedProjects.
	project := SProject projectAt: #monticello.
	self assert: project notNil.
	self assert: project projectName == #monticello.
	self assert: project categories = #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks').! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:57.294'!
test03bProjectRegistryAtSUnitProject
	| project |
	SProject addPredefinedProjects.
	project := SProject projectAt: #sunit.
	self assert: project notNil.
	self assert: project projectName == #sunit.
	self assert: project categories = #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:53:01.969'!
test03cProjectRegistryAtSystemBrowserProject
	| project |
	SProject addPredefinedProjects.
	project := SProject projectAt: #systemBrowser.
	self assert: project notNil.
	self assert: project projectName == #systemBrowser.
	self assert: project categories = #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:52:23.366'!
test04AddNewProject
	| project |
	project := SProject name: #myProject categories: #(#'DontExists').
	self assert: (SProject projectAt: #myProject) isNil.
	SProject addProject: project.
	self assert: (SProject projectAt: #myProject) notNil.	! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 3/22/2013 11:58:36.951'!
test05RemoveProject

	SProject addPredefinedProjects.
	SProject removeProjectAt: #observerExample.
	self assert: (SProject projectAt: #observerExample) isNil.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 7/7/2010 16:53:18.927'!
test06ResetProjectRegistry

	SProject addPredefinedProjects.
	SProject reset.
	self assert: SProject projectRegistry isEmpty.! !

!SProjectRegistryTest methodsFor: 'tests' stamp: 'mp 3/25/2013 15:35:05.228'!
test07ProjectRegistryAllProjects
	SProject addPredefinedProjects.
	self assert: (SProject allProjects 
		collect: [:each | each projectName]) = 
	{#path. #sunit. #sandbox. #monticello. #null. #systemBrowser. #observerExample}.
	self assert: (SProject allProjectsWithoutNull 
		collect: [:each | each projectName]) =  
	{#path. #sunit. #sandbox. #monticello. #systemBrowser. #observerExample}.! !

!SProjectTest methodsFor: 'accessing' stamp: 'mp 3/22/2013 13:59:09.814'!
project

	^ SProject current! !

!SProjectTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:52:00.248'!
setUp

	oldRegistry := SProject projectRegistry.
	oldCurrentProject := SProject current.
	SProject reset.! !

!SProjectTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:52:04.062'!
tearDown
	SProject projectRegistry: oldRegistry.
	SProject setCurrentProject: oldCurrentProject.! !

!SProjectTest methodsFor: 'testing' stamp: 'mp 3/25/2013 15:25:43.212'!
test01ProjectInitialization
	self assert: SProject projectRegistry isEmpty. 
	self assert: self project isNil.
	SProject initialize. 
	self assert: SProject allProjectNames =  #(path sunit sandbox monticello null
												systemBrowser observerExample).
	self assert: SProject isNullProjectSelected.! !

TestCase subclass: #SRecordAndReplayTest
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Record-Replay'!

!SRecordAndReplayTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SRecordAndReplayTest methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:48'!
cache
	"Answer the value of cache"

	^ cache! !

!SRecordAndReplayTest methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:48'!
cache: anObject
	"Set the value of cache"

	cache := anObject! !

!SRecordAndReplayTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:58:36.095'!
setUp

	self cache: SReplayCache new.! !

!SRecordAndReplayTest methodsFor: 'running' stamp: 'mp 7/7/2010 16:57:54.603'!
tearDown

	SRecordReplayWrapper nuke.
	Smalltalk garbageCollect.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:57:51.617'!
testRecordDateAndTimeNow
	| time |
	(SRecordReplayWrapper on: #now inClass: DateAndTime class with: self cache) install.
	time := DateAndTime now.
	(Delay forSeconds: 1) wait.
	self assert: time = DateAndTime now.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:57:58.805'!
testRecordDateAndTimeNowUninstallWrapper
	| time wrapper |
	wrapper := (SRecordReplayWrapper on: #now inClass: DateAndTime class with: self cache) install.
	time := DateAndTime now.
	(Delay forSeconds: 1) wait.
	self assert: time = DateAndTime now.
	wrapper uninstall.
	self deny: time = DateAndTime now.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:58:05.997'!
testRecordMultipleRandoms

	| result1 result2 |
	(SRecordReplayWrapper on: #atRandom inClass: Integer with: self cache) install.
	result1 := 10000 atRandom.
	result2 := 9999 atRandom.
	self assert: 10000 atRandom = result1.
	self assert: 9999 atRandom = result2.! !

!SRecordAndReplayTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:58:02.317'!
testRecordRandom

	| result |
	(SRecordReplayWrapper on: #atRandom inClass: Integer with: self cache) install.
	result := 10000 atRandom.
	self assert: 10000 atRandom = result.! !

TestCase subclass: #SSBFaultLocalizationExampleTest
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBFaultLocalizationExampleTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBFaultLocalizationExampleTest methodsFor: 'accessing' stamp: 'mp 9/21/2011 14:23:30.654'!
example
	"Answer the value of example"

	^ example! !

!SSBFaultLocalizationExampleTest methodsFor: 'accessing' stamp: 'mp 9/21/2011 14:23:30.67'!
example: anObject
	"Set the value of example"

	example := anObject! !

!SSBFaultLocalizationExampleTest methodsFor: 'running' stamp: 'mp 9/21/2011 14:28:22.142'!
setUp
	self example: SSBFaultLocalizationExample new.! !

!SSBFaultLocalizationExampleTest methodsFor: 'testing' stamp: 'mp 9/21/2011 14:36:07.623'!
test123
	self example midX: 1 Y: 2 Z: 3.
	self assert: (self example mid) = 2.! !

!SSBFaultLocalizationExampleTest methodsFor: 'testing' stamp: 'mp 2/1/2012 11:26:10.884'!
test213
	"Expected Failure for Testing Fault Localization - do not add to #expectedFailures"
	self example midX: 2 Y: 1 Z: 3.
	self assert: (self example mid) = 2.! !

!SSBFaultLocalizationExampleTest methodsFor: 'testing' stamp: 'mp 9/21/2011 14:36:29.724'!
test321
	self example midX: 3 Y: 2 Z: 1.
	self assert: (self example mid) = 2.! !

!SSBFaultLocalizationExampleTest methodsFor: 'testing' stamp: 'mp 9/21/2011 14:36:39.001'!
test335
	self example midX: 3 Y: 3 Z: 5.
	self assert: (self example mid) = 3.! !

!SSBFaultLocalizationExampleTest methodsFor: 'testing' stamp: ''!
test534
	self example midX: 5 Y: 3 Z: 4.
	self assert: (self example mid) = 4.! !

!SSBFaultLocalizationExampleTest methodsFor: 'testing' stamp: 'mp 9/21/2011 14:37:00.606'!
test555
	self example midX: 5 Y: 5 Z: 5.
	self assert: (self example mid) = 5.! !

TestCase subclass: #SSBFaultLocalizationTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBFaultLocalizationTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBFaultLocalizationTest methodsFor: 'accessing' stamp: 'mp 11/5/2010 10:04:18.32'!
a
	"Answer the value of a"

	^ a! !

!SSBFaultLocalizationTest methodsFor: 'accessing' stamp: 'mp 11/5/2010 10:04:18.325'!
a: anObject
	"Set the value of a"

	a := anObject! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 14:10:33.885'!
setUp

	self a: SSBClassA new.! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 2/1/2012 11:26:26.044'!
testFailingMethodFault
	"Expected Failure for Testing Fault Localization - do not add to #expectedFailures"
	self deny: (self a failingMethod: false).! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 14:12:16.308'!
testFailingMethodPass

	self assert: (self a failingMethod: true).
	self a unaryMethod.! !

!SSBFaultLocalizationTest methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 16:50:03.059'!
xtestFailingMethodError
	self a doNothing.
	self deny: (self a failingMethod: 1)! !

TestCase subclass: #SSBTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBTest methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:35'!
a
	"Answer the value of a"

	^ a! !

!SSBTest methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:35'!
a: anObject
	"Set the value of a"

	a := anObject! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:28.17'!
setUp

	self a: SSBClassA new.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:35'!
tearDown

	self a doNothing.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:38'!
testBinary

	self assert: self a + 5 = 5.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 1/24/2012 15:21:40.139'!
testComplexTrace
	self assert: (self a complexMethod: 5) = 10.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:12.736'!
testConstructor

	self assert: (SSBClassB on: 1) myValue = 1.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 1/24/2012 15:21:35.298'!
testDelay
	<ignoreForHarvesting>
	"Required for Profiling"
	self assert: self a delayedMethod.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:38'!
testDoNothing

	self assert: self a doNothing = self a.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:34'!
testInitialize

	self assert: self a myValue = 0.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 11/8/2010 17:01:53.424'!
testLongParameterMethod
	self a param: 1 method: 2.
	self a manyParameters: 1 b: 2 d: 3 f: 4 long: 5! !

!SSBTest methodsFor: 'testing' stamp: 'mp 5/8/2012 11:55:52.523'!
testMethodChain

	self assert: (self a methodChain: (self a methodChain: (self a methodChain: 1) + 1) + 1) = 3.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:14.617'!
testModelView

	| b |
	b := SSBClassB new.
	self a myValue: 1.
	self assert: b myValue isNil.
	self a addDependent: b.
	self a myValue: 2.
	self assert: b myValue = 2.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 11/8/2010 15:37:20.516'!
testMultipleByteCodePaths

	self assert: (self a param: 5 method: 2) = 4.
	self assert: (self a param: 3 method: 2) = #(3 2).! !

!SSBTest methodsFor: 'testing' stamp: ''!
testOwnCollectionType
	| dict |
	dict := SSBDictionary in: 123.
	dict symbolFor: #abc.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:40'!
testParamMethod

	self assert: (self a param: 1 method: 2) = #(1 2).
	self assert: self a myValue = #(1 2).! !

!SSBTest methodsFor: 'testing' stamp: 'mp 8/14/2013 15:33:20.585'!
testParamMethod2
	"Expected Failure for Testing Fault Localization - do not add to #expectedFailures"
	self assert: (self a param: 5 method: 2) = 5.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:32:14.64'!
testPartial

	self assert: self a doNothing = self a.
	self assert: SPartialTraceObject new doSomething.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 5/9/2012 10:52:35.499'!
testPolymorphie

	self assert: (SSBClassC new complexMethod: 5) = 10! !

!SSBTest methodsFor: 'testing' stamp: 'mp 1/24/2012 16:08:04.563'!
testPrintString
	<ignore>
	self a myValue: 5.
	self assert: self a asString = '5'.
	! !

!SSBTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:37:30.165'!
testRecursion

	self assert: (SSBClassA new recursionMethod: 5) = 15.! !

!SSBTest methodsFor: 'testing' stamp: 'mp 3/8/2010 14:37'!
testUnary

	self assert: self a unaryMethod.! !

TestCase subclass: #SSBTypeTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBTypeTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBTypeTest methodsFor: 'as yet unclassified' stamp: 'mp 5/14/2013 14:19:21.459'!
testCollection
	| d collection |
	d := SSBClassD new.
	collection := {1. 2. 3.}.
	d myValue2: collection.
	^ collection! !

!SSBTypeTest methodsFor: 'as yet unclassified' stamp: 'mp 5/14/2013 14:22:19.281'!
testDictionary
	| d dictionary |
	d := SSBClassD new.
	dictionary := Dictionary new 
					at: 1 put: #abc; 
					yourself.
	d myValue3: dictionary.
	^ d myValue! !

!SSBTypeTest methodsFor: 'as yet unclassified' stamp: 'mp 1/21/2013 15:14:25.203'!
testObject
	| d |
	d := SSBClassD new.
	d myValue: 2.! !

TestCase subclass: #SSBValueRangeTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBValueRangeTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBValueRangeTest methodsFor: 'running' stamp: 'mp 2/6/2012 16:00:35.311'!
setUp
	object := SSBClassD new.! !

!SSBValueRangeTest methodsFor: 'test-boolean' stamp: ''!
testBoolean

	object myValue: true.
	object myValue2: false.
	object myValue3: nil.! !

!SSBValueRangeTest methodsFor: 'test-characters' stamp: 'mp 2/8/2012 14:52:26.164'!
testCharacters1

	object myValue: $1.	
	object myValue: $a.
	object myValue: $C.	
	object myValue: Character space.
	object myValue: $?.! !

!SSBValueRangeTest methodsFor: 'test-characters' stamp: 'mp 2/8/2012 14:52:56.135'!
testCharacters2

	object myValue2: $Z.
	object myValue2: $a.	
	object myValue2: nil.! !

!SSBValueRangeTest methodsFor: 'test-characters' stamp: 'mp 2/8/2012 14:54:29.859'!
testCharacters3

	object myValue3: $.! !

!SSBValueRangeTest methodsFor: 'test-collections' stamp: 'mp 2/10/2012 09:59:48.086'!
testCollection1

	object myValue: {1. 2. 3}.
	object myValue: {4. 5. 6. 7}.	
	object myValue: {}.	! !

!SSBValueRangeTest methodsFor: 'test-collections' stamp: 'mp 2/10/2012 10:00:49.178'!
testCollection2

	object myValue2: {1. 2. 3}.
	object myValue2: {4. 5. 6. 4} asSet.	
	object myValue2: (Dictionary newFrom: {1->2. 2->3. 3->4}).	! !

!SSBValueRangeTest methodsFor: 'test-datetime' stamp: 'mp 2/10/2012 11:35:02.087'!
testDateAndTime1

	object myValue: DateAndTime now.! !

!SSBValueRangeTest methodsFor: 'test-datetime' stamp: 'mp 2/10/2012 11:35:38.812'!
testDateAndTime2

	object myValue2: DateAndTime tomorrow.
	object myValue2: nil.
	object myValue2: DateAndTime today.
	object myValue2: DateAndTime yesterday.! !

!SSBValueRangeTest methodsFor: 'test-duration' stamp: 'mp 2/10/2012 12:08:53.759'!
testDuration1

	object myValue: (Duration seconds: 10).
	object myValue: (Duration seconds: -10).
	object myValue: (Duration seconds: 0).! !

!SSBValueRangeTest methodsFor: 'test-duration' stamp: 'mp 2/10/2012 12:09:25.541'!
testDuration2

	object myValue2: (Duration nanoSeconds: 10).
	object myValue2: (Duration nanoSeconds: -10).
	object myValue2: (Duration nanoSeconds: 0).! !

!SSBValueRangeTest methodsFor: 'test-duration' stamp: 'mp 2/10/2012 12:10:11.441'!
testDuration3

	object myValue3: (Duration days: 1).
	object myValue3: nil.
	object myValue3: (Duration nanoSeconds: 10000).! !

!SSBValueRangeTest methodsFor: 'as yet unclassified' stamp: 'mp 3/30/2012 13:22:59.869'!
testEvil
	object myValue: 0.
	SSBClassA new + 2.3.! !

!SSBValueRangeTest methodsFor: 'test-numbers' stamp: 'mp 2/6/2012 16:04:38.977'!
testNumbers1

	object myValue: 1.	
	object myValue: 3.
	object myValue: 7.	
	object myValue: 10.! !

!SSBValueRangeTest methodsFor: 'test-numbers' stamp: 'mp 2/6/2012 16:04:59.826'!
testNumbers2

	object myValue2: -1.	
	object myValue2: 3.
	object myValue2: 0.	
	object myValue2: -7.	
	object myValue2: 10.! !

!SSBValueRangeTest methodsFor: 'test-numbers' stamp: 'mp 2/6/2012 16:05:35.282'!
testNumbers3

	object myValue3: -1.43.	
	object myValue3: 3.123.
	object myValue3: 0.	
	object myValue3: (-1/3).	
	object myValue3: 10.! !

!SSBValueRangeTest methodsFor: 'test-numbers' stamp: 'mp 2/6/2012 16:06:35.948'!
testNumbers4

	object myValue4: 1.	
	object myValue4: nil.
	object myValue4: 1.			
! !

!SSBValueRangeTest methodsFor: 'test-streams' stamp: 'mp 2/10/2012 14:09:37.364'!
testStreams1

	object myValue: (WriteStream on: String new)! !

!SSBValueRangeTest methodsFor: 'test-streams' stamp: 'mp 2/10/2012 14:11:09.22'!
testStreams2

	object myValue2: (WriteStream on: OrderedCollection new).
	object myValue2: nil.
	object myValue2: (ReadStream on: 'abcdef').! !

!SSBValueRangeTest methodsFor: 'test-strings' stamp: 'mp 2/8/2012 17:32:50.956'!
testString1

	object myValue: 'This is a sentence.'.
! !

!SSBValueRangeTest methodsFor: 'test-strings' stamp: 'mp 2/8/2012 17:35:19.227'!
testString2

	object myValue2: 'This is a sentence with a mitsake.'.	
! !

!SSBValueRangeTest methodsFor: 'test-strings' stamp: 'mp 2/8/2012 17:36:30.209'!
testString3

	object myValue3: '123456'.
	object myValue3: nil.
	object myValue3: 'Content-Lenght?'.
	
! !

!SSBValueRangeTest methodsFor: 'test-strings' stamp: 'mp 8/6/2013 15:49:57.726'!
testString4

	object myValue4: '1 halt.'.
	object myValue4: '/abcdef/ghi.txt'.
	object myValue4: 'This is a sentence.'.
	object myValue4: '12.31.2012'.
	object myValue4: FileDirectory default pathName asString.
! !

!SSBValueRangeTest methodsFor: 'test-strings' stamp: 'mp 5/6/2013 11:42:06.872'!
testString5

	object myValue4: '  '.
	object myValue4: ''.! !

TestCase subclass: #SSourceCodeIdiomsTest
	instanceVariableNames: 'pathCategories pathClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Idioms'!

!SSourceCodeIdiomsTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSourceCodeIdiomsTest methodsFor: 'accessing' stamp: 'mp 5/3/2013 13:22:54.278'!
pathCategories
	"Answer the value of pathCategories"

	^ pathCategories! !

!SSourceCodeIdiomsTest methodsFor: 'accessing' stamp: 'mp 5/3/2013 13:22:54.295'!
pathCategories: anObject
	"Set the value of pathCategories"

	pathCategories := anObject! !

!SSourceCodeIdiomsTest methodsFor: 'accessing' stamp: 'mp 5/3/2013 13:22:54.313'!
pathClasses
	"Answer the value of pathClasses"

	^ pathClasses! !

!SSourceCodeIdiomsTest methodsFor: 'accessing' stamp: 'mp 5/3/2013 13:22:54.33'!
pathClasses: anObject
	"Set the value of pathClasses"

	pathClasses := anObject! !

!SSourceCodeIdiomsTest methodsFor: 'running' stamp: 'mp 5/3/2013 13:22:21.027'!
setUp
	super setUp.
	self pathCategories: (SCategoryChooser allCategories 
							select: [:each | each startsWith: 'Path-']).
	self pathClasses: (Smalltalk allClasses select: [:each | 
						self pathCategories includes: each category]).! !

!SSourceCodeIdiomsTest methodsFor: 'testing' stamp: 'mp 5/3/2013 13:34:53.488'!
test01EnsureHashImplementationsByEquality
	| classesWithEqual |
	classesWithEqual := self pathClasses select: [:each | each includesSelector: #=].
	self 
		assert: classesWithEqual notEmpty;
		assert: (classesWithEqual allSatisfy: [:each | each includesSelector: #hash]);
		assert: (classesWithEqual allSatisfy: [:each | 
					[each new hash ~= each new scaledIdentityHash] 
						on: MessageNotUnderstood do: [true] 
						"Ignore not correct initialized objects"]).! !

TestCase subclass: #STracerTest
	instanceVariableNames: 'oldCurrentProject tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!STracerTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

STracerTest subclass: #SCallTreeTest
	instanceVariableNames: 'callTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SCallTreeTest subclass: #SCallTreeFailingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeFailingTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallTreeFailingTest class methodsFor: 'hooks' stamp: 'mp 7/12/2013 13:38:00.377'!
test
	^ MethodReference class: SSBFaultLocalizationTest selector: #testFailingMethodFault.! !

!SCallTreeFailingTest methodsFor: 'testing' stamp: 'mp 7/12/2013 13:45:01.812'!
test01FailureExceptionInRegistry
	| signal |
	signal := SwaTestExceptionRegistry 
				at: (self class test actualClass selector: self class test selector) 
				ifAbsent: nil.
	self 
		assert: signal notNil;
		assert: signal asString = 'TestFailure: Assertion failed'.
! !

!SCallTreeFailingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:01:50.251'!
test02FailureExceptionInEntryPoint

	self callTree rootNode asString = 'Entry Point - TestFailure: Assertion failed'.! !

SCallTreeTest subclass: #SCallTreeFunctionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeFunctionsTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:54.418'!
testBrowseSelectedNode

	| browser |
	self assert: self callTree browseMethod == self callTree.
	self callTree newSelectedItem: (self getNode: 12).
	browser := self callTree browseMethod.
	self assert: browser class == SBrowser.
	self assert: browser selectedClass == SSBClassB.
	self assert: browser selectedMessageName == #compute.
	self flag: #mpe. "Find a better way to close the system window"
	browser dependents first delete.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:06.275'!
testExpandRootNode

	self assert: self callTree selectedItem isNil.
	self callTree expandRootNode.
	self assert: self callTree selectedItem == self rootNode.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:14.039'!
testExpandSelectedNode

	self callTree expandSelectedNode.
	self assert: self callTree selectedItem == self rootNode.
	self callTree newSelectedItem: (self getNode: 12).
	self callTree expandSelectedNode.
	self assert: self callTree selectedItem ==(self getNode: 12).! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:17.718'!
testFindNodeFromRoot

	self assert: (self callTree findNodeInSubGraph: 0 startNode: self rootNode) isNil.
	self assert: (self callTree findNodeInSubGraph: 12 startNode: self rootNode) id = 12.
	self assert: (self callTree findNodeInSubGraph: 22 startNode: self rootNode) id = 22.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:23.263'!
testFindNodeWithinSubtree

	| node |
	node := self getNode: 12.
	self assert: (self callTree findNodeInSubGraph: 0 startNode: node) isNil.
	self assert: (self callTree findNodeInSubGraph: 12 startNode: node) isNil.
	self assert: (self callTree findNodeInSubGraph: 22 startNode: node) isNil.
	
	self assert: (self callTree findNodeInSubGraph: 13 startNode: node) id = 13.
	self assert: (self callTree findNodeInSubGraph: 19 startNode: node) id = 19.	! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:26.791'!
testFindNotExistingNode

	self assert: (self callTree findNodeInSubGraph: -1 startNode: self rootNode) isNil.
	self assert: (self callTree findNodeInSubGraph: 23 startNode: self rootNode) isNil.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:31.926'!
testGetSelectedPath

	| path |
	self callTree newSelectedItem: (self getNode: 12).
	path := self callTree getSelectedPath.
	self assert: path = (OrderedCollection 
								with: self rootNode 
								with: (self getNode: 5) 
								with: (self getNode: 7) 
								with: (self getNode: 12))! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:37.114'!
testNewSelectedItem

	self assert: self callTree selectedItem isNil.
	self callTree newSelectedItem: (self getNode: 12).
	self assert: self callTree selectedItem notNil.
	self assert: self callTree selectedItem == (self getNode: 12).! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:03:41.764'!
testNumberOfCallsBefore

	| node |
	self assert: (self callTree numberOfCallsBefore: self rootNode) = 0.
	node := self getNode: 12.
	self assert: (self callTree numberOfCallsBefore: node) = 0.
	node := self getNode: 13.
	self assert: (self callTree numberOfCallsBefore: node) = 0.
	node := self getNode: 15.
	self assert: (self callTree numberOfCallsBefore: node) = 1.	
	node := self getNode: 16.
	self assert: (self callTree numberOfCallsBefore: node) = 2.	! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:03:28.072'!
testTraverseCallTreeFromRoot

	| collection |
	collection := OrderedCollection new.
	self callTree traverseCallTree: self rootNode with: [:each | collection add: each id].
	self assert: (1 to: 22) asOrderedCollection = collection.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:02:54.09'!
testTraverseCallTreeFromRootWithAbort

	| collection |
	collection := OrderedCollection new.
	self callTree 
		traverseCallTree: self rootNode 
		with: [:each | collection add: each id] abort: [:each | each id > 10].
	self assert: #(1 2 3 4 5 6 7 8 9 10 11 12 20) asOrderedCollection = collection.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:03:31.359'!
testTraverseCallTreeFromSubTree

	| collection node |
	node := self getNode: 12.
	collection := OrderedCollection new.
	self callTree traverseCallTree: node with: [:each | collection add: each id].
	self assert: (13 to: 19) asOrderedCollection = collection.! !

!SCallTreeFunctionsTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:02:56.168'!
testTraverseCallTreeFromSubTreeWithAbort

	| collection node |
	node := self getNode: 12.
	collection := OrderedCollection new.
	self callTree 
		traverseCallTree: node 
		with: [:each | collection add: each id] abort: [:each | each id > 15].
	self assert: (13 to: 18) asOrderedCollection = collection.! !

SCallTreeTest subclass: #SCallTreeHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeHistoryTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:04:16.692'!
testAddToHistory

	self assert: self callTree history isEmpty.
	self assert: self callTree currentHistoryNode = 0.
	self callTree newSelectedItem: self rootNode.
	self assert: self callTree history notEmpty.	
	self assert: self callTree history size = 1.
	self assert: self callTree history first == self rootNode.
	self assert: self callTree currentHistoryNode = 1.! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:04:22.434'!
testAddToHistorySameItemTwice

	self callTree newSelectedItem: self rootNode.
	self callTree newSelectedItem: self rootNode.
	self assert: self callTree history notEmpty.	
	self assert: self callTree history size = 1.
	self assert: self callTree history first == self rootNode.
	self assert: self callTree currentHistoryNode = 1.! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:04:32.588'!
testAddToHistoryTwoItems

	self callTree newSelectedItem: self rootNode.
	self callTree newSelectedItem: (self getNode: 12).
	self assert: self callTree history notEmpty.	
	self assert: self callTree history size = 2.
	self assert: self callTree history first == self rootNode.
	self assert: self callTree history second == (self getNode: 12).
	self assert: self callTree currentHistoryNode = 2.! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:04:37.023'!
testHistoryBack

	self callTree newSelectedItem: self rootNode.
	self callTree newSelectedItem: (self getNode: 12).
	self callTree newSelectedItem: (self getNode: 1).
	self callTree historyBack.
	self assert: self callTree selectedItem == (self getNode: 12).
	self callTree historyBack.
	self assert: self callTree selectedItem == self rootNode.! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:04:41.279'!
testHistoryBackAndForth

	self callTree newSelectedItem: self rootNode.
	self callTree newSelectedItem: (self getNode: 12).
	self callTree newSelectedItem: (self getNode: 1).
	self callTree historyBack.
	self assert: self callTree selectedItem == (self getNode: 12).
	self callTree historyPrevious.
	self assert: self callTree selectedItem == (self getNode: 1).! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:06.336'!
testHistoryBackAndNewSelectedItem

	self callTree newSelectedItem: self rootNode.
	self callTree newSelectedItem: (self getNode: 12).
	self callTree newSelectedItem: (self getNode: 1).
	self callTree historyBack.
	self callTree historyBack.
	self callTree newSelectedItem: (self getNode: 10).
	self assert: self callTree history size = 2.
	self assert: self callTree history first == self rootNode.
	self assert: self callTree history second == (self getNode: 10).
! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:10.424'!
testHistoryBackButtonEnabled

	self deny: self callTree historyBackButtonEnabled.
	self callTree newSelectedItem: self rootNode.
	self deny: self callTree historyBackButtonEnabled.
	self callTree newSelectedItem: (self getNode: 12).
	self assert: self callTree historyBackButtonEnabled.
	self callTree historyBack.
	self deny: self callTree historyBackButtonEnabled.
	self callTree historyPrevious.
	self assert: self callTree historyBackButtonEnabled.
	! !

!SCallTreeHistoryTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:14.36'!
testHistoryPreviousButtonEnabled

	self deny: self callTree historyPreviousButtonEnabled.
	self callTree newSelectedItem: self rootNode.
	self callTree newSelectedItem: (self getNode: 12).
	self deny: self callTree historyPreviousButtonEnabled.
	self callTree historyBack.
	self assert: self callTree historyPreviousButtonEnabled.
	self callTree historyPrevious.
	self deny: self callTree historyPreviousButtonEnabled.! !

SCallTreeTest subclass: #SCallTreeModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeModelTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:10:24.657'!
testCallTreeCallStackOfNode12

	| node |
	node := self getNode: 12.
	self assert: node getCallStack notEmpty.
	self assert: node getCallStack size = 4.
	self assert: node getCallStack = (OrderedCollection 
								with: self rootNode 
								with: (self getNode: 5) 
								with: (self getNode: 7) 
								with: node)! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:10:33.353'!
testCallTreeCheckNode12

	| node |
	node := self getNode: 12.
	self assert: node clientClass == SSBClassB.
	self assert: node clientSelector == #compute.	! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:10:42.804'!
testCallTreeChildrenOfNode12

	| node |
	node := self getNode: 12.
	self assert: node nextCalls notEmpty.
	self assert: node nextCalls size = 6.
	self assert: node nextCalls = (OrderedCollection 
								with: (self getNode: 13) 
								with: (self getNode: 14) 
								with: (self getNode: 15) 
								with: (self getNode: 16)
								with: (self getNode: 17)
								with: (self getNode: 18))! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:10:49.786'!
testCallTreeFromSenderOfNode12

	| node |
	node := self getNode: 12.
	self assert: node fromSender clientClass == SSBClassA.
	self assert: node fromSender clientSelector == #complexMethod:.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:11:09.919'!
testCallTreeInitialization

	| testCallTree |
	testCallTree := SCallTreeModel on: self tracer.
	self assert: testCallTree rootNode isNil.
	self assert: testCallTree currentNode isNil.
	self assert: testCallTree history isEmpty.
	self assert: testCallTree currentHistoryNode = 0.
	self assert: testCallTree selectedItem isNil.
	self assert: testCallTree highlightedItems isEmpty.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:11:18.453'!
testCallTreeRootNode

	self assert: self callTree rootNode clientClass == SSBTest.
	self assert: self callTree rootNode clientSelector == #testComplexTrace.
	self assert: self callTree rootNode nextCalls notEmpty.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:24.719'!
testGetChildren

	self assert: (self callTree getChildren: self rootNode) size = 3.
	self assert: (self callTree getChildren: (self getNode: 12)) size = 6.
	self assert: (self callTree getChildren: (self getNode: 22)) isEmpty.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:28.559'!
testHasChildren

	self assert: (self callTree hasChildren: self rootNode).
	self assert: (self callTree hasChildren: (self getNode: 12)).
	self deny: (self callTree hasChildren: (self getNode: 22)).! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:03:48.948'!
testNumberOfNodesWithinCallTree

	| number |
	number := 0.
	self callTree 
		traverseCallTree: self callTree rootNode 
		with: [:aNode | number := number + 1].
	self assert: number = 22.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:44.586'!
testReset

	self assert: self callTree rootNode notNil.
	self callTree reset.
	self assert: self callTree rootNode isNil.
	self assert: self callTree currentNode isNil.
	self assert: self callTree history isEmpty.
	self assert: self callTree currentHistoryNode = 0.
	self assert: self callTree selectedItem isNil.
	self assert: self callTree highlightedItems isEmpty.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:05:52.026'!
testRootCallNodes

	self assert: self callTree rootCallNodes notEmpty.
	self assert: self callTree rootCallNodes size = 1.
	self assert: self callTree rootCallNodes first clientClass == SSBTest.
	self assert: self callTree rootCallNodes first clientSelector == #testComplexTrace.! !

!SCallTreeModelTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:06:06.073'!
testStartingCallNodes

	self assert: self callTree startingCallNodes notEmpty.
	self assert: self callTree startingCallNodes size = 3.
	self assert: self callTree startingCallNodes first clientSelector == #setUp.
	self assert: self callTree startingCallNodes second clientSelector == 
		#testComplexTrace.
	self assert: self callTree startingCallNodes third clientSelector == #tearDown.! !

SCallTreeTest subclass: #SCallTreeSearchingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeSearchingTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:07.539'!
testGetSearchQuery

	self assert: self callTree searchQuery isNil.
	self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: self callTree searchQuery = 'SSBClassB>>myValue'.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:14.15'!
testMultipleItemSearching

	| result |
	result := self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: result size = 4.
	self assert: result first id = 11.
	self assert: result second id = 13.
	self assert: result third id = 15.
	self assert: result fourth id = 16.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:19.456'!
testNotExistingItemSearching

	| result |
	result := self callTree searchNode: 'XXX'.
	self assert: result isEmpty.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:23.002'!
testSearchingAndHighlighting

	self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: self callTree highlightedItems size = 4.
	self assert: self callTree highlightedItems first id = 11.
	self assert: self callTree highlightedItems second id = 13.
	self assert: self callTree highlightedItems third id = 15.
	self assert: self callTree highlightedItems fourth id = 16.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:26.761'!
testSearchingAndSelectFirstResult

	self assert: self callTree selectedItem isNil.
	self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: self callTree selectedItem id = 11.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:31.809'!
testSearchingAndSelectNextResult

	self assert: self callTree selectedItem isNil.
	self callTree searchNode: 'SSBClassB>>myValue'.
	self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: self callTree selectedItem id = 13.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:35.329'!
testSearchingAndSelectNextResultAfterCurrentSelection

	self callTree newSelectedItem: (self getNode: 14).
	self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: self callTree selectedItem id = 15.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:40.256'!
testSearchingAndSelectNextResultAfterEndOfTree

	self callTree newSelectedItem: (self getNode: 22).
	self callTree searchNode: 'SSBClassB>>myValue'.
	self assert: self callTree selectedItem id = 11.! !

!SCallTreeSearchingTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:07:43.486'!
testSingleItemSearching

	| result |
	result := self callTree searchNode: 'SSBClassB>>compute'.
	self assert: result size = 1.
	self assert: result first = (self getNode: 12).! !

SCallTreeTest subclass: #SCallTreeSteppingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SCallTreeSteppingTest commentStamp: 'mp 12/9/2013 13:57:45.477' prior: 0!
A SCallTreeSteppingTest is xxxxxxxxx.

Instance Variables

The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/13/2013 12:11:25.894'!
testStepBack
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 5).
	self callTree stepOver.
	self callTree stepBack.
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 3.
	self assert: (self getNode: 6) isPartOfSteppingSelection.
	self assert: (self getNode: 7) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/14/2013 12:39:31.319'!
testStepBackFirstByteCode
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 7).
	self callTree stepBack.
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 5.
	self assert: (self getNode: 7) isPartOfSteppingSelection.
	self assert: (self getNode: 6) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/13/2013 12:14:00.834'!
testStepInto
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 5).
	self callTree stepOver.
	self callTree stepInto.
	self assert: self callTree steppingNode == (self getNode: 7).
	self assert: self callTree steppingPosition == 3.
	self assert: (self getNode: 8) isPartOfSteppingSelection.
	self assert: (self getNode: 9) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/14/2013 16:06:47.166'!
testStepIntoNoNextCall
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 12).
	self callTree steppingPosition: 4.
	self callTree stepInto.
	self assert: self callTree steppingNode == (self getNode: 12).
	self assert: self callTree steppingPosition == 4.
	self assert: (self getNode: 15) isPartOfSteppingSelection not.
	self assert: (self getNode: 16) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/13/2013 12:07:58.692'!
testStepIntoNode
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 5).
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 3.
	self assert: (self getNode: 6) isPartOfSteppingSelection.
	self assert: (self getNode: 7) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'mp 12/9/2013 15:41:55.465'!
testStepIntoQuick
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 7).
	self callTree steppingPosition: 6.
	self callTree stepInto.
	self assert: self callTree steppingNode == (self getNode: 9).
	"self assert: self callTree steppingPosition = 0." 
		"0 depends on Cog VM, otherwise can differ, e.g. 2"! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/13/2013 12:10:08.993'!
testStepOver
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 5).
	self callTree stepOver.
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 5.
	self assert: (self getNode: 7) isPartOfSteppingSelection.
	self assert: (self getNode: 6) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/14/2013 11:13:42.319'!
testStepOverLastBytecode
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 10).
	self callTree steppingPosition: 5.
	self callTree stepOver.
	self assert: self callTree steppingNode == (self getNode: 7).
	self assert: self callTree steppingPosition == 13.
	self assert: (self getNode: 12) isPartOfSteppingSelection.
	self assert: (self getNode: 11) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/13/2013 12:16:01.751'!
testStepReturn
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 7).
	self callTree stepReturn.
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 7.
	self assert: (self getNode: 6) isPartOfSteppingSelection not.
	self assert: (self getNode: 7) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/14/2013 13:39:36.639'!
testStepReturnLastCallNode
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 20).
	self callTree stepReturn.
	self assert: self callTree steppingNode == (self getNode: 20).
	self assert: self callTree steppingPosition == 2.
	self assert: (self getNode: 21) isPartOfSteppingSelection.
	self assert: (self getNode: 22) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/13/2013 12:15:15.168'!
testStepToSender
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 7).
	self callTree stepToSender.
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 5.
	self assert: (self getNode: 7) isPartOfSteppingSelection.
	self assert: (self getNode: 6) isPartOfSteppingSelection not.! !

!SCallTreeSteppingTest methodsFor: 'testing' stamp: 'BS 11/14/2013 13:40:23.655'!
testStepToSenderNoSender
	self assert: self callTree steppingNode isNil.
	self callTree stepInto: (self getNode: 5).
	self callTree stepToSender.
	self assert: self callTree steppingNode == (self getNode: 5).
	self assert: self callTree steppingPosition == 3.
	self assert: (self getNode: 6) isPartOfSteppingSelection.
	self assert: (self getNode: 7) isPartOfSteppingSelection not.! !

!SCallTreeTest class methodsFor: 'hooks' stamp: 'mp 7/12/2013 13:36:32.942'!
test
	^ MethodReference class: SSBTest selector: #testComplexTrace.! !

!SCallTreeTest methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:00:58.217'!
callTree

	^ callTree! !

!SCallTreeTest methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:00:58.223'!
callTree: anObject

	callTree := anObject! !

!SCallTreeTest methodsFor: 'helper' stamp: 'mp 7/16/2013 16:02:15.515'!
getNode: anId

	^ self callTree findNodeInSubGraph: anId startNode: self callTree rootNode! !

!SCallTreeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:25:15.06'!
setUp

	super setUp.
	self tracer traceTest: self class test actualClass method: self class test selector.
	self callTree: self tracer callTreeModel.! !

SCallTreeTest subclass: #SObjectExplorerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-CallTree'!

!SObjectExplorerTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 4/24/2010 18:43'!
testClearObjectCache

	| callNode |
	callNode := self getNode: 12.
	self assert: callNode objects isEmpty.
	callNode explore: #return.
	self assert: callNode objects notEmpty.
	callNode clearObjectCache.
	self assert: callNode objects isEmpty.! !

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:36:25.56'!
testExploreFullCallNode

	| callNode |
	callNode := self getNode: 12.
	self assert: callNode objects isEmpty.
	callNode 
		explore: #types;
		explore: #arguments;
		explore: #selfBefore;
		explore: #selfAfter;
		explore: #return.
	self assert: callNode objects notNil.
	self assert: (callNode objects at: #types) = 
		(OrderedCollection with: #self->SSBClassB with: #result->SmallInteger)."types" 
	self assert: (callNode objects at: #arguments) first = #(). "args" 
	self assert: (callNode objects at: #selfBefore) first myValue myValue = 5. "selfBefore"
	self assert: (callNode objects at: #selfAfter) first myValue myValue = 5. "selfAfter"
	self assert: (callNode objects at: #return) first = 10. "return"
! !

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:19:33.071'!
testExploreReturnObject

	| callNode |
	callNode := self getNode: 12.
	self assert: callNode objects isEmpty.
	self assert: ((callNode explore: #return) first = 10).
	self assert: callNode objects notEmpty.
	self assert: ((callNode objects at: #return) first = 10).
	callNode callTreeModel: nil. 
	"get cached value without callTree access - no reload is possible"
	self assert: ((callNode explore: #return) first = 10).! !

!SObjectExplorerTest methodsFor: 'testing' stamp: 'mp 4/24/2010 18:51'!
testInitialization
	
	| callNode |
	callNode := self getNode: 12.
	self assert: callNode tracer == self tracer.
	self assert: callNode objects isEmpty.		! !

STracerTest subclass: #STracerCoreTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!STracerCoreTraceTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:31:51.918'!
testBinaryMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testBinary.
	nodes := self callTreeGetNodesFor: SSBClassA method: #+.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testBinary.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:31:59.956'!
testClassMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testConstructor.
	nodes := self callTreeGetNodesFor: SSBClassB class method: #on:.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testConstructor.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:40.144'!
testGetNode

	self tracer traceTest: SSBTest method: #testDoNothing.
	self assert: (self tracer getNode: 0) == self rootNode.
	self assert: (self tracer getNode: -1) isNil.
	self assert: (self tracer getNode: 1) == self rootNode nextCalls first.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:02.481'!
testMethodChainTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testMethodChain.
	nodes := self callTreeGetNodesFor: SSBClassA method: #methodChain:.
	self assert: nodes size = 3.
	nodes do: [:each | 
		self assert: each fromSender clientClass == SSBTest.
		self assert: each fromSender clientSelector == #testMethodChain].! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:13.33'!
testModelViewTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testModelView.
	nodes := self callTreeGetNodesFor: SSBClassA method: #myValue:.
	self assert: nodes size = 3.
	self assert: nodes first nextCalls isEmpty.
	self assert: nodes second nextCalls isEmpty.
	self assert: nodes third nextCalls notEmpty.
	self assert: nodes third nextCalls first == (self callTreeGetNodesFor: SSBClassB method: #update:) first.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:54'!
testNextId

	self assert: self tracer currentId = -1.
	self assert: self tracer nextId = 0.
	self assert: self tracer currentId = 0.
	self assert: self tracer nextId = 1.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:15.183'!
testParameterMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testParamMethod.
	nodes := self callTreeGetNodesFor: SSBClassA method: #param:method:.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testParamMethod.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:18.771'!
testPartialTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testPartial.
	nodes := self callTreeGetNodesFor: Behavior method: #new.
	self assert: nodes isEmpty.
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	self assert: nodes notEmpty.
	nodes := self callTreeGetNodesFor: SPartialTraceObject method: #doSomething.
	self assert: nodes isEmpty.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:20.842'!
testRecursionTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testRecursion.
	nodes := self callTreeGetNodesFor: SSBClassA method: #recursionMethod:.
	self assert: nodes size = 6.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testRecursion.
	self assert: nodes second fromSender clientClass == SSBClassA.
	self assert: nodes second fromSender clientSelector == #recursionMethod:.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:37:06.805'!
testRunSingleWrapper

	| wrappers nodes |
	wrappers := OrderedCollection new.
	self tracer createNewCallTreeOn: SSBTest with: #testDoNothing.
	[self tracer createWrapperOn: SSBClassA and: #doNothing addTo: wrappers.
	SSBClassA new doNothing] 
		ensure: [wrappers first uninstall].
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testDoNothing.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:45.115'!
testSetUpTestTearDownTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callTreeGetNodesFor: SSBTest method: #setUp.
	self assert: nodes size = 1.
	self assert: nodes first fromSender == self rootNode.
	nodes := self callTreeGetNodesFor: SSBTest method: #testDoNothing.
	self assert: nodes size = 1.
	self assert: nodes first fromSender == self rootNode.
	nodes := self callTreeGetNodesFor: SSBTest method: #tearDown.
	self assert: nodes size = 1.
	self assert: nodes first fromSender == self rootNode.! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:50.371'!
testTraceOverClassBorders

	| nodes |
	self tracer traceTest: SSBTest method: #testComplexTrace.
	nodes := self callTreeGetNodesFor: SSBClassA method: #complexMethod:.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testComplexTrace.
	nodes := self callTreeGetNodesFor: SSBClassB method: #compute.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBClassA.
	self assert: nodes first fromSender clientSelector == #complexMethod:.	! !

!STracerCoreTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:52.275'!
testUnaryMethodTrace

	| nodes |
	self tracer traceTest: SSBTest method: #testUnary.
	nodes := self callTreeGetNodesFor: SSBClassA method: #unaryMethod.
	self assert: nodes size = 1.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testUnary.! !

STracerTest subclass: #STracerInitializeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!STracerInitializeTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:37:10.946'!
testCreateCallNode

	| nodes |
	self tracer createNewCallTreeOn: SSBTest with: #testDoNothing.
	self assert: (self tracer 
				createNewCallNodeOn: SSBClassB with: #compute receiverType: SSBClassB callsBefore: 0) = 1.
	nodes := self callTreeGetNodesFor: SSBClassB method: #compute.
	self assert: nodes notEmpty.
	self assert: nodes first fromSender clientClass == SSBTest.
	self assert: nodes first fromSender clientSelector == #testDoNothing.
	! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:39:16.191'!
testCreateNewCallTree

	self assert: self rootNode isNil.
	self tracer createNewCallTreeOn: SSBTest with: #testDoNothing.
	self assert: self tracer currentId = self tracer rootId.
	self assert: self rootNode notNil.
	self assert: self rootNode nextCalls isEmpty.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:44.899'!
testCreateRootNode

	self assert: self tracer currentId = -1.
	self tracer createRootNode: SSBTest withTest: #testDoNothing.
	self assert: self tracer currentId = self tracer rootId.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:38:04.328'!
testCreateWrapper

	| wrappers |
	wrappers := OrderedCollection new.
	[self tracer createWrapperOn: SSBClassA and: #doNothing addTo: wrappers.
	self assert: wrappers size = 1.
	self assert: wrappers first tracer == self tracer.
	self assert: wrappers first wrappedClass == SSBClassA.
	self assert: wrappers first clientSelector == #doNothing.] 
		ensure: [wrappers first uninstall].! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'tfel 3/6/2012 15:28:40.032'!
testCreateWrappers

	| wrappers |
	[wrappers := self tracer createWrappers.
	self assert: wrappers notEmpty.
	self assert: wrappers size > 1.
	wrappers do: [:each | 
		each wrappedClass isMeta
			ifFalse: [self assert: (each wrappedClass category beginsWith: 'Path-Tests-Sandbox')]]
	] ensure: [self tracer removeWrappers: wrappers].! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 17:39:31.299'!
testResetCallTree

	self tracer createNewCallTreeOn: SSBTest with: #testDoNothing.
	self tracer resetCallTree.
	self assert: self tracer currentId = -1.
	self assert: self rootNode isNil.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:55'!
testRootId

	self assert: self tracer rootId = 0.
	self deny: self tracer rootId = self tracer currentId.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:37:15.7'!
testRunTestWithoutInstrumentation

	self tracer createNewCallTreeOn: SSBTest with: #testDoNothing.
	self tracer runRootNode.
	self assert: self rootNode nextCalls isEmpty.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 13:23:06.612'!
testRunTestWithoutInstrumentationAndChosenTest

	self should: [self tracer runRootNode] raise: MessageNotUnderstood.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'tfel 3/6/2012 15:28:30.36'!
testSelectedCategories

	self assert: SProject current categories size = 1.
	self assert: (SProject current categories includes: #'Path-Tests-Sandbox').! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:34:48.403'!
testTestCaseIsAvailable

	self assert: (SProject current categories includes: SSBTest category)! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:40'!
testTracerInitialActiveState

	self deny: self tracer active.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:31:29.642'!
testTracerInitialCallTreeModel

	self assert: self tracer callTreeModel notNil.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:59.223'!
testTracerInitialCategories

	self assert: self tracer selectedCategories = SProject current categories.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:53'!
testTracerInitialCurrentId

	self assert: self tracer currentId = -1.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:40'!
testTracerInitialProfilingMode

	self assert: self tracer profilingMode = #normal.! !

!STracerInitializeTest methodsFor: 'testing' stamp: 'mp 3/5/2010 17:40'!
testTracerInitialViewMode

	self assert: self tracer viewMode = #classes.! !

STracerTest subclass: #STracerProfilingTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!STracerProfilingTraceTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:21:43.97'!
testGetCallWrapperClass

	self tracer profilingMode: #%.
	self assert: self tracer getCallWrapperClass == SProfilingWrapper.	
	self tracer profilingMode: #counts.
	self assert: self tracer getCallWrapperClass == SCallWrapper.
	self tracer profilingMode: #ms.
	self assert: self tracer getCallWrapperClass == SProfilingWrapper.	
	self tracer viewMode: #identities.
	self tracer profilingMode: #counts.
	self assert: self tracer getCallWrapperClass == SViewWrapper.		! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:32:58.949'!
testProfilingAndView

	| nodes |
	self tracer profilingMode: #%.
	self tracer viewMode: #objects.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callTreeGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles notEmpty.
	self assert: nodes first views notEmpty.
	self assert: (nodes first profiles at: #%) asInteger > 60.
	self assert: (nodes first views at: #classes) = SSBClassA.
	self assert: (nodes first views at: #objects) = '0'.
	self assert: nodes first asString = ('[', (nodes first profiles at: #%),']', 
								(nodes first views at: #objects), '>>delayedMethod').! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:01.241'!
testProfilingCounts

	| nodes |
	self tracer profilingMode: #counts.
	self tracer traceTest: SSBTest method: #testRecursion.
	nodes := self callTreeGetNodesFor: SSBClassA method: #recursionMethod:.
	nodes withIndexDo: [:each :index | 
		self assert: each profiles notEmpty.
		self assert: (each profiles at: #counts) asInteger = index.		
		self assert: (each asString beginsWith: '[', (each profiles at: #counts),']SSBClassA>>recursionMethod:')].
! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:03.311'!
testProfilingMilliSeconds

	| nodes |
	self tracer profilingMode: #ms.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callTreeGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles notEmpty.
	self assert: (nodes first profiles at: #ms) asInteger >= 95.
	self assert: nodes first asString = ('[', (nodes first profiles at: #ms),']SSBClassA>>delayedMethod').! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:05.1'!
testProfilingPercentage
	
	| nodes |
	self tracer profilingMode: #%.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callTreeGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles notEmpty.
	self assert: (nodes first profiles at: #%) asInteger > 60.
	self assert: nodes first asString = ('[', (nodes first profiles at: #%),']SSBClassA>>delayedMethod').! !

!STracerProfilingTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:06.948'!
testWithoutProfiling

	| nodes |
	self tracer profilingMode: #normal.
	self tracer traceTest: SSBTest method: #testDelay.
	nodes := self callTreeGetNodesFor: SSBClassA method: #delayedMethod.
	self assert: nodes first profiles isEmpty.
	self assert: nodes first asString = 'SSBClassA>>delayedMethod'.! !

STracerTest subclass: #STracerRefinementTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!STracerRefinementTraceTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:09.52'!
testCreateExploreWrapper

	| nodes wrapper |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	wrapper := self tracer createExploreWrapper: #selfBefore on: nodes first.
	self assert: wrapper notNil.
	self assert: wrapper objects isEmpty.
	self assert: wrapper wrappedClass == SSBClassA.
	self assert: wrapper clientSelector == #doNothing.
	self assert: wrapper numberOfCallsBefore = 0.
	self assert: wrapper exploreWhat == #selfBefore.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:11.848'!
testExploreArgumentsBinary

	| obj args |
	self tracer traceTest: SSBTest method: #testBinary.
	obj := self tracer 
				explore: #arguments 
				on: (self callTreeGetNodesFor: SSBClassA method: #+) first.
	args := obj first.
	self assert: args notEmpty.
	self assert: args size = 1.
	self assert: args first = 5.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:13.965'!
testExploreArgumentsMultiply

	| obj args |
	self tracer traceTest: SSBTest method: #testParamMethod.
	obj := self tracer 
				explore: #arguments 
				on: (self callTreeGetNodesFor: SSBClassA method: #param:method:) first.
	args := obj first.
	self assert: args notEmpty.
	self assert: args size = 2.
	self assert: args = #(1 2).! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:16.244'!
testExploreArgumentsUnary

	| args |
	self tracer traceTest: SSBTest method: #testUnary.
	args := self tracer 
				explore: #arguments 
				on: (self callTreeGetNodesFor: SSBClassA method: #unaryMethod) first.
	self assert: args first isEmpty.
	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:18.311'!
testExploreExplicitReturn

	| return |
	self tracer traceTest: SSBTest method: #testUnary.
	return := self tracer 
				explore: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #unaryMethod) first.
	self assert: return notEmpty.
	self assert: return first.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:21.053'!
testExploreOn

	| obj |
	self tracer traceTest: SSBTest method: #testDoNothing.
	 obj := self tracer explore: #selfBefore on: (self callTreeGetNodesFor: SSBClassA method: #doNothing) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first myValue = 0.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:34:17.696'!
testExploreRecursionMethodFirst

	| obj |
	self tracer traceTest: SSBTest method: #testRecursion.
	obj := self tracer 
				explore: #arguments 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) first.
	self assert: obj first first = 5.	
			
	obj := self tracer 
				explore: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) first.	
	self assert: obj first = 15.	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:34:20.348'!
testExploreRecursionMethodLast

	| obj |
	self tracer traceTest: SSBTest method: #testRecursion.
	obj := self tracer 
				explore: #arguments 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) last.
	self assert: obj first first = 0.	
			
	obj := self tracer 
				explore: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) last.	
	self assert: obj first = 0.	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:34:22.108'!
testExploreRecursionMethodMiddle

	| obj |
	self tracer traceTest: SSBTest method: #testRecursion.
	obj := self tracer 
				explore: #arguments 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) third.
	self assert: obj first first = 3.	
			
	obj := self tracer 
				explore: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) third.	
	self assert: obj first = 6.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:30.039'!
testExploreSelfAfter

	| obj |
	self tracer traceTest: SSBTest method: #testModelView.
	 obj := self tracer explore: #selfAfter on: (self callTreeGetNodesFor: SSBClassB method: #myValue:) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first class = SSBClassB.
	self assert: obj first myValue = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:32.944'!
testExploreSelfBefore

	| obj |
	self tracer traceTest: SSBTest method: #testModelView.
	 obj := self tracer explore: #selfBefore on: (self callTreeGetNodesFor: SSBClassB method: #myValue:) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first class = SSBClassB.
	self assert: obj first myValue = nil.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:34.838'!
testExploreSelfBeforeAndAfterDifference

	| before after node |
	self tracer traceTest: SSBTest method: #testModelView.
	node := (self callTreeGetNodesFor: SSBClassB method: #myValue:) first.
	before := (self tracer explore: #selfBefore on: node) first.
	after := (self tracer explore: #selfAfter on: node) first.
	self deny: before == after.
	self assert: before myValue isNil.
	self assert: after myValue = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:36.464'!
testExploreSelfReturn

	| obj |
	self tracer traceTest: SSBTest method: #testDoNothing.
	obj := self tracer explore: #return on: (self callTreeGetNodesFor: SSBClassA method: #doNothing) first.
	self assert: obj notEmpty.
	self assert: obj size = 1.
	self assert: obj first class == SSBClassA.
	self assert: obj first myValue = 0.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:37.881'!
testExploreTypes

	|  types |
	self tracer traceTest: SSBTest method: #testParamMethod.
	types := self tracer 
				explore: #types 
				on: (self callTreeGetNodesFor: SSBClassA method: #param:method:) first.
	self assert: types notEmpty.
	self assert: types size = 3.

	self assert: types first key == #arguments.
	self assert: types first value size = 2.
	self assert: types first value first = SmallInteger.
	self assert: types first value second = SmallInteger.

	self assert: types second key == #self.
	self assert: types second value == SSBClassA.

	self assert: types third key == #result.
	self assert: types third value == Array.	! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:43.895'!
testNumberOfCallsBeforeMethodChain

	| wrapper |
	self tracer traceTest: SSBTest method: #testMethodChain.
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #methodChain:) first.
	self assert: wrapper numberOfCallsBefore = 0.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #methodChain:) second.
	self assert: wrapper numberOfCallsBefore = 1.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #methodChain:) third.
	self assert: wrapper numberOfCallsBefore = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:51.448'!
testNumberOfCallsBeforeRecursion

	| wrapper |
	self tracer traceTest: SSBTest method: #testRecursion.
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) first.
	self assert: wrapper numberOfCallsBefore = 0.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) last.
	self assert: wrapper numberOfCallsBefore = 5.
	
	wrapper := self tracer 
				createExploreWrapper: #return 
				on: (self callTreeGetNodesFor: SSBClassA method: #recursionMethod:) third.
	self assert: wrapper numberOfCallsBefore = 2.! !

!STracerRefinementTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:54.657'!
testRunOwnExploreWrapper

	| nodes wrapper a |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	[wrapper := self tracer createExploreWrapper: #selfBefore on: nodes first.
	wrapper install.
	a := SSBClassA new myValue: 123.
	a doNothing.
	self assert: wrapper objects notEmpty.
	self assert: wrapper objects size = 1.
	self assert: wrapper objects first myValue = a myValue.
	self deny: wrapper objects first == a]
		ensure: [wrapper uninstall].! !

!STracerTest methodsFor: 'helper' stamp: 'mp 7/16/2013 17:04:45.464'!
callTreeGetNodesFor: aClass method: aMethodSelector
	| nodes |
	nodes := OrderedCollection new.
	self tracer callTreeModel traverseCallTree: self rootNode 
			with: [:aNode | 
				(aNode clientClass == aClass and: [aNode clientSelector == aMethodSelector])
					ifTrue: [nodes add: aNode]].
	^ nodes! !

!STracerTest methodsFor: 'helper' stamp: 'mp 7/16/2013 16:30:54.216'!
rootNode

	^ self tracer callTreeModel rootNode! !

!STracerTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:24:42.31'!
setUp

	oldCurrentProject := SProject current.
	SProject setCurrent: #sandbox.
	self tracer: (SCallTreeTracer on: SProject current).
	self tracer callTreeModel: (SCallTreeModel on: self tracer).! !

!STracerTest methodsFor: 'testing' stamp: 'mp 7/7/2010 16:53:51.492'!
tearDown

	SProject setCurrentProject: oldCurrentProject.! !

!STracerTest methodsFor: 'accessing' stamp: 'mp 3/5/2010 17:48'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!STracerTest methodsFor: 'accessing' stamp: 'mp 3/5/2010 17:48'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !

STracerTest subclass: #STracerViewTraceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!STracerViewTraceTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:56.35'!
testClassesView

	| nodes |
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	self assert: (nodes first views at: #classes) = SSBClassA.
	self assert: nodes first asString = 'SSBClassA>>doNothing'.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:21:48.899'!
testGetCallWrapperClass

	self tracer viewMode: #objects.
	self assert: self tracer getCallWrapperClass == SViewWrapper.
	self tracer viewMode: #classes.
	self assert: self tracer getCallWrapperClass == SCallWrapper.	
	self tracer viewMode: #identities.
	self assert: self tracer getCallWrapperClass == SViewWrapper.
	self tracer profilingMode: #%.
	self assert: self tracer getCallWrapperClass == SProfilingWrapper.	
	self tracer profilingMode: #counts.
	self assert: self tracer getCallWrapperClass == SViewWrapper.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:57.755'!
testIdentityView

	| nodes |
	self tracer viewMode: #identities.
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	self assert: (nodes first views at: #identities) asInteger > 0.
	self assert: (nodes first asString beginsWith: 'SSBClassA').
	self assert: (nodes first asString occurrencesOf: $() = 1.
	self assert: ((nodes first asString subStrings: '(') second subStrings: ')') first asInteger > 0.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/16/2013 16:33:59.73'!
testObjectsView

	| nodes |
	self tracer viewMode: #objects.
	self tracer traceTest: SSBTest method: #testDoNothing.
	nodes := self callTreeGetNodesFor: SSBClassA method: #doNothing.
	self assert: (nodes first views at: #objects) = '0'.
	self assert: nodes first asString = '0>>doNothing'.! !

!STracerViewTraceTest methodsFor: 'testing' stamp: 'mp 7/7/2010 17:39:22.658'!
testPrintString

	| a |
	a := SSBClassA new.
	self assert: a asString = '0'.
	a myValue: 123.
	self assert: a asString = '123'.
	self assert: SSBClassB new asString = 'a SSBClassB'.! !

TestCase subclass: #SWrapperTest
	instanceVariableNames: 'myObject originalMethod methodRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SWrapperTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SWrapperTest subclass: #SAroundWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SAroundWrapperTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SAroundWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:45:09.713'!
tearDown

	SAroundWrapperMethodOne nuke.
	SAroundWrapperMethodTwo nuke.
	super tearDown.! !

!SAroundWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:45:13.183'!
testAround

	| wrapper |
	wrapper := SAroundWrapperMethodOne on: #methodOne inClass: SClassA.
	self assert: self myObject methodOne.
	wrapper install.
	self deny: self myObject methodOne.
	wrapper uninstall.
	self assert: self myObject methodOne.
	
	! !

!SAroundWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:59.159'!
testProceed

	| wrapper1 wrapper2 |
	wrapper1 := SAroundWrapperMethodTwo on: #methodTwo: inClass: SClassA.
	wrapper2 := SAroundWrapperMethodTwo on: #methodTwo: inClass: SClassA.	
	self assert: (self myObject methodTwo: 1) = 1.
	wrapper1 install.
	self assert: (self myObject methodTwo: 1) = 3.
	wrapper1 uninstall.
	self assert: (self myObject methodTwo: 1) = 1.
	wrapper2 install.
	self assert: (self myObject methodTwo: 1) = 3.
	wrapper2 uninstall.! !

SWrapperTest subclass: #SBeforeWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SBeforeWrapperTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SBeforeWrapperTest methodsFor: 'private' stamp: 'mp 7/16/2013 13:15:33.988'!
checkTouches:  aWrapperAssociationCollection

	aWrapperAssociationCollection do: [:each | 
		self assert: each key touched = each value].
	! !

!SBeforeWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:44:16.005'!
tearDown

	SBeforeWrapper nuke.
	super tearDown.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:12.745'!
testAccessCompiledMethod

	| wrappers |
	wrappers := OrderedCollection new.
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers first install.
	wrappers  second install.
	wrappers third install.
	self checkWrapperChain: #(Wrapper Wrapper Wrapper Original) of: self methodRef.
	self assert: wrappers third unwrappedMethod = originalMethod.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:22.331'!
testInstallationMultipleWrappers

	| wrappers |
	wrappers := OrderedCollection new.
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	self checkWrapperChain: #(Original) of: self methodRef.
	wrappers first install.
	self checkWrapperChain: #(Wrapper Original) of: self methodRef.
	wrappers  second install.
	self checkWrapperChain: #(Wrapper Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers second.
	wrappers third install.
	self checkWrapperChain: #(Wrapper Wrapper Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers third.
	self assert: self methodRef compiledMethod clientMethod == wrappers second.
	self assert: self methodRef compiledMethod clientMethod clientMethod  == wrappers first.
	wrappers first uninstall.
	self checkWrapperChain: #(Wrapper Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers third.
	self assert: self methodRef compiledMethod clientMethod  == wrappers second.
	wrappers third uninstall.
	self checkWrapperChain: #( Wrapper Original) of: self methodRef.
	self assert: self methodRef compiledMethod == wrappers second.
	wrappers second uninstall.
	self checkWrapperChain: #( Original) of: self methodRef.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:27.061'!
testInstallationOneWrapper

	| wrapper |
	wrapper := SBeforeWrapper on: #methodOne inClass: SClassA.
	self deny: self methodRef compiledMethod isMwMethodWrapper.
	wrapper install.
	self assert: self methodRef compiledMethod isMwMethodWrapper.
	wrapper uninstall.
	self deny: self methodRef compiledMethod isMwMethodWrapper.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/16/2013 13:15:49.593'!
testOneWrapper

	| wrapper |
	wrapper := SBeforeWrapper on: #methodOne inClass: SClassA.
	self assert: self myObject methodOne.
	self checkTouches: {wrapper -> 0}. 
	wrapper install.
	self checkTouches: {wrapper -> 0}. 
	self assert: self myObject methodOne.
	self checkTouches: {wrapper -> 1}. 
	wrapper uninstall.
	self assert: ((MethodReference class: SClassA selector: #methodOne) compiledMethod isKindOf: CompiledMethod).
	self checkTouches: {wrapper -> 1}. 
	self assert: self myObject methodOne.
	self checkTouches: {wrapper -> 1}.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/16/2013 13:15:55.901'!
testTwoWrappers

	| wrapper1 wrapper2 |
	wrapper1 := SBeforeWrapper on: #methodOne inClass: SClassA.
	wrapper2 := SBeforeWrapper on: #methodOne inClass: SClassA.
	self checkTouches: {wrapper1 -> 0. wrapper2 -> 0}. 
	self assert: self myObject methodOne.
	self checkTouches: {wrapper1 -> 0. wrapper2 -> 0}. 	
	wrapper1 install.
	self assert: self myObject methodOne.
	self checkTouches: {wrapper1 -> 1. wrapper2 -> 0}. 
	wrapper2 install.
	self assert: self myObject methodOne.
	self checkTouches: {wrapper1 -> 2. wrapper2 -> 1}. 	
	wrapper2 uninstall.
	self assert: self methodRef compiledMethod isMwMethodWrapper.
	self assert: self myObject methodOne.
	self checkTouches: {wrapper1 -> 3. wrapper2 -> 1}. 
	wrapper1 uninstall.
	self deny:  self methodRef compiledMethod isMwMethodWrapper.
	self assert: self myObject methodOne.
	self checkTouches: {wrapper1 -> 3. wrapper2 -> 1}. 	! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 1/22/2010 17:02'!
testWithoutWrapper

	self assert: self myObject methodOne.! !

!SBeforeWrapperTest methodsFor: 'tests' stamp: 'mp 7/7/2010 17:44:30.095'!
testWrappingWrapper

	| wrappers |
	wrappers := OrderedCollection new.
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers add: (SBeforeWrapper on: #methodOne inClass: SClassA).
	wrappers first install.
	wrappers  second install.
	wrappers third install.
	self checkWrapperChain: #(Wrapper Wrapper Wrapper Original) of: self methodRef.
	self assert: wrappers third wrappingWrapper = nil.
	self assert: wrappers second wrappingWrapper = wrappers third.
	self assert: wrappers first wrappingWrapper = wrappers second.
	wrappers second uninstall.
	self assert: wrappers second wrappingWrapper = nil.
	self assert: wrappers first wrappingWrapper = wrappers third.! !

!SWrapperTest methodsFor: 'private' stamp: 'mp 3/5/2010 12:57'!
checkWrapperChain: anArray of: aMethodRef

	| item |
	item := aMethodRef compiledMethod.
	anArray do: [:each |
		each == #Wrapper
			ifTrue: [	self assert: item isMwMethodWrapper.
					item := item clientMethod].
		each == #Original
			ifTrue: [self deny: item isMwMethodWrapper]].! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:54'!
methodRef
	"Answer the value of methodRef"

	^ methodRef! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:54'!
methodRef: anObject
	"Set the value of methodRef"

	methodRef := anObject! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:55'!
myObject
	"Answer the value of myObject"

	^ myObject! !

!SWrapperTest methodsFor: 'accessing' stamp: 'mp 1/22/2010 16:55'!
myObject: anObject
	"Set the value of myObject"

	myObject := anObject! !

!SWrapperTest methodsFor: '-- all --' stamp: 'mp 7/7/2010 17:43:07.462'!
setUp

	self myObject: SClassA new.
	originalMethod := (MethodReference class: SClassA selector: #methodOne) compiledMethod.
	self methodRef: (MethodReference class: SClassA selector: #methodOne).! !

!SWrapperTest methodsFor: '-- all --' stamp: 'mp 1/22/2010 16:56'!
tearDown

	self methodRef actualClass methodDictionary at: self methodRef methodSymbol put: originalMethod.! !

Spec subclass: #SPVMorphTest
	instanceVariableNames: 'klass testClass instance previousProject testProject associatedTestClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SPVMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SPVMorphTest subclass: #SClassDiagramTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SClassDiagramTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SClassDiagramTest methodsFor: 'transfer-event-helpers' stamp: 'tfel 4/28/2011 16:40:32.028'!
defaultTransferType

	^ #dragTransferPlus! !

!SClassDiagramTest methodsFor: 'drop-event-helpers' stamp: 'tfel 4/28/2011 16:46:39.646'!
dropEventFor: aMorph

	^ DropEvent new
		setPosition: instance position + (1 @ 1)
		contents: aMorph
		hand: ActiveHand;
		yourself! !

!SClassDiagramTest methodsFor: 'transfer-event-helpers' stamp: 'tfel 4/28/2011 16:40:41.757'!
omniBrowserTransferType

	^ #OmniBrowser! !

!SClassDiagramTest methodsFor: 'running' stamp: 'tfel 4/28/2011 16:01:39.696'!
setUp

	super setUp.
	instance := klass new
					openInWorld;
					bottomRight: 0@0; "Do not show the Morph. Making it really hidden
										will prevent things like DropEvents"
					yourself.
! !

!SClassDiagramTest methodsFor: 'testing' stamp: 'tfel 7/14/2011 15:03:04.021'!
testAcceptsClassDropsFromBrowser

	self mock: #confirm: of: UIManager default class toReturn: false during: [
		self assert: [ instance submorphs isEmpty ].
		(self transferEventFor: self class) sentTo: instance.
		self assert: [ instance submorphs size = 1 ].
		self assert: [ instance submorphs first class = SClassMorph ].
		self assert: [ instance submorphs first klass = self class ]].
! !

!SClassDiagramTest methodsFor: 'testing' stamp: 'tfel 7/14/2011 15:03:57.303'!
testAcceptsClassDropsFromOmniBrowser
	| OBClassNodeClass |
	OBClassNodeClass := Smalltalk at: #OBClassNode ifAbsent: [].
	OBClassNodeClass ifNil: [^ self assert: true].
	self mock: #confirm: of: UIManager default class toReturn: false during: [
		self assert: [instance submorphs isEmpty].
		(self 
			transferEventFor: (OBClassNodeClass on: self class) 
			withType: self omniBrowserTransferType) sentTo: instance.
		self assert: [instance submorphs size = 1].
		self assert: [instance submorphs first class = SClassMorph].
		self assert: [instance submorphs first klass = self class]].
! !

!SClassDiagramTest methodsFor: 'testing' stamp: 'tfel 7/14/2011 15:03:19.449'!
testFailsSilentlyForRandomlyDroppedMorphs

	self mock: #confirm: of: UIManager default class toReturn: false during: [
		self assert: [instance submorphs isEmpty].
		(self transferEventFor: (TransferMorph
									withPassenger: self class methodDict values first)) 
			sentTo: instance.
		self assert: [instance submorphs isEmpty].
		(self dropEventFor: (BorderedMorph new)) sentTo: instance.
		self assert: [instance submorphs isEmpty]].
! !

!SClassDiagramTest methodsFor: 'testing' stamp: 'mp 7/16/2013 13:17:20.994'!
testTransferredMorphHasDropPosition
	| dropEvent dropPosition |
	self mock: #confirm: of: UIManager default class toReturn: false during: [
		self assert: [ instance submorphs isEmpty ].
		dropPosition := 27@36.
		dropEvent := self transferEventFor: self class.
		dropEvent contents position: dropPosition.
		dropEvent sentTo: instance.
		self assert: [ instance submorphs size = 1 ].
		self assert: [ instance submorphs first class = SClassMorph ].
		self assert: [ instance submorphs first klass = self class ].
		self assert: [ instance submorphs first position = dropPosition]].! !

!SClassDiagramTest methodsFor: 'transfer-event-helpers' stamp: 'tfel 4/28/2011 16:47:10.507'!
transferEventFor: aPassenger

	^ self transferEventFor: aPassenger withType: self defaultTransferType! !

!SClassDiagramTest methodsFor: 'transfer-event-helpers' stamp: 'tfel 4/28/2011 16:47:16.837'!
transferEventFor: aPassenger withType: aTransferType

	^ self dropEventFor: ((TransferMorph withPassenger: aPassenger)
							dragTransferType: aTransferType;
							yourself)! !

SPVMorphTest subclass: #SClassMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SClassMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SClassMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/17/2011 15:46:25.872'!
expectedFailures

	^ #(testShouldAllowChangingTheSuperclass)! !

!SClassMorphTest methodsFor: 'running' stamp: 'tfel 4/30/2011 14:16:59.558'!
setUp

	super setUp.
	instance := klass on: testClass.! !

!SClassMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 4/30/2013 16:43:49.154'!
testOpenCloseAncestors
	"Test auto-opening of ancestors. (instance + ((connector + superclass) * auto ancestor depth))"
	| pasteUp arrowMorphs classMorphs superclasses oldPreference |
	oldPreference := SClassMorph autoAncestorDepth.
	SClassMorph autoAncestorDepth: 2.
	pasteUp := SClassDiagram new.
	pasteUp addMorph: instance.
	self assert: [pasteUp submorphs size = 1].
"	instance openAncestors.
	classMorphs := pasteUp submorphs select: [:m | m isKindOf: SClassMorph].
	arrowMorphs := pasteUp submorphs select: [:m | m isKindOf: SInheritanceConnector].
	self assert: [classMorphs size = (1 + SClassMorph autoAncestorDepth)].
	self assert: [arrowMorphs size = SClassMorph autoAncestorDepth].
	superclasses := (instance klass withAllSuperclasses copyFrom: 1 to: SClassMorph autoAncestorDepth + 1).
	classMorphs do: [:classMorph |
		self assert: [superclasses includes: classMorph klass].
		superclasses remove: classMorph klass].
	SClassMorph autoAncestorDepth: oldPreference.
"! !

!SClassMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 3/26/2013 11:49:53.606'!
testOpenDirectAssociations
	"Test auto-opening of associations"
"	| pasteUp arrowMorphs classMorphs submorphs classMorphClasses |
	pasteUp := SClassDiagram new.
	pasteUp addMorph: instance.
	self assert: [pasteUp submorphs size = 1].
	instance openAssociations.
	classMorphs := pasteUp submorphs select: [:m | m isKindOf: SClassMorph].
	arrowMorphs := pasteUp submorphs select: [:m | m isKindOf: SAssociationConnector].
	""The testClass has 2 instance variables, ivar1 and ivar2""
	self assert: [classMorphs size = 3].
	self assert: [arrowMorphs size = 2].
	classMorphClasses := classMorphs collect: [:classMorph | classMorph klass].
	{testClass . associatedTestClass . associatedTestClass superclass} do: [:class |
		self assert: (classMorphClasses includes: class)].
	((self allSubmorphsRecursiveFor: instance)
		detect: [:m | m isKindOf: SStateMorph]) collapseMorphs.
	submorphs := (self allSubmorphsRecursiveFor: pasteUp).
	self assert: [ self thereIsAStringMorphIn: submorphs with: 'ivar1'].
	self assert: [ self thereIsAStringMorphIn: submorphs with: 'ivar2'].
"! !

!SClassMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/13/2011 15:49:42.945'!
testShouldAllowChangingTheSuperclass
	| newSuperclassMorph oldSuperclass |
	newSuperclassMorph := klass on: Morph.
	oldSuperclass := testClass superclass.
	instance newSuperclassTarget: newSuperclassMorph.
	[self assert: [testClass superclass = Morph]]
		ensure: [klass superclass: oldSuperclass].! !

!SClassMorphTest methodsFor: 'as yet unclassified' stamp: 'ag 9/22/2011 14:19:04.636'!
testShouldReturnItselfAsClassMorph

	self assert: [instance classMorph = instance].! !

SPVMorphTest subclass: #SEntryMorphTest
	instanceVariableNames: 'classMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SEntryMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SEntryMorphTest subclass: #SClassNameMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SClassNameMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SClassNameMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 6/9/2011 14:05:12.048'!
testShouldAllowOpeningABrowserOnDoubleClick
	<ignoreForTypeHarvesting>
	self mock: #browse of: Class toReturn: [:v | v] during: [
		self
			assert: [instance doubleClick: MorphicUnknownEvent new]
			sends: #browse
			to: Class].! !

!SClassNameMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 18:27:04.694'!
testShouldAllowRefreshingTheClass
	| set newName |
	set := self allSubmorphsRecursiveFor: instance.
	newName := self class testClassName, 'Renamed'.
	instance update.
	self assert: [ self thereIsAStringMorphIn: set with: self class testClassName ].
	testClass rename: newName.
	instance update.
	[self assert: [ self thereIsAStringMorphIn: set with: newName ]]
		ensure: [testClass rename: self class testClassName].! !

!SClassNameMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 18:27:39.005'!
testShouldAutomaticallyRefreshTheClass
	| set newName |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	newName := self class testClassName, 'Renamed'.
	self assert: [ self thereIsAStringMorphIn: set with: self class testClassName ].
	testClass rename: newName.
	[self assert: [ self thereIsAStringMorphIn: set with: newName ]]
		ensure: [testClass rename: self class testClassName].! !

!SClassNameMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 18:11:03.415'!
testShouldBeExpandedByDefault
	
	instance update.
	self assert: [instance entries allSatisfy: [:morph | morph owner = instance]].! !

!SClassNameMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 18:29:29.951'!
testShouldShowAClassName
	| set |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [ self thereIsAStringMorphIn: set with: self class testClassName ]! !

!SClassNameMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 18:29:20.685'!
testShouldShowASuperclass
	| set |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [ self thereIsAStringMorphIn: set with: testClass superclass name asString ]! !

!SEntryMorphTest class methodsFor: 'testing' stamp: 'tfel 5/13/2011 17:57:28.548'!
isAbstract

	^ self name = #SEntryMorphTest! !

!SEntryMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 2/14/2012 11:23:26.583'!
aboutToCreateClassMorphFor: aTestClass
	"Hook to run just before trying to creating a class morph"! !

!SEntryMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 5/5/2011 14:32:03.79'!
aboutToSearchInstanceIn: aClassMorph
	"Hook to run just before trying to detect the instance in a class morph"! !

!SEntryMorphTest methodsFor: 'morphic-test-helpers' stamp: 'mp 7/16/2013 13:17:37.547'!
detectInstanceIn: aClassMorph
	"Hook for those submorphs that need to do something special to find themselves in a SClassMorph"
	
	self subclassResponsibility.! !

!SEntryMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 5/24/2011 13:59:31.954'!
expandMorphsIn: aClassMorph

	aClassMorph allMorphsDo: [:s | (s respondsTo: #expandMorphs) ifTrue: [s expandMorphs]].! !

!SEntryMorphTest methodsFor: 'running' stamp: 'tfel 2/14/2012 11:22:26.5'!
setUp
	
	super setUp.
	self aboutToCreateClassMorphFor: testClass.
	classMorph := SClassMorph on: testClass.
	self aboutToSearchInstanceIn: classMorph.
	instance := classMorph allMorphs
		detect: [:m | m class = klass and: [m klass = testClass]]
		ifNone: [self detectInstanceIn: classMorph].! !

SEntryMorphTest subclass: #SExpandableEntryMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SExpandableEntryMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SExpandableEntryMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 2/14/2012 11:01:42.464'!
detectInstanceIn: aClassMorph

	^ aClassMorph allMorphs detect: [:m | m class = SStateMorph]! !

!SExpandableEntryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 2/14/2012 11:04:06.495'!
setUp

	super setUp.
	instance := SStateMorph on: testClass.
	instance type: #instance.! !

!SExpandableEntryMorphTest methodsFor: 'running' stamp: 'tfel 4/30/2011 18:08:46.752'!
tearDown

	instance abandon.
	super tearDown.! !

!SExpandableEntryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 18:12:32.598'!
testShouldAllowCollapsing

	instance update.
	instance expandMorphs.
	self assert: [instance entries allSatisfy: [:morph | morph owner = instance]].
	instance collapseMorphs.
	self assert: [instance entries allSatisfy: [:morph | morph owner isNil]].! !

!SExpandableEntryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 2/14/2012 11:04:02.45'!
testShouldAllowExpansion

	instance update.
	instance collapseMorphs.
	self assert: [instance entries allSatisfy: [:morph | morph owner isNil]].
	instance expandMorphs.
	self assert: [instance entries allSatisfy: [:morph | morph owner = instance]].! !

SEntryMorphTest subclass: #SInstVarMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SInstVarMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SInstVarMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 5/5/2011 14:35:13.2'!
aboutToSearchInstanceIn: aClassMorph

	self expandMorphsIn: aClassMorph.! !

!SInstVarMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 3/26/2013 11:16:38.865'!
expectedFailures

	^ #(testShouldAnswerAnAssociationIfTheClassIsADictionary)! !

!SInstVarMorphTest methodsFor: 'get class tests' stamp: 'mp 5/8/2013 11:39:06.8'!
testShouldAnswerAnAssociationIfTheClassIsADictionary

	(testProject typesBucket membersFor: testClass) 
		atAllPut: (SContainerType new
					typeOfContainer: Dictionary new;
					typeOfElements: testClass;
					typeOfKeys: Symbol;
					yourself).
	[self assert: (instance getClass = (Symbol -> testClass))]
		ensure: [(testProject typesBucket membersFor: testClass) 
					atAllPut: testClass].! !

!SInstVarMorphTest methodsFor: 'get class tests' stamp: 'tfel 2/14/2012 11:15:33.437'!
testShouldAnswerTheClassIfItKnowsIt

	self assert: [instance getClass = associatedTestClass].! !

!SInstVarMorphTest methodsFor: 'get class tests' stamp: 'mp 5/8/2013 11:39:15.884'!
testShouldAnswerTheCollectionIfTheClassIsACollection

	(testProject typesBucket membersFor: testClass) 
		atAllPut: (SContainerType new
					typeOfContainer: OrderedCollection new;
					typeOfElements: testClass;
					yourself).
	[self assert: [instance getClass typeOfElements = testClass].
	self assert: [instance getClass typeOfContainer isKindOf: OrderedCollection]]
		ensure: [(testProject typesBucket membersFor: testClass) atAllPut: testClass]! !

!SInstVarMorphTest methodsFor: 'get class tests' stamp: 'mp 5/8/2013 11:39:21.493'!
testShouldAskForAClassIfItIsUnknown
	<ignoreForTypeHarvesting>
	self
		mock: #prompt:labels:values:
		of: SMultipleChoiceRequest class
		toReturn: (Smalltalk at: #SPVTestClass) during: [
		self assert: [
			(testProject typesBucket membersFor: testClass) atAllPut: nil.
			[self assert: [instance getClass = testClass]]
				ensure: [(testProject typesBucket membersFor: testClass) atAllPut: testClass]]
			sends: #prompt:labels:values: to: SMultipleChoiceRequest class]! !

!SInstVarMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 7/16/2013 13:18:33.208'!
testShouldBeConvertibleToAnAssociationArrow
	| associationArrow |
	self mock: #openInHand of: Morph toReturn: [:i | i] during: [
	self 
		mock: #setCorrectOwnerForConnections: 
		of: SAssociationConnector 
		toReturn: [:receiver | associationArrow := receiver]
		during: [
			instance openTypeMorph.
			self assert: [associationArrow isKindOf: SAssociationConnector]]].! !

!SInstVarMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 7/16/2013 13:18:42.581'!
testShouldBeConvertibleToAnAssociationArrowThatHasTheCorrectOwner
	| associationArrow |
	self mock: #openInHand of: Morph toReturn: [:i | i] during: [
	self 
		mock: #setCorrectOwnerForConnections: 
		of: SAssociationConnector 
		toReturn: [:receiver | associationArrow := receiver]
		during: [
			instance openTypeMorph.
			self assert: [associationArrow owner = classMorph owner]]].! !

!SInstVarMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 3/26/2013 11:06:50.845'!
testShouldNotBecomePinnedIfDragged

	self mock: #openInHand of: Morph toReturn: [:i | i] during: [
	self mock: #setCorrectOwnerForConnections: of: SAssociationConnector toReturn: [SAssociationConnector basicNew] during: [
		instance startDrag: InputSensor default.
		self deny: instance isPinned]].! !

!SInstVarMorphTest methodsFor: 'as yet unclassified' stamp: 'mp 3/26/2013 11:05:59.986'!
testShouldStayVisibleIfDragged

	self mock: #openInHand of: Morph toReturn: [:i | i] during: [
	self mock: #setCorrectOwnerForConnections: of: SAssociationConnector toReturn: [SAssociationConnector basicNew] during: [
		instance startDrag: InputSensor default.
		self assert: [instance wantsToBeShown]]].! !

SEntryMorphTest subclass: #SStateMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SStateMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SStateMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/17/2011 15:47:58.188'!
testShouldAutomaticallyChangeItsNumberOnClassChange
	| set |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [self thereIsAStringMorphIn: set with: '2'].
	testClass addInstVarName: 'testIvar'.
	[self assert: [self 
			thereIsAStringMorphIn: set 
			with: '3']]
	ensure: [testClass removeInstVarName: 'testIvar'].! !

!SStateMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/17/2011 15:48:19.569'!
testShouldChangeItsNumberOnClassChange
	| set |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [self thereIsAStringMorphIn: set with: '2'].
	testClass addInstVarName: 'testIvar'.
	instance update.
	[self assert: [self 
			thereIsAStringMorphIn: set 
			with: '3']]
	ensure: [testClass removeInstVarName: 'testIvar'].! !

!SStateMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 2/14/2012 11:16:06.637'!
testShouldDisplayPinnedInstVarsAfterCollapse
	
	instance update.
	instance expandMorphs.
	(instance entries at: 1) togglePin.
	self assert: instance entries first isPinned.
	
	instance toggleExpansion.
	self deny: [instance expanded].
	self assert: [(instance entries at: 1) owner notNil].
	self assert: [(instance entries at: 2) owner isNil].
! !

SEntryMorphTest subclass: #STestBehaviorMorphs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!STestBehaviorMorphs commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

STestBehaviorMorphs subclass: #SBehaviorMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SBehaviorMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SBehaviorMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/13/2011 15:35:22.869'!
setUp

	super setUp.
	instance := klass on: testClass.! !

!SBehaviorMorphTest methodsFor: 'testing' stamp: 'tfel 4/30/2011 18:28:12.399'!
testShouldAutomaticallyChangeItsNumberOnClassChange
	| set |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [self thereIsAStringMorphIn: set with: self class testClassMethods keys size].
	testClass removeSelector: self class testClassMethods keys first.
	[self assert: [self 
			thereIsAStringMorphIn: set 
			with: self class testClassMethods keys size - 1]]
	ensure: [testClass compile: self class testClassMethods values first].! !

!SBehaviorMorphTest methodsFor: 'testing' stamp: 'tfel 4/30/2011 18:25:43.031'!
testShouldChangeItsNumberOnRefresh
	| set |
	set := self allSubmorphsRecursiveFor: instance.
	instance update.
	self assert: [self thereIsAStringMorphIn: set with: self class testClassMethods keys size].
	testClass removeSelector: self class testClassMethods keys first.
	[instance update.
	self assert: [self 
			thereIsAStringMorphIn: set 
			with: self class testClassMethods keys size - 1]]
	ensure: [testClass compile: self class testClassMethods values first].! !

!SBehaviorMorphTest methodsFor: 'testing' stamp: 'tfel 4/30/2011 19:09:54.87'!
testShouldShowCategoriesOnExpand
	| set |
	instance update.
	instance expandMorphs.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [self thereIsAStringMorphIn: set with: self class testClassMethodsCategory ].
	instance collapseMorphs.! !

!SBehaviorMorphTest methodsFor: 'testing' stamp: 'tfel 4/30/2011 18:21:10.675'!
testShouldShowTheNumberOfMethods

	instance update.
	self assert: [ self 
		thereIsAStringMorphIn: (self allSubmorphsRecursiveFor: instance) 
		with: self class testClassMethods keys size asString ].! !

STestBehaviorMorphs subclass: #SMethodCategoryMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SMethodCategoryMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SMethodCategoryMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 5/24/2011 14:09:36.57'!
aboutToSearchInstanceIn: aClassMorph

	super aboutToSearchInstanceIn: aClassMorph.
	self expandMorphsIn: aClassMorph.! !

!SMethodCategoryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 14:46:14.386'!
expectedFailures

	^ #(testShouldUpdateTheCategoryAutomatically testShouldRemoveItselfIfCategoryIsRemoved)! !

!SMethodCategoryMorphTest methodsFor: 'running' stamp: 'tfel 5/5/2011 14:24:53.19'!
setUp

	super setUp.
	instance category: self class testClassMethodsCategory.! !

!SMethodCategoryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 19:18:34.279'!
testShouldAutomaticallyChangeItsNumberOnClassChange
	| set |
	instance update.
	set := self allSubmorphsRecursiveFor: instance.
	self assert: [self thereIsAStringMorphIn: set with: self class testClassMethods keys size].
	testClass removeSelector: self class testClassMethods keys first.
	[self assert: [self 
			thereIsAStringMorphIn: set 
			with: self class testClassMethods keys size - 1]]
	ensure: [testClass compile: self class testClassMethods values first].! !

!SMethodCategoryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 19:18:43.319'!
testShouldChangeItsNumberOnRefresh
	| set |
	set := self allSubmorphsRecursiveFor: instance.
	instance update.
	self assert: [self thereIsAStringMorphIn: set with: self class testClassMethods keys size].
	testClass removeSelector: self class testClassMethods keys first.
	[instance update.
	self assert: [self 
			thereIsAStringMorphIn: set 
			with: self class testClassMethods keys size - 1]]
	ensure: [testClass compile: self class testClassMethods values first].! !

!SMethodCategoryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/26/2011 14:35:50.999'!
testShouldRemoveItselfIfCategoryIsRemoved
	self assert: false.
	"instance update.
	self class testClassMethods keys do: [:s | testClass removeSelector: s].
	self mock: #doSilently: of: SystemChangeNotifier toReturn: [:recv :block | block value] during: [
		self
			assert: [testClass organization removeCategory: self class testClassMethodsCategory]
			sends: #delete
			to: instance class]."! !

!SMethodCategoryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/30/2011 19:12:47.556'!
testShouldShowTheCategory

	instance update.
	self assert: [self 
		thereIsAStringMorphIn: (self allSubmorphsRecursiveFor: instance)
		with: self class testClassMethodsCategory].! !

!SMethodCategoryMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/17/2011 16:18:02.705'!
testShouldUpdateTheCategoryAutomatically
	| set newCategory |
	instance update.
	set := (self allSubmorphsRecursiveFor: instance).
	newCategory := self class testClassMethodsCategory, 'Renamed'.
	self assert: [self thereIsAStringMorphIn: set with: self class testClassMethodsCategory].
	self mock: #doSilently: of: SystemChangeNotifier toReturn: [:recv :block | block value] during: [
		testClass organization 
			renameCategory: self class testClassMethodsCategory toBe: newCategory].
	[self assert: [self thereIsAStringMorphIn: set with: newCategory]]
		ensure: [testClass organization 
			renameCategory: newCategory toBe: self class testClassMethodsCategory].! !

STestBehaviorMorphs subclass: #SMethodMorphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-PathView'!

!SMethodMorphTest commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SMethodMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 5/17/2011 15:54:14.461'!
expectedFailures

	^ #(testShouldChangeItsContentsOnRefresh)! !

!SMethodMorphTest methodsFor: 'as yet unclassified' stamp: 'tfel 4/26/2011 16:33:33.875'!
testShouldChangeItsContentsOnRefresh

	self assert: false description: 'The class canvas should accept drops from the browser'.! !

!STestBehaviorMorphs class methodsFor: 'testing' stamp: 'tfel 4/30/2011 19:04:09.148'!
isAbstract

	^ self name = #STestBehaviorMorphs! !

!STestBehaviorMorphs class methodsFor: 'test configuration' stamp: 'tfel 4/30/2011 19:04:23.027'!
testClassMethods

	^ Dictionary newFromPairs: {
		#testMethod . 'testMethod' .
		#testMethod2 . 'testMethod2'}! !

!STestBehaviorMorphs class methodsFor: 'test configuration' stamp: 'tfel 4/30/2011 19:07:11.165'!
testClassMethodsCategory

	^ 'test methods'! !

!STestBehaviorMorphs methodsFor: 'running' stamp: 'mp 7/16/2013 13:19:13.977'!
aboutToCreateClassMorphFor: aTestClass
	"We have to add methods now, otherwise the container won't be visible and expanding will not find it"
	self class testClassMethods keysAndValuesDo: [:methodName :methodSource |
		aTestClass compile: methodSource classified: self class testClassMethodsCategory ].! !

!SPVMorphTest class methodsFor: 'test configuration' stamp: 'tfel 4/30/2011 14:16:31.51'!
classVariableNames

	^ ''! !

!SPVMorphTest class methodsFor: 'test configuration' stamp: 'tfel 5/13/2011 18:02:00.322'!
instanceVariableNames

	^ 'ivar1 ivar2'! !

!SPVMorphTest class methodsFor: 'testing' stamp: 'tfel 4/30/2011 19:03:54.18'!
isAbstract

	^ self name = #SPVMorphTest! !

!SPVMorphTest class methodsFor: 'test configuration' stamp: 'tfel 3/6/2012 14:04:40.617'!
sandboxCategory

	^ 'Path-Tests-PathView-Sandbox'! !

!SPVMorphTest class methodsFor: 'test configuration' stamp: 'tfel 4/30/2011 14:16:15.87'!
testClassName

	^ #SPVTestClass! !

!SPVMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 4/30/2011 14:10:29.556'!
allSubmorphsRecursiveFor: aMorph
	| set flag |
	set := IdentitySet withAll: aMorph submorphs.
	flag := true.
	[ flag ]
		whileTrue: [ 
			(set select: [ :morph | morph hasSubmorphs and: [ (morph submorphs difference: set) notEmpty ] ])
				ifEmpty: [ flag := false ]
				ifNotEmptyDo: [ :nextMorphs | nextMorphs do: [ :morph | set addAll: morph submorphs ] ]	"No more submorphs to any of the morphs we have by now" ].
	^ set! !

!SPVMorphTest methodsFor: 'accessing' stamp: 'tfel 4/30/2011 18:56:39.718'!
defaultTimeout

	^ 240! !

!SPVMorphTest methodsFor: 'running' stamp: 'tfel 2/14/2012 10:47:48.448'!
setUp

	klass := (Smalltalk at: (self class name copyReplaceAll: 'Test' with: '') asSymbol).
	self
		setUpTestClass;
		setUpAssociatedTestClass;
		setUpSProject.! !

!SPVMorphTest methodsFor: 'running' stamp: 'tfel 3/6/2012 14:04:49.897'!
setUpAssociatedTestClass
	"Set up a class for associations - it and its superclasses will be the associations"
	associatedTestClass := ClassBuilder new
		superclass: Array
		subclass: (self class testClassName, 'Associated') asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self class sandboxCategory! !

!SPVMorphTest methodsFor: 'running' stamp: 'mp 7/16/2013 17:29:37.204'!
setUpSProject

	| bucket members |
	previousProject := SProject current.
	testProject := SProject name: #SPVMorphTestProject categories: #().
	SProject 
		addProject: testProject;
		setCurrent: testProject projectName.
	bucket := SMonoTypeBucket new.
	members := bucket membersFor: testClass.
	"Put superclasses for associatedTestClass in all inst vars"
	members inject: associatedTestClass into: [:class :next |
		members at: (members indexOf: next) put: class.
		class superclass].
	testProject typesBucket: bucket.! !

!SPVMorphTest methodsFor: 'running' stamp: 'tfel 3/6/2012 14:04:19.236'!
setUpTestClass

	testClass := ClassBuilder new
		superclass: Object
		subclass: self class testClassName asSymbol
		instanceVariableNames: self class instanceVariableNames
		classVariableNames: self class classVariableNames
		poolDictionaries: ''
		category: self class sandboxCategory.! !

!SPVMorphTest methodsFor: 'running' stamp: 'tfel 2/14/2012 10:44:32.968'!
tearDown

	instance abandon.
	self tearDownSProject.
	testClass removeFromSystem.
	associatedTestClass removeFromSystem.! !

!SPVMorphTest methodsFor: 'running' stamp: 'tfel 5/5/2011 15:16:11.567'!
tearDownSProject

	SProject setCurrent: previousProject projectName.
	SProject removeProjectAt: testProject projectName asSymbol.! !

!SPVMorphTest methodsFor: 'morphic-test-helpers' stamp: 'tfel 7/12/2011 14:38:04.68'!
thereIsAStringMorphIn: aCollection with: aString
	| matchString |
	matchString :=  '*' , aString, '*'.
	^ aCollection anySatisfy: [ :morph | 
		(morph isStringMorph
			and: [matchString match: morph contents])
		or: [morph class = NCGrabbableDisplayTextMorph
			and: [matchString match: morph text asString]]]
! !

IdentityDictionary subclass: #SSBDictionary
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBDictionary commentStamp: 'mp 11/15/2013 14:48:11.561' prior: 0!
A SSBDictionary is blub.

Instance Variables
	myValue:		<Object>

myValue
	- xxxxx

The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBDictionary class methodsFor: 'as yet unclassified' stamp: 'mp 1/5/2012 11:55:33.597'!
in: anObject

	^ self new
		myValue: anObject;
		yourself! !

!SSBDictionary methodsFor: 'accessing' stamp: 'mp 1/5/2012 11:55:12.52'!
myValue
	"Answer the value of myValue"

	^ myValue! !

!SSBDictionary methodsFor: 'accessing' stamp: 'mp 1/5/2012 11:55:12.535'!
myValue: anObject
	"Set the value of myValue"

	myValue := anObject! !

!SSBDictionary methodsFor: 'as yet unclassified' stamp: ''!
symbolFor: squeakSymbol

	^ self
		at: squeakSymbol 
		ifAbsentPut: [self myValue].! !

Object subclass: #SClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SClassA commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/5/2010 12:54'!
methodOne

	^ true! !

!SClassA methodsFor: 'as yet unclassified' stamp: 'mp 1/22/2010 17:09'!
methodTwo: aNumber

	^ aNumber! !

Object subclass: #SHClassA
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Sandbox'!

!SHClassA commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SHClassA class methodsFor: 'as yet unclassified' stamp: 'mp 5/12/2011 14:38:46.168'!
a: anObjectA b: anObjectB c: anObjectC

	^ self new
		a: anObjectA;
		b: anObjectB;
		c: anObjectC;
		yourself.! !

!SHClassA methodsFor: 'accessing' stamp: 'mp 5/26/2010 16:25'!
a
	^ a! !

!SHClassA methodsFor: 'accessing' stamp: 'mha 4/27/2010 23:12'!
a: x
	a := x! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/26/2010 17:16'!
addValueToA: aNumber

	^ a + aNumber! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/3/2011 10:09:49.679'!
assoc: anAssoc collection: aCollection dict: aDictionary number: aNumber
	| assoc coll dict num |
	assoc := anAssoc.
	coll := aCollection.
	dict := aDictionary.
	num := aNumber.
	self b: assoc.
	self b: coll.
	self b: dict.
	self b: num.
	^ {assoc. coll. dict. num}! !

!SHClassA methodsFor: 'accessing' stamp: 'mha 4/27/2010 23:12'!
b
	^ b! !

!SHClassA methodsFor: 'accessing' stamp: 'mha 4/27/2010 23:12'!
b: x
	b := x! !

!SHClassA methodsFor: 'accessing' stamp: 'mha 4/27/2010 23:12'!
c
	^ c! !

!SHClassA methodsFor: 'accessing' stamp: 'mha 4/27/2010 23:12'!
c: x
	c := x! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/26/2010 16:18'!
collectCollection: aCollection
	"Enforce a closure, and force the closure to access external state."
	
	^ aCollection collect: [ :each | | oink gunk | aCollection includes: each ]! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/26/2010 17:54'!
concatTwoStrings: aBlock

	^ aBlock value: 'Hello' value: 'world'! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/27/2010 16:54'!
evalBlock: aBlock with: anObject

	aBlock value: anObject.
	^ #ShouldNotBeReached! !

!SHClassA methodsFor: 'initialize-release' stamp: 'mp 5/26/2010 16:48'!
initialize

	self a: 1.! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/26/2010 16:18'!
locals: val which: i
	| local mocal nocal r |
	i = 1 ifTrue: [ local := val. r := local ].
	i = 2 ifTrue: [ mocal := val. r := mocal ].
	i = 3 ifTrue: [ nocal := val. r := nocal ].
	^ r! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/26/2010 16:18'!
numbers: n
	^ n! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/27/2010 16:53'!
returnBlock: anObject

	self evalBlock: [:each | ^ each] with: anObject! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/27/2010 17:26'!
returnTrue

	self. "Do nothing --- prevent quick return accessor"
	^ true! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/2/2013 13:51:01.669'!
sayHelloTo: aString
	| obj |
	obj := SHClassB new.
	^ obj addExclamationMarkTo: (obj getHello, Character space, aString)! !

!SHClassA methodsFor: 'methods' stamp: 'mp 5/26/2010 16:18'!
strings: s magnitudes: m andObjects: o index: i
	^ { s. m. o } at: i! !

Object subclass: #SHClassB
	instanceVariableNames: 'mark'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Sandbox'!

!SHClassB commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SHClassB methodsFor: 'methods' stamp: 'mp 5/26/2010 17:40'!
addExclamationMarkTo: aString
	^ aString, mark! !

!SHClassB methodsFor: 'methods' stamp: 'mp 5/26/2010 17:37'!
getHello

	^ 'Hello'! !

!SHClassB methodsFor: 'initialize-release' stamp: 'mp 5/26/2010 17:40'!
initialize

	self mark: '!!'.! !

!SHClassB methodsFor: 'accessing' stamp: 'mp 5/26/2010 17:39'!
mark
	"Answer the value of mark"

	^ mark! !

!SHClassB methodsFor: 'accessing' stamp: 'mp 5/26/2010 17:39'!
mark: anObject
	"Set the value of mark"

	mark := anObject! !

SHClassB subclass: #SHClassSubB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Sandbox'!

!SHClassSubB commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SHClassB subclass: #SHClassSubB2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Harvester-Sandbox'!

!SHClassSubB2 commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SHClassSubB2 methodsFor: 'as yet unclassified' stamp: 'mp 5/12/2011 14:57:58.156'!
initialize

	super initialize.
	self mark: '?'.
	1 = 3
		ifTrue: [self mark: 3 + 4.
				self mark: 5 + 6]! !

Object subclass: #SPartialTraceObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Tracer'!

!SPartialTraceObject commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPartialTraceObject methodsFor: 'private' stamp: 'mp 3/8/2010 16:32'!
doSomething

	^ true! !

Object subclass: #SProjectEventRecorder
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Projects'!

!SProjectEventRecorder commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectEventRecorder methodsFor: 'accessing' stamp: 'mp 3/25/2013 16:27:01.795'!
events
	^ events ifNil: [events := OrderedCollection new]! !

!SProjectEventRecorder methodsFor: 'updating' stamp: 'mp 3/25/2013 16:27:12.334'!
update: anEvent
	self events add: anEvent.! !

Object subclass: #SSBClassA
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBClassA commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBClassA methodsFor: 'computation' stamp: 'mp 3/8/2010 14:13'!
+ aValue

	^ self myValue + aValue! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 5/8/2012 12:34:04.516'!
complexMethod: anObject
	"blub"
	| b |
	self myValue: anObject.
	self unaryMethod 
		ifTrue: [
			b := SSBClassB on: self.
			^ b compute]
		ifFalse: [self error: 'Should not happen.'].! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:52'!
delayedMethod

	self unaryMethod
		ifTrue: [(Delay forMilliseconds: 100) wait].
	^ true! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:36'!
doNothing! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 13:57:23.076'!
failingMethod: aBoolean
	self unaryMethod.
	^ aBoolean
		ifTrue: [aBoolean]
		ifFalse: [aBoolean not]! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 5/28/2013 17:09:20.782'!
initialize
	self myValue: 0.! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 11/8/2010 16:56:15.457'!
manyParameters: a b: c d: e f: g long: tooLongForDisplayingAtOnce! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:48'!
methodChain: anInteger

	^ anInteger! !

!SSBClassA methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:12'!
myValue
	"Answer the value of myValue"

	^ myValue! !

!SSBClassA methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:26'!
myValue: anObject
	"Set the value of myValue"

	myValue := anObject.
	self changed.! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 8/14/2013 15:34:05.787'!
param: anObject method: anotherObject
	anObject == 5 ifTrue: [^ 4].
	self myValue: (Array with: anObject with: anotherObject).
	^ self myValue! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:45'!
printString

	^ self myValue asString! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:33'!
recursionMethod: aNumber

	aNumber = 0
		ifTrue: [^ 0]
		ifFalse: [
			^ aNumber + (self recursionMethod: aNumber - 1)].! !

!SSBClassA methodsFor: 'as yet unclassified' stamp: 'mp 3/9/2010 18:11'!
unaryMethod

	^ true! !

SSBClassA subclass: #SSBClassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBClassC commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBClassC methodsFor: 'as yet unclassified' stamp: 'mp 11/5/2010 14:08:00.226'!
failingMethod: aBoolean
	^ super failingMethod: aBoolean not.! !

Object subclass: #SSBClassB
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBClassB commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBClassB class methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:23'!
on: anObject

	^ self new
		myValue: anObject! !

!SSBClassB methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:25'!
compute

	self myValue unaryMethod not
		ifFalse: [^ self myValue + self myValue myValue].
	^ 0! !

!SSBClassB methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:13'!
myValue
	"Answer the value of myValue"

	^ myValue! !

!SSBClassB methodsFor: 'accessing' stamp: 'mp 3/8/2010 14:13'!
myValue: anObject
	"Set the value of myValue"

	myValue := anObject! !

!SSBClassB methodsFor: 'as yet unclassified' stamp: 'mp 3/8/2010 14:27'!
update: anObject

	self myValue: anObject myValue.! !

Object subclass: #SSBClassD
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBClassD commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBClassD methodsFor: 'as yet unclassified' stamp: 'mp 5/14/2013 14:22:42.148'!
myValue
	1 + 1. "prevent quick method"
	^ myValue! !

!SSBClassD methodsFor: 'as yet unclassified' stamp: 'mp 2/6/2012 16:01:35.996'!
myValue2: anObject

	myValue := anObject.
	^ anObject! !

!SSBClassD methodsFor: 'as yet unclassified' stamp: 'mp 2/6/2012 16:03:16.594'!
myValue3: anObject

	myValue := anObject.
	^ anObject! !

!SSBClassD methodsFor: 'as yet unclassified' stamp: 'mp 2/6/2012 16:06:15.987'!
myValue4: anObject

	myValue := anObject.
	^ anObject! !

!SSBClassD methodsFor: 'as yet unclassified' stamp: 'mp 2/6/2012 15:51:13.002'!
myValue: anObject

	myValue := anObject.
	^ anObject! !

Object subclass: #SSBFaultLocalizationExample
	instanceVariableNames: 'mid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Sandbox'!

!SSBFaultLocalizationExample commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SSBFaultLocalizationExample methodsFor: 'accessing' stamp: 'mp 9/21/2011 14:34:38.815'!
mid
	"Answer the value of mid"

	^ mid! !

!SSBFaultLocalizationExample methodsFor: 'accessing' stamp: 'mp 9/21/2011 14:34:38.83'!
mid: anObject
	"Set the value of mid"

	mid := anObject! !

!SSBFaultLocalizationExample methodsFor: 'computation' stamp: 'mp 9/21/2011 14:35:32.022'!
midX: firstNumber Y: secondNumber Z: thirdNumber
	self mid: thirdNumber.
	secondNumber < thirdNumber
		ifTrue: [firstNumber < secondNumber
					ifTrue: [self mid: secondNumber]
					ifFalse: [firstNumber < thirdNumber
								ifTrue: [self mid: secondNumber]]]
		ifFalse: [firstNumber > secondNumber
					ifTrue: [self mid: secondNumber]
					ifFalse: [firstNumber > thirdNumber
								ifTrue: [self mid: firstNumber]]]! !

TestResource subclass: #SPathMapInductiveTestResource
	instanceVariableNames: 'pathMap oldRegistry oldCurrentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SPathMapInductiveTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SPathMapInductiveTestResource subclass: #SPathMapBrowserContractsTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SPathMapBrowserContractsTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapBrowserContractsTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:48:49.414'!
harvesterClass
	^ STypeHarvester! !

!SPathMapBrowserContractsTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:52:25.319'!
projectResourceClass
	^ SProjectObserverTestResource! !

!SPathMapBrowserContractsTestResource methodsFor: 'running' stamp: 'mp 4/29/2013 14:22:31.742'!
setUp
	super setUp.
	self pathMap model runAll.	
	self pathMap model pathMap selectedOptions addContracts.! !

!SPathMapBrowserContractsTestResource methodsFor: 'running' stamp: 'mp 4/29/2013 14:23:10.933'!
tearDown
	self pathMap model pathMap selectedOptions removeContracts.
	super tearDown.! !

SPathMapInductiveTestResource subclass: #SPathMapInductiveContractsTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SPathMapInductiveContractsTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapInductiveContractsTestResource methodsFor: 'accessing' stamp: 'mp 5/13/2013 10:40:40.225'!
harvesterClass
	^ STypeHarvester! !

!SPathMapInductiveContractsTestResource methodsFor: 'accessing' stamp: 'mp 5/13/2013 10:41:24.08'!
projectResourceClass
	^ SProjectSandboxTestResource! !

!SPathMapInductiveContractsTestResource methodsFor: 'running' stamp: 'mp 5/13/2013 10:43:46.113'!
setUp
	super setUp.
	self pathMap model runAll.	
	self pathMap model pathMap selectedOptions 
		setKindOfAnalysis: SValueRangeHarvester.
	self pathMap model runAll.! !

!SPathMapInductiveTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:48:08.211'!
harvesterClass
	self subclassResponsibility.! !

!SPathMapInductiveTestResource methodsFor: 'accessing' stamp: 'mp 3/28/2013 11:39:05.728'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPathMapInductiveTestResource methodsFor: 'accessing' stamp: 'mp 3/28/2013 11:39:05.744'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPathMapInductiveTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 11:15:50.828'!
projectResourceClass
	self subclassResponsibility.! !

!SPathMapInductiveTestResource methodsFor: 'running' stamp: 'mp 5/24/2013 15:33:33.291'!
setUp
	SPathMapInductiveTestResource allSubclasses 
		detect: [:each | each isInitialized]
		ifFound: [:each | STestResourceError signal.]
		ifNone: [].
	self projectResourceClass current.
	self pathMap: SPathMapTestRunner open.
	(self pathMap model getFlap: #inductive) switchExpandState.
	self pathMap model pathMap selectedAnalysis: #inductive.
	self pathMap model pathMap selectedOptions	setKindOfAnalysis: self harvesterClass.! !

!SPathMapInductiveTestResource methodsFor: 'running' stamp: 'mp 4/29/2013 14:23:01.843'!
tearDown
	self pathMap abandon.! !

SPathMapInductiveTestResource subclass: #SPathMapInductiveTypeHarvestingTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SPathMapInductiveTypeHarvestingTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapInductiveTypeHarvestingTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:48:15.171'!
harvesterClass
	^ STypeHarvester! !

!SPathMapInductiveTypeHarvestingTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:49:46.542'!
projectResourceClass
	^ SProjectHarvesterSandboxTestResource! !

SPathMapInductiveTestResource subclass: #SPathMapInductiveValueRangeHarvestingTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SPathMapInductiveValueRangeHarvestingTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapInductiveValueRangeHarvestingTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:48:31.911'!
harvesterClass
	^ SValueRangeHarvester! !

!SPathMapInductiveValueRangeHarvestingTestResource methodsFor: 'accessing' stamp: 'mp 5/2/2013 17:50:21.421'!
projectResourceClass
	^ SProjectSandboxTestResource! !

TestResource subclass: #SPathMapTestQualityTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SPathMapTestQualityTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SPathMapTestQualityTestResource methodsFor: 'running' stamp: 'mp 5/2/2013 17:52:31.006'!
setUp
	| pathMap |
	SProjectObserverTestResource current.
	pathMap := SPathMapTestRunner open.
	(pathMap model getFlap: #testQuality) switchExpandState.
	pathMap model pathMap selectedAnalysis: #testQuality.
	pathMap model runAll.
	pathMap abandon.! !

TestResource subclass: #SProjectTestResource
	instanceVariableNames: 'oldRegistry oldCurrentProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SProjectTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

SProjectTestResource subclass: #SProjectHarvesterSandboxTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SProjectHarvesterSandboxTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectHarvesterSandboxTestResource methodsFor: 'hooks' stamp: 'mp 4/29/2013 11:24:55.074'!
project
	
	^ SProject harvesterSandboxProject! !

!SProjectHarvesterSandboxTestResource methodsFor: 'hooks' stamp: 'mp 4/29/2013 11:25:27.194'!
projectSymbol
	
	^ #harvesterSandbox! !

SProjectTestResource subclass: #SProjectObserverTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SProjectObserverTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectObserverTestResource methodsFor: 'hooks' stamp: 'mp 5/2/2013 17:51:08.877'!
project
	
	^ SProject observerExampleProject! !

!SProjectObserverTestResource methodsFor: 'hooks' stamp: 'mp 5/2/2013 17:51:17.834'!
projectSymbol
	
	^ #observerExample! !

SProjectTestResource subclass: #SProjectSandboxTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-Resources'!

!SProjectSandboxTestResource commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SProjectSandboxTestResource methodsFor: 'hooks' stamp: 'mp 5/2/2013 17:35:14.673'!
project
	
	^ SProject sandboxProject! !

!SProjectSandboxTestResource methodsFor: 'hooks' stamp: 'mp 5/2/2013 17:35:20.309'!
projectSymbol
	
	^ #sandbox! !

!SProjectTestResource methodsFor: 'hooks' stamp: 'mp 5/2/2013 17:51:36.564'!
project

	self subclassResponsibility.! !

!SProjectTestResource methodsFor: 'hooks' stamp: 'mp 5/2/2013 17:51:31.38'!
projectSymbol

	self subclassResponsibility.! !

!SProjectTestResource methodsFor: 'running' stamp: 'mp 5/24/2013 15:30:48.666'!
setUp
	SProjectTestResource allSubclasses 
		detect: [:each | each isInitialized]
		ifFound: [:each | STestResourceError signal.]
		ifNone: [].
	oldRegistry := SProject projectRegistry.
	oldCurrentProject := SProject current.
	SProject reset.
	SProject addProject: self project.
	SProject setCurrent: self projectSymbol.! !

!SProjectTestResource methodsFor: 'running' stamp: 'mp 4/30/2013 17:57:09.918'!
tearDown
	SProject projectRegistry: oldRegistry.
	SProject setCurrentProject: oldCurrentProject.! !

MwMethodWrapper subclass: #SAroundWrapperMethodOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SAroundWrapperMethodOne commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SAroundWrapperMethodOne methodsFor: 'evaluating' stamp: 'mp 3/5/2010 12:48'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	self beforeMethod.
	^ [
		false
	] ensure: [self afterMethod]! !

MwMethodWrapper subclass: #SAroundWrapperMethodTwo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SAroundWrapperMethodTwo commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SAroundWrapperMethodTwo methodsFor: '-- all --' stamp: 'mp 3/5/2010 12:51'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."

	self beforeMethod.
	^ [
		(self clientMethod valueWithReceiver: anObject arguments: #(2)) + 1.
	] ensure: [self afterMethod]! !

MwMethodWrapper subclass: #SBeforeWrapper
	instanceVariableNames: 'touched'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Tests-MethodWrappers'!

!SBeforeWrapper commentStamp: '<historical>' prior: 0!
The Path Tools Framework is released under the MIT License (MIT).

Copyright (c) 2009 Michael Perscheid, Software Architecture Group, 
Hasso-Plattner-Institute, University of Potsdam.

Contact: michael.perscheid@gmail.com
Website: www.michaelperscheid.de

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!SBeforeWrapper methodsFor: 'evaluating' stamp: 'mp 2/22/2010 09:32'!
beforeMethod

	self touched: self touched + 1.! !

!SBeforeWrapper methodsFor: '-- all --' stamp: 'mp 1/22/2010 14:58'!
initialize

	self touched: 0.! !

!SBeforeWrapper methodsFor: 'accessing' stamp: 'mp 1/22/2010 14:41'!
touched
	"Answer the value of touched"

	^ touched! !

!SBeforeWrapper methodsFor: 'accessing' stamp: 'mp 1/22/2010 14:41'!
touched: anObject
	"Set the value of touched"

	touched := anObject! !
